/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/types","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/errorMessage","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","vs/code/electron-main/main"],x=function(j){for(var e=[],w=0,L=j.length;w<L;w++)e[w]=Z[j[w]];return e};define(Z[104],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=w}),define(Z[47],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(P){return(E,h,g)=>{let i=null,I=null;if(typeof g.value=="function"?(i="value",I=g.value):typeof g.get=="function"&&(i="get",I=g.get),!I)throw new Error("not supported");g[i]=P(I,h)}}e.createDecorator=w;function L(P,E,h){let g=null,i=null;if(typeof h.value=="function"?(g="value",i=h.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(g="get",i=h.get),!i)throw new Error("not supported");const I=`$memoize$${E}`;h[g]=function(...S){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,S)}),this[I]}}e.memoize=L;function D(P,E,h){return w((g,i)=>{const I=`$debounce$${i}`,S=`$debounce$result$${i}`;return function(...p){this[S]||(this[S]=h?h():void 0),clearTimeout(this[I]),E&&(this[S]=E(this[S],...p),p=[this[S]]),this[I]=setTimeout(()=>{g.apply(this,p),this[S]=h?h():void 0},P)}})}e.debounce=D;function M(P,E,h){return w((g,i)=>{const I=`$throttle$timer$${i}`,S=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,t=`$throttle$pending$${i}`;return function(...d){if(this[S]||(this[S]=h?h():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),E&&(this[S]=E(this[S],...d)),this[t])return;const y=this[p]+P;y<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[S]]),this[S]=h?h():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),g.apply(this,[this[S]]),this[S]=h?h():void 0},y-Date.now()))}})}e.throttle=M}),define(Z[16],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(a=>{a(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=w,e.errorHandler=new w;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function D(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function M(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function P(c){if(c instanceof Error){let{name:n,message:a}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:n,message:a,stack:s}}return c}e.transformErrorForSerialization=P;const E="Canceled";function h(c){return c instanceof Error&&c.name===E&&c.message===E}e.isPromiseCanceledError=h;class g extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=g;function i(){const c=new Error(E);return c.name=c.message,c}e.canceled=i;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=t;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class y extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=y;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function u(c){const n=c;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=u;function o(c,n=Object.create(null)){const a=new Error(c);return n.actions&&(a.actions=n.actions),a}e.createErrorWithActions=o}),define(Z[31],x([0,1,16]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,z=0){return W[W.length-(1+z)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function M(W,z,K=(O,q)=>O===q){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let O=0,q=W.length;O<q;O++)if(!K(W[O],z[O]))return!1;return!0}e.equals=M;function P(W,z,K){let O=0,q=W.length-1;for(;O<=q;){const C=(O+q)/2|0,$=K(W[C],z);if($<0)O=C+1;else if($>0)q=C-1;else return C}return-(O+1)}e.binarySearch=P;function E(W,z){let K=0,O=W.length;if(O===0)return 0;for(;K<O;){const q=Math.floor((K+O)/2);z(W[q])?O=q:K=q+1}return K}e.findFirstInSorted=E;function h(W,z,K){if(W=W|0,W>=z.length)throw new TypeError("invalid index");let O=z[Math.floor(z.length*Math.random())],q=[],C=[],$=[];for(let J of z){const Q=K(J,O);Q<0?q.push(J):Q>0?C.push(J):$.push(J)}return W<q.length?h(W,q,K):W<q.length+$.length?$[0]:h(W-(q.length+$.length),C,K)}e.quickSelect=h;function g(W,z){const K=[];let O;for(const q of W.slice(0).sort(z))!O||z(O[0],q)!==0?(O=[q],K.push(O)):O.push(q);return K}e.groupBy=g;function i(W,z,K){const O=[];function q(J,Q,ne){if(Q===0&&ne.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===J?(le.deleteCount+=Q,le.toInsert.push(...ne)):O.push({start:J,deleteCount:Q,toInsert:ne})}let C=0,$=0;for(;;){if(C===W.length){q(C,0,z.slice($));break}if($===z.length){q(C,W.length-C,[]);break}const J=W[C],Q=z[$],ne=K(J,Q);ne===0?(C+=1,$+=1):ne<0?(q(C,1,[]),C+=1):ne>0&&(q(C,0,[Q]),$+=1)}return O}e.sortedDiff=i;function I(W,z,K){const O=i(W,z,K),q=[],C=[];for(const $ of O)q.push(...W.slice($.start,$.start+$.deleteCount)),C.push(...$.toInsert);return{removed:q,added:C}}e.delta=I;function S(W,z,K){if(K===0)return[];const O=W.slice(0,K).sort(z);return t(W,z,O,K,W.length),O}e.top=S;function p(W,z,K,O,q){return K===0?Promise.resolve([]):new Promise((C,$)=>{(async()=>{const J=W.length,Q=W.slice(0,K).sort(z);for(let ne=K,le=Math.min(K+O,J);ne<J;ne=le,le=Math.min(le+O,J)){if(ne>K&&await new Promise(oe=>setTimeout(oe)),q&&q.isCancellationRequested)throw(0,w.canceled)();t(W,z,Q,ne,le)}return Q})().then(C,$)})}e.topAsync=p;function t(W,z,K,O,q){for(const C=K.length;O<q;O++){const $=W[O];if(z($,K[C-1])<0){K.pop();const J=E(K,Q=>z($,Q)<0);K.splice(J,0,$)}}}function d(W){return W.filter(z=>!!z)}e.coalesce=d;function y(W){let z=0;for(let K=0;K<W.length;K++)W[K]&&(W[z]=W[K],z+=1);W.length=z}e.coalesceInPlace=y;function v(W,z,K){W.splice(K,0,W.splice(z,1)[0])}e.move=v;function b(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=b;function u(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=u;function o(W,z=K=>K){const K=new Set;return W.filter(O=>{const q=z(O);return K.has(q)?!1:(K.add(q),!0)})}e.distinct=o;function c(W){const z=Object.create(null);return K=>{const O=W(K);return z[O]?!1:(z[O]=!0,!0)}}e.uniqueFilter=c;function n(W,z){const K=a(W,z);if(K!==-1)return W[K]}e.findLast=n;function a(W,z){for(let K=W.length-1;K>=0;K--){const O=W[K];if(z(O))return K}return-1}e.lastIndex=a;function s(W,z){return W.length>0?W[0]:z}e.firstOrDefault=s;function r(W,z,K=(O,q)=>O===q){let O=0;for(let q=0,C=Math.min(W.length,z.length);q<C&&K(W[q],z[q]);q++)O++;return O}e.commonPrefixLength=r;function l(W){return[].concat(...W)}e.flatten=l;function f(W,z){let K=typeof z=="number"?W:0;typeof z=="number"?K=W:(K=0,z=W);const O=[];if(K<=z)for(let q=K;q<z;q++)O.push(q);else for(let q=K;q>z;q--)O.push(q);return O}e.range=f;function m(W,z,K){return W.reduce((O,q)=>(O[z(q)]=K?K(q):q,O),Object.create(null))}e.index=m;function k(W,z){return W.push(z),()=>R(W,z)}e.insert=k;function R(W,z){const K=W.indexOf(z);if(K>-1)return W.splice(K,1),z}e.remove=R;function A(W,z,K){const O=W.slice(0,z),q=W.slice(z);return O.concat(K,q)}e.arrayInsert=A;function F(W,z){let K;if(typeof z=="number"){let O=z;K=()=>{const q=Math.sin(O++)*179426549;return q-Math.floor(q)}}else K=Math.random;for(let O=W.length-1;O>0;O-=1){const q=Math.floor(K()*(O+1)),C=W[O];W[O]=W[q],W[q]=C}}e.shuffle=F;function H(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.unshift(z))}e.pushToStart=H;function te(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.push(z))}e.pushToEnd=te;function se(W,z){return Array.isArray(W)?W.map(z):z(W)}e.mapArrayOrNot=se;function G(W){return Array.isArray(W)?W:[W]}e.asArray=G;function ee(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=ee;function T(W,z){for(const K of W){const O=z(K);if(O!==void 0)return O}}e.mapFind=T;function V(W,z,K){const O=B(W,z),q=W.length,C=K.length;W.length=q+C;for(let $=q-1;$>=O;$--)W[$+C]=W[$];for(let $=0;$<C;$++)W[$+O]=K[$]}e.insertInto=V;function N(W,z,K,O){const q=B(W,z),C=W.splice(q,K);return V(W,q,O),C}e.splice=N;function B(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}function U(W,z){let K=Number.MAX_SAFE_INTEGER,O=0;return W.forEach((q,C)=>{const $=z(q);$<K&&(K=$,O=C)}),O}e.minIndex=U;function _(W,z){let K=Number.MIN_SAFE_INTEGER,O=0;return W.forEach((q,C)=>{const $=z(q);$>K&&(K=$,O=C)}),O}e.maxIndex=_;class X{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let K=this.firstIdx;for(;K<this.items.length&&z(this.items[K]);)K++;const O=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,O}takeFromEndWhile(z){let K=this.lastIdx;for(;K>=0&&z(this.items[K]);)K--;const O=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,O}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=X}),define(Z[42],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(L){const D=this;let M=!1,P;return function(){return M||(M=!0,P=L.apply(D,arguments)),P}}e.once=w}),define(Z[68],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=D;const M=Object.freeze([]);function P(){return M}L.empty=P;function*E(c){yield c}L.single=E;function h(c){return c||M}L.from=h;function g(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=g;function i(c){return c[Symbol.iterator]().next().value}L.first=i;function I(c,n){for(const a of c)if(n(a))return!0;return!1}L.some=I;function S(c,n){for(const a of c)if(n(a))return a}L.find=S;function*p(c,n){for(const a of c)n(a)&&(yield a)}L.filter=p;function*t(c,n){let a=0;for(const s of c)yield n(s,a++)}L.map=t;function*d(...c){for(const n of c)for(const a of n)yield a}L.concat=d;function*y(c){for(const n of c)for(const a of n)yield a}L.concatNested=y;function v(c,n,a){let s=a;for(const r of c)s=n(s,r);return s}L.reduce=v;function*b(c,n,a=c.length){for(n<0&&(n+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);n<a;n++)yield c[n]}L.slice=b;function u(c,n=Number.POSITIVE_INFINITY){const a=[];if(n===0)return[a,c];const s=c[Symbol.iterator]();for(let r=0;r<n;r++){const l=s.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return s}}]}L.consume=u;function o(c,n,a=(s,r)=>s===r){const s=c[Symbol.iterator](),r=n[Symbol.iterator]();for(;;){const l=s.next(),f=r.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!a(l.value,f.value))return!1}}L.equals=o})(w=e.Iterable||(e.Iterable={}))}),define(Z[39],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function P(n,a=!1){let s=0,r=n.length,l="",f=0,m=16,k=0;function R(ee){let T=0,V=0;for(;T<ee;){const N=n.charCodeAt(s);if(N>=48&&N<=57)V=V*16+N-48;else if(N>=65&&N<=70)V=V*16+N-65+10;else if(N>=97&&N<=102)V=V*16+N-97+10;else break;s++,T++}return T<ee&&(V=-1),V}function A(ee){s=ee,l="",f=0,m=16,k=0}function F(){const ee=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return k=3,n.substring(ee,s);let T=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;T=s}else k=3;return n.substring(ee,T)}function H(){let ee="",T=s;for(;;){if(s>=r){ee+=n.substring(T,s),k=2;break}const V=n.charCodeAt(s);if(V===34){ee+=n.substring(T,s),s++;break}if(V===92){if(ee+=n.substring(T,s),s++,s>=r){k=2;break}switch(n.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):k=4;break;default:k=5}T=s;continue}if(V>=0&&V<=31)if(h(V)){ee+=n.substring(T,s),k=2;break}else k=6;s++}return ee}function te(){if(l="",k=0,f=s,s>=r)return f=r,m=17;let ee=n.charCodeAt(s);if(E(ee)){do s++,l+=String.fromCharCode(ee),ee=n.charCodeAt(s);while(E(ee));return m=15}if(h(ee))return s++,l+=String.fromCharCode(ee),ee===13&&n.charCodeAt(s)===10&&(s++,l+=`
`),m=14;switch(ee){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,l=H(),m=10;case 47:const T=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<r&&!h(n.charCodeAt(s));)s++;return l=n.substring(T,s),m=12}if(n.charCodeAt(s+1)===42){s+=2;const V=r-1;let N=!1;for(;s<V;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,N=!0;break}s++}return N||(s++,k=1),l=n.substring(T,s),m=13}return l+=String.fromCharCode(ee),s++,m=16;case 45:if(l+=String.fromCharCode(ee),s++,s===r||!g(n.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),m=11;default:for(;s<r&&se(ee);)s++,ee=n.charCodeAt(s);if(f!==s){switch(l=n.substring(f,s),l){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return l+=String.fromCharCode(ee),s++,m=16}}function se(ee){if(E(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let ee;do ee=te();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>s,scan:a?G:te,getToken:()=>m,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=P;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function h(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,a){const s=[],r=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function k(R,A,F,H){f.value=R,f.offset=A,f.length=F,f.type=H,f.colonOffset=void 0,l=f}try{u(n,{onObjectBegin:(R,A)=>{if(a<=R)throw r;l=void 0,m=a>R,s.push("")},onObjectProperty:(R,A,F)=>{if(a<A||(k(R,A,F,"property"),s[s.length-1]=R,a<=A+F))throw r},onObjectEnd:(R,A)=>{if(a<=R)throw r;l=void 0,s.pop()},onArrayBegin:(R,A)=>{if(a<=R)throw r;l=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(a<=R)throw r;l=void 0,s.pop()},onLiteralValue:(R,A,F)=>{if(a<A||(k(R,A,F,c(R)),a<=A+F))throw r},onSeparator:(R,A,F)=>{if(a<=A)throw r;if(R===":"&&l&&l.type==="property")l.colonOffset=A,m=!1,l=void 0;else if(R===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(m=!0,s[s.length-1]=""),l=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:l,isAtPropertyKey:m,matches:R=>{let A=0;for(let F=0;A<R.length&&F<s.length;F++)if(R[A]===s[F]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}e.getLocation=I;function S(n,a=[],s=M.DEFAULT){let r=null,l=[];const f=[];function m(R){Array.isArray(l)?l.push(R):r!==null&&(l[r]=R)}return u(n,{onObjectBegin:()=>{const R={};m(R),f.push(l),l=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const R=[];m(R),f.push(l),l=R,r=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:m,onError:(R,A,F)=>{a.push({error:R,offset:A,length:F})}},s),l[0]}e.parse=S;function p(n,a=[],s=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function f(R){return r.children.push(R),R}u(n,{onObjectBegin:R=>{r=f({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,A,F)=>{r=f({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:A,length:F,parent:r})},onObjectEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,l(R+A)},onArrayBegin:(R,A)=>{r=f({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,l(R+A)},onLiteralValue:(R,A,F)=>{f({type:c(R),offset:A,length:F,parent:r,value:R}),l(A+F)},onSeparator:(R,A,F)=>{r.type==="property"&&(R===":"?r.colonOffset=A:R===","&&l(A))},onError:(R,A,F)=>{a.push({error:R,offset:A,length:F})}},s);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=p;function t(n,a){if(!n)return;let s=n;for(let r of a)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===r){s=f.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=t;function d(n){if(!n.parent||!n.parent.children)return[];const a=d(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;a.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&a.push(s)}return a}e.getNodePath=d;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":const a=Object.create(null);for(let s of n.children){const r=s.children[1];r&&(a[s.children[0].value]=y(r))}return a;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function v(n,a,s=!1){return a>=n.offset&&a<n.offset+n.length||s&&a===n.offset+n.length}e.contains=v;function b(n,a,s=!1){if(v(n,a,s)){const r=n.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=a;l++){const f=b(r[l],a,s);if(f)return f}return n}}e.findNodeAtOffset=b;function u(n,a,s=M.DEFAULT){const r=P(n,!1);function l(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(K){return K?O=>K(O,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=l(a.onObjectBegin),k=f(a.onObjectProperty),R=l(a.onObjectEnd),A=l(a.onArrayBegin),F=l(a.onArrayEnd),H=f(a.onLiteralValue),te=f(a.onSeparator),se=l(a.onComment),G=f(a.onError),ee=s&&s.disallowComments,T=s&&s.allowTrailingComma;function V(){for(;;){const K=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:ee||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(K){case 12:case 13:ee?N(10):se();break;case 16:N(1);break;case 15:case 14:break;default:return K}}}function N(K,O=[],q=[]){if(G(K),O.length+q.length>0){let C=r.getToken();for(;C!==17;){if(O.indexOf(C)!==-1){V();break}else if(q.indexOf(C)!==-1)break;C=V()}}}function B(K){const O=r.getTokenValue();return K?H(O):k(O),V(),!0}function U(){switch(r.getToken()){case 11:let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(N(2),K=0)}catch(O){N(2)}H(K);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return V(),!0}function _(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(te(":"),V(),z()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function X(){m(),V();let K=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(K||N(4,[],[]),te(","),V(),r.getToken()===2&&T)break}else K&&N(6,[],[]);_()||N(4,[],[2,5]),K=!0}return R(),r.getToken()!==2?N(7,[2],[]):V(),!0}function W(){A(),V();let K=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(K||N(4,[],[]),te(","),V(),r.getToken()===4&&T)break}else K&&N(6,[],[]);z()||N(4,[],[4,5]),K=!0}return F(),r.getToken()!==4?N(8,[4],[]):V(),!0}function z(){switch(r.getToken()){case 3:return W();case 1:return X();case 10:return B(!0);default:return U()}}return V(),r.getToken()===17?s.allowEmptyContent?!0:(N(4,[],[]),!1):z()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=u;function o(n,a){let s=P(n),r=[],l,f=0,m;do switch(m=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:f!==m&&r.push(n.substring(f,m)),a!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,a)),f=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=o;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[105],x([0,1,39]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(h,g,i){let I,S,p,t,d;if(g){for(t=g.offset,d=t+g.length,p=t;p>0&&!E(h,p-1);)p--;let f=d;for(;f<h.length&&!E(h,f);)f++;S=h.substring(p,f),I=M(S,i)}else S=h,I=0,p=0,t=0,d=h.length;const y=P(i,h);let v=!1,b=0,u;i.insertSpaces?u=D(" ",i.tabSize||4):u="	";const o=(0,w.createScanner)(S,!1);let c=!1;function n(){return y+D(u,I+b)}function a(){let f=o.scan();for(v=!1;f===15||f===14;)v=v||f===14,f=o.scan();return c=f===16||o.getTokenError()!==0,f}const s=[];function r(f,m,k){!c&&m<d&&k>t&&h.substring(m,k)!==f&&s.push({offset:m,length:k-m,content:f})}let l=a();if(l!==17){const f=o.getTokenOffset()+p,m=D(u,I);r(m,p,f)}for(;l!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,m=a(),k="";for(;!v&&(m===12||m===13);){const A=o.getTokenOffset()+p;r(" ",f,A),f=o.getTokenOffset()+o.getTokenLength()+p,k=m===12?n():"",m=a()}if(m===2)l!==1&&(b--,k=n());else if(m===4)l!==3&&(b--,k=n());else{switch(l){case 3:case 1:b++,k=n();break;case 5:case 12:k=n();break;case 13:v?k=n():k=" ";break;case 6:k=" ";break;case 10:if(m===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?k=" ":m!==5&&m!==17&&(c=!0);break;case 16:c=!0;break}v&&(m===12||m===13)&&(k=n())}const R=o.getTokenOffset()+p;r(k,f,R),l=m}return s}e.format=L;function D(h,g){let i="";for(let I=0;I<g;I++)i+=h;return i}function M(h,g){let i=0,I=0;const S=g.tabSize||4;for(;i<h.length;){const p=h.charAt(i);if(p===" ")I++;else if(p==="	")I+=S;else break;i++}return Math.floor(I/S)}function P(h,g){for(let i=0;i<g.length;i++){const I=g.charAt(i);if(I==="\r")return i+1<g.length&&g.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function E(h,g){return`\r
`.indexOf(h.charAt(g))!==-1}e.isEOL=E}),define(Z[79],x([0,1,39,105]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(g,i,I){return M(g,i,void 0,I)}e.removeProperty=D;function M(g,i,I,S,p){const t=i.slice(),d=[],y=(0,w.parseTree)(g,d);let v,b;for(;t.length>0&&(b=t.pop(),v=(0,w.findNodeAtLocation)(y,t),v===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(v)if(v.type==="object"&&typeof b=="string"&&Array.isArray(v.children)){const u=(0,w.findNodeAtLocation)(v,[b]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const o=v.children.indexOf(u.parent);let c,n=u.parent.offset+u.parent.length;if(o>0){const a=v.children[o-1];c=a.offset+a.length}else c=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return P(g,{offset:c,length:n-c,content:""},S)}else return P(g,{offset:u.offset,length:u.length,content:JSON.stringify(I)},S);else{if(I===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,c=p?p(v.children.map(a=>a.children[0].value)):v.children.length;let n;if(c>0){const a=v.children[c-1];n={offset:a.offset+a.length,length:0,content:","+o}}else v.children.length===0?n={offset:v.offset+1,length:0,content:o}:n={offset:v.offset+1,length:0,content:o+","};return P(g,n,S)}}else if(v.type==="array"&&typeof b=="number"&&Array.isArray(v.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let o;if(v.children.length===0||b===0)o={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=b===-1||b>v.children.length?v.children.length:b,n=v.children[c-1];o={offset:n.offset+n.length,length:0,content:","+u}}return P(g,o,S)}else{const u=b,o=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const n=v.children[u-1],a=n.offset+n.length,s=v.offset+v.length;c={offset:a,length:s-2-a,content:""}}else c={offset:o.offset,length:v.children[u+1].offset-o.offset,content:""};return P(g,c,S)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return P(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(I)},S)}}e.setProperty=M;function P(g,i,I){let S=E(g,i),p=i.offset,t=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(S,p-1);)p--;for(;t<S.length&&!(0,L.isEOL)(S,t);)t++}const d=(0,L.format)(S,{offset:p,length:t-p},I);for(let v=d.length-1;v>=0;v--){const b=d[v];S=E(S,b),p=Math.min(p,b.offset),t=Math.max(t,b.offset+b.length),t+=b.content.length-b.length}const y=g.length-(S.length-t)-p;return[{offset:p,length:y,content:S.substring(p,t)}]}e.withFormatting=P;function E(g,i){return g.substring(0,i.offset)+i.content+g.substring(i.offset+i.length)}e.applyEdit=E;function h(g,i){let I=i.slice(0).sort((p,t)=>{const d=p.offset-t.offset;return d===0?p.length-t.length:d}),S=g.length;for(let p=I.length-1;p>=0;p--){let t=I[p];if(t.offset+t.length<=S)g=E(g,t);else throw new Error("Overlapping edit");S=t.offset}return g}e.applyEdits=h}),define(Z[80],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(L=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,y){this._keyCodeToStr[d]=y,this._strToKeyCode[y.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new D,P=new D,E=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],g=Object.create(null),i=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>i[t]||0,toEnum:t=>g[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let y=[],v=[];for(const b of d){const[u,o,c,n,a,s,r,l,f,m]=b;if(v[c]||(v[c]=!0,h[c]=n,g[n]=c,i[n.toLowerCase()]=c,o&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[a]=c))),!y[a]){if(y[a]=!0,!s)throw new Error(`String representation missing for key code ${a} around scan code ${n}`);M.define(a,s),P.define(a,f||s),E.define(a,m||f||s)}r&&(e.EVENT_KEY_CODE_MAP[r]=a),l&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=a)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(t){function d(c){return M.keyCodeToStr(c)}t.toString=d;function y(c){return M.strToKeyCode(c)}t.fromString=y;function v(c){return P.keyCodeToStr(c)}t.toUserSettingsUS=v;function b(c){return E.keyCodeToStr(c)}t.toUserSettingsGeneral=b;function u(c){return P.strToKeyCode(c)||E.strToKeyCode(c)}t.fromUserSettings=u;function o(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(c)}t.toElectronAccelerator=o})(I=e.KeyCodeUtils||(e.KeyCodeUtils={}));var S;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(S=e.KeyMod||(e.KeyMod={}));function p(t,d){const y=(d&65535)<<16>>>0;return(t|y)>>>0}e.KeyChord=p}),define(Z[59],x([0,1,16]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var L;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(L||(L={}));function D(I,S){if(I===0)return null;const p=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new E([M(p,S),M(t,S)]):new E([M(p,S)])}e.createKeybinding=D;function M(I,S){const p=!!(I&2048),t=!!(I&256),d=S===2?t:p,y=!!(I&1024),v=!!(I&512),b=S===2?p:t,u=I&255;return new P(d,y,v,b,u)}e.createSimpleKeybinding=M;class P{constructor(S,p,t,d,y){this.ctrlKey=S,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.keyCode=y}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.keyCode===S.keyCode}getHashCode(){const S=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${S}${p}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class E{constructor(S){if(S.length===0)throw(0,w.illegalArgument)("parts");this.parts=S}getHashCode(){let S="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(S+=";"),S+=this.parts[p].getHashCode();return S}equals(S){if(S===null||this.parts.length!==S.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(S.parts[p]))return!1;return!0}}e.ChordKeybinding=E;class h{constructor(S,p,t,d,y){this.ctrlKey=S,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.scanCode=y}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class g{constructor(S,p,t,d,y,v){this.ctrlKey=S,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.keyLabel=y,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=g;class i{}e.ResolvedKeybinding=i}),define(Z[106],x([0,1,80,59]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let E=!1,h=!1,g=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(P)&&(E=!0,P=P.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(P)&&(h=!0,P=P.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(P)&&(g=!0,P=P.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(P)&&(i=!0,P=P.substr("meta-".length),I=!0),/^win(\+|\-)/.test(P)&&(i=!0,P=P.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(P)&&(i=!0,P=P.substr("cmd-".length),I=!0);while(I);let S;const p=P.indexOf(" ");return p>0?(S=P.substring(0,p),P=P.substring(p)):(S=P,P=""),{remains:P,ctrl:E,shift:h,alt:g,meta:i,key:S}}static parseSimpleKeybinding(P){const E=this._readModifiers(P),h=w.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,h),E.remains]}static parseKeybinding(P,E){if(!P)return null;const h=[];let g;do[g,P]=this.parseSimpleKeybinding(P),h.push(g);while(P.length>0);return new L.ChordKeybinding(h)}static parseSimpleUserBinding(P){const E=this._readModifiers(P),h=E.key.match(/^\[([^\]]+)\]$/);if(h){const i=h[1],I=w.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,I),E.remains]}const g=w.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,g),E.remains]}static parseUserBinding(P){if(!P)return[];const E=[];let h;for(;P.length>0;)[h,P]=this.parseSimpleUserBinding(P),E.push(h);return E}}e.KeybindingParser=D}),define(Z[2],x([0,1,42,68]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function P(r){M=r}if(e.setDisposableTracker=P,D){const r="__is_disposable_tracked__";P(new class{trackDisposable(l){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(f)},3e3)}setParent(l,f){if(l&&l!==b.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==b.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function E(r){return M?.trackDisposable(r),r}function h(r){M?.markAsDisposed(r)}function g(r,l){M?.setParent(r,l)}function i(r,l){if(!!M)for(const f of r)M.setParent(f,l)}function I(r){return M?.markAsSingleton(r),r}e.markAsSingleton=I;class S extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=S;function p(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=p;function t(r){if(L.Iterable.is(r)){let l=[];for(const f of r)if(f)try{f.dispose()}catch(m){l.push(m)}if(l.length===1)throw l[0];if(l.length>1)throw new S(l);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function d(...r){const l=y(()=>t(r));return i(r,l),l}e.combinedDisposable=d;function y(r){const l=E({dispose:(0,w.once)(()=>{h(l),r()})});return l}e.toDisposable=y;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return g(l,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new v,E(this),g(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&g(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&g(l,null),l}}e.MutableDisposable=u;class o{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class c{constructor(){this.references=new Map}acquire(l,...f){let m=this.references.get(l);m||(m={counter:0,object:this.createReferencedObject(l,...f)},this.references.set(l,m));const{object:k}=m,R=(0,w.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(l,m.object),this.references.delete(l))});return m.counter++,{object:k,dispose:R}}}e.ReferenceCollection=c;class n{constructor(l){this.referenceCollection=l}async acquire(l,...f){const m=this.referenceCollection.acquire(l,...f);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(k){throw m.dispose(),k}}}e.AsyncReferenceCollection=n;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a;function s(r){const l=new v;try{r(l)}finally{l.dispose()}}e.disposeOnReturn=s}),define(Z[107],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(M){this.element=M,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class L{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let M=this._first;for(;M!==w.Undefined;){const P=M.next;M.prev=w.Undefined,M.next=w.Undefined,M=P}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,P){const E=new w(M);if(this._first===w.Undefined)this._first=E,this._last=E;else if(P){const g=this._last;this._last=E,E.prev=g,g.next=E}else{const g=this._first;this._first=E,E.next=g,g.prev=E}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(E))}}shift(){if(this._first!==w.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==w.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==w.Undefined&&M.next!==w.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===w.Undefined&&M.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):M.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):M.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==w.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function j(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function P(h){M.push(h,Date.now())}function E(){const h=[];for(let g=0;g<M.length;g+=2)h.push({name:M[g],startTime:M[g+1]});return h}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(D+P.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function w(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(Z[3],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let L=!1,D=!1,M=!1,P=!1,E=!1,h=!1,g=!1,i,I=w,S,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const d=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=d&&t?.sandboxed,typeof navigator=="object"&&!d)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,g=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=p.indexOf("Linux")>=0,h=!0,i=navigator.language,I=i;else if(typeof t=="object"){L=t.platform==="win32",D=t.platform==="darwin",M=t.platform==="linux",P=M&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,i=w,I=w;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),l=r.availableLanguages["*"];i=r.locale,I=l||w,S=r._translationsConfigFile}catch(r){}E=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function v(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let b=0;D?b=1:L?b=3:M&&(b=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=P,e.isNative=E,e.isWeb=h,e.isIOS=g,e.platform=b,e.userAgent=p,e.language=I;var u;(function(s){function r(){return e.language}s.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function f(){return e.language==="en"}s.isDefault=f})(u=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=S,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let k=0,R=l.length;k<R;k++){const A=l[k];if(A.id===m.data.vscodeSetImmediateId){l.splice(k,1),A.callback();return}}});let f=0;return m=>{const k=++f;l.push({id:k,callback:m}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const r=Promise.resolve();return l=>r.then(l)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||g?2:L?1:3;let c=!0,n=!1;function a(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,c=new Uint16Array(s.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(Z[32],x([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const D=w.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(M){return(0,w.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,w.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,32]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,M=90,P=122,E=46,h=47,g=92,i=58,I=63;class S extends Error{constructor(o,c,n){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${a} of type ${c}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,o){if(typeof u!="string")throw new S(o,"string",u)}function t(u){return u===h||u===g}function d(u){return u===h}function y(u){return u>=L&&u<=M||u>=D&&u<=P}function v(u,o,c,n){let a="",s=0,r=-1,l=0,f=0;for(let m=0;m<=u.length;++m){if(m<u.length)f=u.charCodeAt(m);else{if(n(f))break;f=h}if(n(f)){if(!(r===m-1||l===1))if(l===2){if(a.length<2||s!==2||a.charCodeAt(a.length-1)!==E||a.charCodeAt(a.length-2)!==E){if(a.length>2){const k=a.lastIndexOf(c);k===-1?(a="",s=0):(a=a.slice(0,k),s=a.length-1-a.lastIndexOf(c)),r=m,l=0;continue}else if(a.length!==0){a="",s=0,r=m,l=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",s=2)}else a.length>0?a+=`${c}${u.slice(r+1,m)}`:a=u.slice(r+1,m),s=m-r-1;r=m,l=0}else f===E&&l!==-1?++l:l=-1}return a}function b(u,o){if(o===null||typeof o!="object")throw new S("pathObject","Object",o);const c=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${n}`:`${c}${u}${n}`:n}e.win32={resolve(...u){let o="",c="",n=!1;for(let a=u.length-1;a>=-1;a--){let s;if(a>=0){if(s=u[a],p(s,"path"),s.length===0)continue}else o.length===0?s=w.cwd():(s=w.env[`=${o}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===g)&&(s=`${o}\\`));const r=s.length;let l=0,f="",m=!1;const k=s.charCodeAt(0);if(r===1)t(k)&&(l=1,m=!0);else if(t(k))if(m=!0,t(s.charCodeAt(1))){let R=2,A=R;for(;R<r&&!t(s.charCodeAt(R));)R++;if(R<r&&R!==A){const F=s.slice(A,R);for(A=R;R<r&&t(s.charCodeAt(R));)R++;if(R<r&&R!==A){for(A=R;R<r&&!t(s.charCodeAt(R));)R++;(R===r||R!==A)&&(f=`\\\\${F}\\${s.slice(A,R)}`,l=R)}}}else l=1;else y(k)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),l=2,r>2&&t(s.charCodeAt(2))&&(m=!0,l=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(n){if(o.length>0)break}else if(c=`${s.slice(l)}\\${c}`,n=m,m&&o.length>0)break}return c=v(c,!n,"\\",t),n?`${o}\\${c}`:`${o}${c}`||"."},normalize(u){p(u,"path");const o=u.length;if(o===0)return".";let c=0,n,a=!1;const s=u.charCodeAt(0);if(o===1)return d(s)?"\\":u;if(t(s))if(a=!0,t(u.charCodeAt(1))){let l=2,f=l;for(;l<o&&!t(u.charCodeAt(l));)l++;if(l<o&&l!==f){const m=u.slice(f,l);for(f=l;l<o&&t(u.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&!t(u.charCodeAt(l));)l++;if(l===o)return`\\\\${m}\\${u.slice(f)}\\`;l!==f&&(n=`\\\\${m}\\${u.slice(f,l)}`,c=l)}}}else c=1;else y(s)&&u.charCodeAt(1)===i&&(n=u.slice(0,2),c=2,o>2&&t(u.charCodeAt(2))&&(a=!0,c=3));let r=c<o?v(u.slice(c),!a,"\\",t):"";return r.length===0&&!a&&(r="."),r.length>0&&t(u.charCodeAt(o-1))&&(r+="\\"),n===void 0?a?`\\${r}`:r:a?`${n}\\${r}`:`${n}${r}`},isAbsolute(u){p(u,"path");const o=u.length;if(o===0)return!1;const c=u.charCodeAt(0);return t(c)||o>2&&y(c)&&u.charCodeAt(1)===i&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let o,c;for(let s=0;s<u.length;++s){const r=u[s];p(r,"path"),r.length>0&&(o===void 0?o=c=r:o+=`\\${r}`)}if(o===void 0)return".";let n=!0,a=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++a;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++a,s>2&&(t(c.charCodeAt(2))?++a:n=!1))}if(n){for(;a<o.length&&t(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(u,o){if(p(u,"from"),p(o,"to"),u===o)return"";const c=e.win32.resolve(u),n=e.win32.resolve(o);if(c===n||(u=c.toLowerCase(),o=n.toLowerCase(),u===o))return"";let a=0;for(;a<u.length&&u.charCodeAt(a)===g;)a++;let s=u.length;for(;s-1>a&&u.charCodeAt(s-1)===g;)s--;const r=s-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===g;)l++;let f=o.length;for(;f-1>l&&o.charCodeAt(f-1)===g;)f--;const m=f-l,k=r<m?r:m;let R=-1,A=0;for(;A<k;A++){const H=u.charCodeAt(a+A);if(H!==o.charCodeAt(l+A))break;H===g&&(R=A)}if(A!==k){if(R===-1)return n}else{if(m>k){if(o.charCodeAt(l+A)===g)return n.slice(l+A+1);if(A===2)return n.slice(l+A)}r>k&&(u.charCodeAt(a+A)===g?R=A:A===2&&(R=3)),R===-1&&(R=0)}let F="";for(A=a+R+1;A<=s;++A)(A===s||u.charCodeAt(A)===g)&&(F+=F.length===0?"..":"\\..");return l+=R,F.length>0?`${F}${n.slice(l,f)}`:(n.charCodeAt(l)===g&&++l,n.slice(l,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const o=e.win32.resolve(u);if(o.length<=2)return u;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const c=o.charCodeAt(2);if(c!==I&&c!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(y(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return u},dirname(u){p(u,"path");const o=u.length;if(o===0)return".";let c=-1,n=0;const a=u.charCodeAt(0);if(o===1)return t(a)?u:".";if(t(a)){if(c=n=1,t(u.charCodeAt(1))){let l=2,f=l;for(;l<o&&!t(u.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&t(u.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&!t(u.charCodeAt(l));)l++;if(l===o)return u;l!==f&&(c=n=l+1)}}}}else y(a)&&u.charCodeAt(1)===i&&(c=o>2&&t(u.charCodeAt(2))?3:2,n=c);let s=-1,r=!0;for(let l=o-1;l>=n;--l)if(t(u.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,o){o!==void 0&&p(o,"ext"),p(u,"path");let c=0,n=-1,a=!0,s;if(u.length>=2&&y(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(c=2),o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let r=o.length-1,l=-1;for(s=u.length-1;s>=c;--s){const f=u.charCodeAt(s);if(t(f)){if(!a){c=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return c===n?n=l:n===-1&&(n=u.length),u.slice(c,n)}for(s=u.length-1;s>=c;--s)if(t(u.charCodeAt(s))){if(!a){c=s+1;break}}else n===-1&&(a=!1,n=s+1);return n===-1?"":u.slice(c,n)},extname(u){p(u,"path");let o=0,c=-1,n=0,a=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&y(u.charCodeAt(0))&&(o=n=2);for(let l=u.length-1;l>=o;--l){const f=u.charCodeAt(l);if(t(f)){if(!s){n=l+1;break}continue}a===-1&&(s=!1,a=l+1),f===E?c===-1?c=l:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||a===-1||r===0||r===1&&c===a-1&&c===n+1?"":u.slice(c,a)},format:b.bind(null,"\\"),parse(u){p(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const c=u.length;let n=0,a=u.charCodeAt(0);if(c===1)return t(a)?(o.root=o.dir=u,o):(o.base=o.name=u,o);if(t(a)){if(n=1,t(u.charCodeAt(1))){let R=2,A=R;for(;R<c&&!t(u.charCodeAt(R));)R++;if(R<c&&R!==A){for(A=R;R<c&&t(u.charCodeAt(R));)R++;if(R<c&&R!==A){for(A=R;R<c&&!t(u.charCodeAt(R));)R++;R===c?n=R:R!==A&&(n=R+1)}}}}else if(y(a)&&u.charCodeAt(1)===i){if(c<=2)return o.root=o.dir=u,o;if(n=2,t(u.charCodeAt(2))){if(c===3)return o.root=o.dir=u,o;n=3}}n>0&&(o.root=u.slice(0,n));let s=-1,r=n,l=-1,f=!0,m=u.length-1,k=0;for(;m>=n;--m){if(a=u.charCodeAt(m),t(a)){if(!f){r=m+1;break}continue}l===-1&&(f=!1,l=m+1),a===E?s===-1?s=m:k!==1&&(k=1):s!==-1&&(k=-1)}return l!==-1&&(s===-1||k===0||k===1&&s===l-1&&s===r+1?o.base=o.name=u.slice(r,l):(o.name=u.slice(r,s),o.base=u.slice(r,l),o.ext=u.slice(s,l))),r>0&&r!==n?o.dir=u.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let o="",c=!1;for(let n=u.length-1;n>=-1&&!c;n--){const a=n>=0?u[n]:w.cwd();p(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===h)}return o=v(o,!c,"/",d),c?`/${o}`:o.length>0?o:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===h,c=u.charCodeAt(u.length-1)===h;return u=v(u,!o,"/",d),u.length===0?o?"/":c?"./":".":(c&&(u+="/"),o?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===h},join(...u){if(u.length===0)return".";let o;for(let c=0;c<u.length;++c){const n=u[c];p(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(u,o){if(p(u,"from"),p(o,"to"),u===o||(u=e.posix.resolve(u),o=e.posix.resolve(o),u===o))return"";const c=1,n=u.length,a=n-c,s=1,r=o.length-s,l=a<r?a:r;let f=-1,m=0;for(;m<l;m++){const R=u.charCodeAt(c+m);if(R!==o.charCodeAt(s+m))break;R===h&&(f=m)}if(m===l)if(r>l){if(o.charCodeAt(s+m)===h)return o.slice(s+m+1);if(m===0)return o.slice(s+m)}else a>l&&(u.charCodeAt(c+m)===h?f=m:m===0&&(f=0));let k="";for(m=c+f+1;m<=n;++m)(m===n||u.charCodeAt(m)===h)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===h;let c=-1,n=!0;for(let a=u.length-1;a>=1;--a)if(u.charCodeAt(a)===h){if(!n){c=a;break}}else n=!1;return c===-1?o?"/":".":o&&c===1?"//":u.slice(0,c)},basename(u,o){o!==void 0&&p(o,"ext"),p(u,"path");let c=0,n=-1,a=!0,s;if(o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let r=o.length-1,l=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===h){if(!a){c=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return c===n?n=l:n===-1&&(n=u.length),u.slice(c,n)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===h){if(!a){c=s+1;break}}else n===-1&&(a=!1,n=s+1);return n===-1?"":u.slice(c,n)},extname(u){p(u,"path");let o=-1,c=0,n=-1,a=!0,s=0;for(let r=u.length-1;r>=0;--r){const l=u.charCodeAt(r);if(l===h){if(!a){c=r+1;break}continue}n===-1&&(a=!1,n=r+1),l===E?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||n===-1||s===0||s===1&&o===n-1&&o===c+1?"":u.slice(o,n)},format:b.bind(null,"/"),parse(u){p(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const c=u.charCodeAt(0)===h;let n;c?(o.root="/",n=1):n=0;let a=-1,s=0,r=-1,l=!0,f=u.length-1,m=0;for(;f>=n;--f){const k=u.charCodeAt(f);if(k===h){if(!l){s=f+1;break}continue}r===-1&&(l=!1,r=f+1),k===E?a===-1?a=f:m!==1&&(m=1):a!==-1&&(m=-1)}if(r!==-1){const k=s===0&&c?1:s;a===-1||m===0||m===1&&a===r-1&&a===s+1?o.base=o.name=u.slice(k,r):(o.name=u.slice(k,a),o.base=u.slice(k,r),o.ext=u.slice(a,r))}return s>0?o.dir=u.slice(0,s-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[81],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...P){const E=P.reduce((i,I)=>(i[I]=!0,i),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!E[i]).forEach(i=>{for(let I=0;I<h.length;I++)if(i.search(h[I])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=D}),define(Z[108],x([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=w.globals.performance&&typeof w.globals.performance.now=="function";class D{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,16,42,2,107,108]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(o){o.None=()=>D.Disposable.None;function c(T){return(V,N=null,B)=>{let U=!1,_;return _=T(X=>{if(!U)return _?_.dispose():U=!0,V.call(N,X)},null,B),U&&_.dispose(),_}}o.once=c;function n(T,V){return m((N,B=null,U)=>T(_=>N.call(B,V(_)),null,U))}o.map=n;function a(T,V){return m((N,B=null,U)=>T(_=>{V(_),N.call(B,_)},null,U))}o.forEach=a;function s(T,V){return m((N,B=null,U)=>T(_=>V(_)&&N.call(B,_),null,U))}o.filter=s;function r(T){return T}o.signal=r;function l(...T){return(V,N=null,B)=>(0,D.combinedDisposable)(...T.map(U=>U(_=>V.call(N,_),null,B)))}o.any=l;function f(T,V,N){let B=N;return n(T,U=>(B=V(B,U),B))}o.reduce=f;function m(T){let V;const N=new S({onFirstListenerAdd(){V=T(N.fire,N)},onLastListenerRemove(){V.dispose()}});return N.event}function k(T,V,N=100,B=!1,U){let _,X,W,z=0;const K=new S({leakWarningThreshold:U,onFirstListenerAdd(){_=T(O=>{z++,X=V(X,O),B&&!W&&(K.fire(X),X=void 0),clearTimeout(W),W=setTimeout(()=>{const q=X;X=void 0,W=void 0,(!B||z>1)&&K.fire(q),z=0},N)})},onLastListenerRemove(){_.dispose()}});return K.event}o.debounce=k;function R(T,V=(N,B)=>N===B){let N=!0,B;return s(T,U=>{const _=N||!V(U,B);return N=!1,B=U,_})}o.latch=R;function A(T,V){return[o.filter(T,V),o.filter(T,N=>!V(N))]}o.split=A;function F(T,V=!1,N=[]){let B=N.slice(),U=T(W=>{B?B.push(W):X.fire(W)});const _=()=>{B&&B.forEach(W=>X.fire(W)),B=null},X=new S({onFirstListenerAdd(){U||(U=T(W=>X.fire(W)))},onFirstListenerDidAdd(){B&&(V?setTimeout(_):_())},onLastListenerRemove(){U&&U.dispose(),U=null}});return X.event}o.buffer=F;class H{constructor(V){this.event=V}map(V){return new H(n(this.event,V))}forEach(V){return new H(a(this.event,V))}filter(V){return new H(s(this.event,V))}reduce(V,N){return new H(f(this.event,V,N))}latch(){return new H(R(this.event))}debounce(V,N=100,B=!1,U){return new H(k(this.event,V,N,B,U))}on(V,N,B){return this.event(V,N,B)}once(V,N,B){return c(this.event)(V,N,B)}}function te(T){return new H(T)}o.chain=te;function se(T,V,N=B=>B){const B=(...W)=>X.fire(N(...W)),U=()=>T.on(V,B),_=()=>T.removeListener(V,B),X=new S({onFirstListenerAdd:U,onLastListenerRemove:_});return X.event}o.fromNodeEventEmitter=se;function G(T,V,N=B=>B){const B=(...W)=>X.fire(N(...W)),U=()=>T.addEventListener(V,B),_=()=>T.removeEventListener(V,B),X=new S({onFirstListenerAdd:U,onLastListenerRemove:_});return X.event}o.fromDOMEventEmitter=G;function ee(T){return new Promise(V=>c(T)(V))}o.toPromise=ee})(E=e.Event||(e.Event={}));class h{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${h._idPool++}`}start(c){this._stopWatch=new P.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let g=-1;function i(o){const c=g;return g=o,{dispose(){g=c}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(c,n=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let n=g;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||c<n)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let r,l=0;for(const[f,m]of this._stacks)(!r||l<m)&&(r=f,l=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${l}):`),console.warn(r)}return()=>{const r=this._stacks.get(a)||0;this._stacks.set(a,r-1)}}}class S{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=g>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(c,n,a)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(n?[c,n]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,n);const l=this._leakageMon?.check(this._listeners.size),f=(0,D.toDisposable)(()=>{l&&l(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(f):Array.isArray(a)&&a.push(f),f}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,a]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,a):n[0].call(n[1],a)}catch(s){(0,w.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=S;class p extends S{async fireAsync(c,n,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),l=[],f={...r,waitUntil:m=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(m=a(m,typeof s=="function"?s:s[0])),l.push(m)}};try{typeof s=="function"?s.call(void 0,f):s[0].call(s[1],f)}catch(m){(0,w.onUnexpectedError)(m);continue}Object.freeze(l),await Promise.allSettled(l).then(m=>{for(const k of m)k.status==="rejected"&&(0,w.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=p;class t extends S{constructor(c){super(c);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class d extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=d;class y extends S{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const n={event:c,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const a=()=>{this.hasListeners&&this.unhook(n);const s=this.events.indexOf(n);this.events.splice(s,1)};return(0,D.toDisposable)((0,L.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(n=>this.emitter.fire(n))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class b{constructor(){this.buffers=[]}wrapEvent(c){return(n,a,s)=>c(r=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>n.call(a,r)):n.call(a,r)},void 0,s)}bufferEvents(c){const n=[];this.buffers.push(n);const a=c();return this.buffers.pop(),n.forEach(s=>s()),a}}e.EventBufferer=b;class u{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(Z[23],x([0,1,4]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,h){const g=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(g)}}});var D;(function(E){function h(g){return g===E.None||g===E.Cancelled||g instanceof M?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Z[109],x([0,1,4]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(I){const S=this._icons.get(I.id);S?I.description?S.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function M(i,I){return new E(i,I)}e.registerCodicon=M;function P(i){return i?i.replace(/\$\((.*?)\)/g,(I,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=P;class E{constructor(I,S,p){this.id=I,this.definition=S,this.description=p,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function h(i,I){const S=["codicon","codicon-"+i];return I&&S.push("codicon-modifier-"+I),S}e.getClassNamesArray=h;var g;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function S(d){if(d instanceof E)return["codicon","codicon-"+d.id];const y=I.exec(d.id);if(!y)return S(E.error);let[,v,b]=y;const u=["codicon","codicon-"+v];return b&&u.push("codicon-modifier-"+b.substr(1)),u}i.asClassNameArray=S;function p(d){return S(d).join(" ")}i.asClassName=p;function t(d){return"."+S(d).join(".")}i.asCSSSelector=t})(g=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"})}(E=e.Codicon||(e.Codicon={}))}),define(Z[60],x([0,1,16,2]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function M(u){const o=u;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(u,o){return new E(u,o)}e.newWriteableStream=P;class E{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,w.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const a=n.indexOf(c);a>=0&&n.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(u,o){const c=[];let n;for(;(n=u.read())!==null;)c.push(n);return o(c)}e.consumeReadable=h;function g(u,o,c){const n=[];let a;for(;(a=u.read())!==null&&n.length<c;)n.push(a);return a===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return u.read()}}}e.peekReadable=g;function i(u,o){return new Promise((c,n)=>{const a=[];I(u,{onData:s=>{o&&a.push(s)},onError:s=>{o?n(s):c(void 0)},onEnd:()=>{c(o?o(a):void 0)}})})}e.consumeStream=i;function I(u,o){u.on("error",c=>o.onError(c)),u.on("end",()=>o.onEnd()),u.on("data",c=>o.onData(c))}e.listenStream=I;function S(u,o){return new Promise((c,n)=>{const a=new L.DisposableStore,s=[],r=m=>{if(s.push(m),s.length>o)return a.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},l=m=>n(m),f=()=>c({stream:u,buffer:s,ended:!0});a.add((0,L.toDisposable)(()=>u.removeListener("error",l))),u.on("error",l),a.add((0,L.toDisposable)(()=>u.removeListener("end",f))),u.on("end",f),a.add((0,L.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=S;function p(u,o){const c=P(o);return c.end(u),c}e.toStream=p;function t(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function d(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}e.toReadable=d;function y(u,o,c){const n=P(c);return I(u,{onData:a=>n.write(o.data(a)),onError:a=>n.error(o.error?o.error(a):a),onEnd:()=>n.end()}),n}e.transform=y;function v(u,o,c){let n=!1;return{read:()=>{const a=o.read();return n?a:(n=!0,a!==null?c([u,a]):u)}}}e.prefixedReadable=v;function b(u,o,c){let n=!1;const a=P(c);return I(o,{onData:s=>n?a.write(s):(n=!0,a.write(c([u,s]))),onError:s=>a.error(s),onEnd:()=>{n||(n=!0,a.write(u)),a.end()}}),a}e.prefixedStream=b}),define(Z[17],x([0,1,60]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,M;class P{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new P(Buffer.allocUnsafe(r)):new P(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new P(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(r)):(D||(D=new TextEncoder),new P(D.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let k=0,R=r.length;k<R;k++)l+=r[k].byteLength}const f=P.alloc(l);let m=0;for(let k=0,R=r.length;k<R;k++){const A=r[k];f.set(A,m),m+=A.byteLength}return f}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(r,l){return new P(this.buffer.subarray(r,l))}set(r,l){r instanceof P?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,l){i(this.buffer,r,l)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,l){S(this.buffer,r,l)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,l){t(this.buffer,r,l)}}e.VSBuffer=P;function E(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=E;function h(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255}e.writeUInt16LE=h;function g(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=g;function i(s,r,l){s[l+3]=r,r=r>>>8,s[l+2]=r,r=r>>>8,s[l+1]=r,r=r>>>8,s[l]=r}e.writeUInt32BE=i;function I(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=I;function S(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255,r=r>>>8,s[l+2]=r&255,r=r>>>8,s[l+3]=r&255}e.writeUInt32LE=S;function p(s,r){return s[r]}e.readUInt8=p;function t(s,r,l){s[l]=r}e.writeUInt8=t;function d(s){return w.consumeReadable(s,r=>P.concat(r))}e.readableToBuffer=d;function y(s){return w.toReadable(s)}e.bufferToReadable=y;function v(s){return w.consumeStream(s,r=>P.concat(r))}e.streamToBuffer=v;async function b(s){return s.ended?P.concat(s.buffer):P.concat([...s.buffer,await v(s.stream)])}e.bufferedStreamToBuffer=b;function u(s){return w.toStream(s,r=>P.concat(r))}e.bufferToStream=u;function o(s){return w.transform(s,{data:r=>typeof r=="string"?P.fromString(r):P.wrap(r)},r=>P.concat(r))}e.streamToBufferReadableStream=o;function c(s){return w.newWriteableStream(r=>P.concat(r),s)}e.newWriteableBufferStream=c;function n(s,r){return w.prefixedReadable(s,r,l=>P.concat(l))}e.prefixedBufferReadable=n;function a(s,r){return w.prefixedStream(s,r,l=>P.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function w(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=w;const L=/{(\d+)}/g;function D(Y,...ae){return ae.length===0?Y:Y.replace(L,function(ue,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=ae.length?ue:ae[be]})}e.format=D;const M=/{([^}]+)}/g;function P(Y,ae){return Y.replace(M,(ue,me)=>ae[me]??ue)}e.format2=P;function E(Y){return Y.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=E;function h(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=h;function g(Y,ae){let ue=0;const me=ae.charCodeAt(0);for(let be=Y.length-1;be>=0;be--)Y.charCodeAt(be)===me&&ue++;return ue}e.count=g;function i(Y,ae,ue="\u2026"){return Y.length<=ae?Y:`${Y.substr(0,ae)}${ue}`}e.truncate=i;function I(Y,ae=" "){const ue=S(Y,ae);return p(ue,ae)}e.trim=I;function S(Y,ae){if(!Y||!ae)return Y;const ue=ae.length;if(ue===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(ae,me)===me;)me=me+ue;return Y.substring(me)}e.ltrim=S;function p(Y,ae){if(!Y||!ae)return Y;const ue=ae.length,me=Y.length;if(ue===0||me===0)return Y;let be=me,Ae=-1;for(;Ae=Y.lastIndexOf(ae,be-1),!(Ae===-1||Ae+ue!==be);){if(Ae===0)return"";be=Ae}return Y.substring(0,be)}e.rtrim=p;function t(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function d(Y){return Y.replace(/\*/g,"")}e.stripWildcards=d;function y(Y,ae,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");ae||(Y=h(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=y;function v(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function b(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function u(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=u;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function c(Y){for(let ae=0,ue=Y.length;ae<ue;ae++){const me=Y.charCodeAt(ae);if(me!==32&&me!==9)return ae}return-1}e.firstNonWhitespaceIndex=c;function n(Y,ae=0,ue=Y.length){for(let me=ae;me<ue;me++){const be=Y.charCodeAt(me);if(be!==32&&be!==9)return Y.substring(ae,me)}return Y.substring(ae,ue)}e.getLeadingWhitespace=n;function a(Y,ae=Y.length-1){for(let ue=ae;ue>=0;ue--){const me=Y.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=a;function s(Y,ae){return Y<ae?-1:Y>ae?1:0}e.compare=s;function r(Y,ae,ue=0,me=Y.length,be=0,Ae=ae.length){for(;ue<me&&be<Ae;ue++,be++){let Be=Y.charCodeAt(ue),_e=ae.charCodeAt(be);if(Be<_e)return-1;if(Be>_e)return 1}const Oe=me-ue,Ue=Ae-be;return Oe<Ue?-1:Oe>Ue?1:0}e.compareSubstring=r;function l(Y,ae){return f(Y,ae,0,Y.length,0,ae.length)}e.compareIgnoreCase=l;function f(Y,ae,ue=0,me=Y.length,be=0,Ae=ae.length){for(;ue<me&&be<Ae;ue++,be++){let Be=Y.charCodeAt(ue),_e=ae.charCodeAt(be);if(Be===_e)continue;if(Be>=128||_e>=128)return r(Y.toLowerCase(),ae.toLowerCase(),ue,me,be,Ae);m(Be)&&(Be-=32),m(_e)&&(_e-=32);const ze=Be-_e;if(ze!==0)return ze}const Oe=me-ue,Ue=Ae-be;return Oe<Ue?-1:Oe>Ue?1:0}e.compareSubstringIgnoreCase=f;function m(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=m;function k(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=k;function R(Y,ae){return Y.length===ae.length&&f(Y,ae)===0}e.equalsIgnoreCase=R;function A(Y,ae){const ue=ae.length;return ae.length>Y.length?!1:f(Y,ae,0,ue)===0}e.startsWithIgnoreCase=A;function F(Y,ae){let ue,me=Math.min(Y.length,ae.length);for(ue=0;ue<me;ue++)if(Y.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return me}e.commonPrefixLength=F;function H(Y,ae){let ue,me=Math.min(Y.length,ae.length);const be=Y.length-1,Ae=ae.length-1;for(ue=0;ue<me;ue++)if(Y.charCodeAt(be-ue)!==ae.charCodeAt(Ae-ue))return ue;return me}e.commonSuffixLength=H;function te(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=te;function se(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=se;function G(Y,ae){return(Y-55296<<10)+(ae-56320)+65536}e.computeCodePoint=G;function ee(Y,ae,ue){const me=Y.charCodeAt(ue);if(te(me)&&ue+1<ae){const be=Y.charCodeAt(ue+1);if(se(be))return G(me,be)}return me}e.getNextCodePoint=ee;function T(Y,ae){const ue=Y.charCodeAt(ae-1);if(se(ue)&&ae>1){const me=Y.charCodeAt(ae-2);if(te(me))return G(me,ue)}return ue}function V(Y,ae){const ue=Re.getInstance(),me=ae,be=Y.length,Ae=ee(Y,be,ae);ae+=Ae>=65536?2:1;let Oe=ue.getGraphemeBreakType(Ae);for(;ae<be;){const Ue=ee(Y,be,ae),Be=ue.getGraphemeBreakType(Ue);if(ke(Oe,Be))break;ae+=Ue>=65536?2:1,Oe=Be}return ae-me}e.nextCharLength=V;function N(Y,ae){const ue=Re.getInstance(),me=ae,be=T(Y,ae);ae-=be>=65536?2:1;let Ae=ue.getGraphemeBreakType(be);for(;ae>0;){const Oe=T(Y,ae),Ue=ue.getGraphemeBreakType(Oe);if(ke(Ue,Ae))break;ae-=Oe>=65536?2:1,Ae=Ue}return me-ae}e.prevCharLength=N;function B(Y,ae){const ue=Re.getInstance(),me=Y.length,be=ae,Ae=ee(Y,me,ae),Oe=ue.getGraphemeBreakType(Ae);ae+=Ae>=65536?2:1;let Ue=Oe;for(;ae<me;){const _e=ee(Y,me,ae),ze=ue.getGraphemeBreakType(_e);if(ke(Ue,ze))break;ae+=_e>=65536?2:1,Ue=ze}const Be=ae;for(ae=be,Ue=Oe;ae>0;){const _e=T(Y,ae),ze=ue.getGraphemeBreakType(_e);if(ke(ze,Ue))break;ae-=_e>=65536?2:1,Ue=ze}return[ae,Be]}function U(Y,ae){return ae>0&&se(Y.charCodeAt(ae))?B(Y,ae-1):B(Y,ae)}e.getCharContainingOffset=U;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(Y){return _.test(Y)}e.containsRTL=X;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return W.test(Y)}e.containsEmoji=z;const K=/^[\t\n\r\x20-\x7E]*$/;function O(Y){return K.test(Y)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=q;function C(Y){for(let ae=0,ue=Y.length;ae<ue;ae++)if($(Y.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=C;function $(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=$;function J(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=J;function Q(Y,ae){if(Y.length<ae)return Y;const ue=/\b/g;let me=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<ae);)me=ue.lastIndex,ue.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=Q;const ne=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function re(Y){return Y&&(Y=Y.replace(ne,""),Y=Y.replace(le,""),Y=Y.replace(oe,"")),Y}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ge(Y){return ce(Y)?Y.substr(1):Y}e.stripUTF8BOM=ge;function de(Y,ae){if(!Y||!ae||Y.length<ae.length)return!1;const ue=ae.length,me=Y.toLowerCase();let be=0,Ae=-1;for(;be<ue;){const Oe=me.indexOf(ae[be],Ae+1);if(Oe<0)return!1;Ae=Oe,be++}return!0}e.fuzzyContains=de;function Ee(Y,ae=!1){return Y?(ae&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ee;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Ie(Y,ae=1){if(ae===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Ie;function ve(Y){const ae=90-65+1;return Y=Y%(2*ae),Y<ae?String.fromCharCode(97+Y):String.fromCharCode(65+Y-ae)}e.singleLetterHash=ve;function ye(Y){return Re.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=ye;function ke(Y,ae){return Y===0?ae!==5&&ae!==7:Y===2&&ae===3?!1:Y===4||Y===2||Y===3||ae===4||ae===2||ae===3?!0:!(Y===8&&(ae===8||ae===9||ae===11||ae===12)||(Y===11||Y===9)&&(ae===9||ae===10)||(Y===12||Y===10)&&ae===10||ae===5||ae===13||ae===7||Y===1||Y===13&&ae===14||Y===6&&ae===6)}e.breakBetweenGraphemeBreakType=ke;var Fe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Re{constructor(){this._data=Ve()}static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,me=ue.length/3;let be=1;for(;be<=me;)if(ae<ue[3*be])be=2*be;else if(ae>ue[3*be+1])be=2*be+1;else return ue[3*be+2];return 0}}Re._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function et(Y,ae){if(Y===0)return 0;const ue=ot(Y,ae);if(ue!==void 0)return ue;const me=T(ae,Y);return Y-=Ge(me),Y}e.getLeftDeleteOffset=et;function ot(Y,ae){let ue=T(ae,Y);for(Y-=Ge(ue);ht(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=T(ae,Y),Y-=Ge(ue)}if(!!J(ue)){if(Y>=0){const me=T(ae,Y);me===8205&&(Y-=Ge(me))}return Y}}function Ge(Y){return Y>=65536?2:1}function ht(Y){return 127995<=Y&&Y<=127999}var tt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={}))}),define(Z[82],x([0,1,25]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(v){return D(v,0)}e.hash=L;function D(v,b){switch(typeof v){case"object":return v===null?M(349,b):Array.isArray(v)?h(v,b):g(v,b);case"string":return E(v,b);case"boolean":return P(v,b);case"number":return M(v,b);case"undefined":return M(937,b);default:return M(617,b)}}e.doHash=D;function M(v,b){return(b<<5)-b+v|0}e.numberHash=M;function P(v,b){return M(v?433:863,b)}function E(v,b){b=M(149417,b);for(let u=0,o=v.length;u<o;u++)b=M(v.charCodeAt(u),b);return b}e.stringHash=E;function h(v,b){return b=M(104579,b),v.reduce((u,o)=>D(o,u),b)}function g(v,b){return b=M(181387,b),Object.keys(v).sort().reduce((u,o)=>(u=E(o,u),D(v[o],u)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=i;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function S(v,b,u=32){const o=u-b,c=~((1<<o)-1);return(v<<b|(c&v)>>>o)>>>0}function p(v,b=0,u=v.byteLength,o=0){for(let c=0;c<u;c++)v[b+c]=o}function t(v,b,u="0"){for(;v.length<b;)v=u+v;return v}function d(v,b=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),b/4)}e.toHexString=d;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const u=b.length;if(u===0)return;const o=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,a,s;for(n!==0?(a=n,s=-1,n=0):(a=b.charCodeAt(0),s=0);;){let r=a;if(w.isHighSurrogate(a))if(s+1<u){const l=b.charCodeAt(s+1);w.isLowSurrogate(l)?(s++,r=w.computeCodePoint(a,l)):r=65533}else{n=a;break}else w.isLowSurrogate(a)&&(r=65533);if(c=this._push(o,c,r),s++,s<u)a=b.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(b,u,o){return o<128?b[u++]=o:o<2048?(b[u++]=192|(o&1984)>>>6,b[u++]=128|(o&63)>>>0):o<65536?(b[u++]=224|(o&61440)>>>12,b[u++]=128|(o&4032)>>>6,b[u++]=128|(o&63)>>>0):(b[u++]=240|(o&1835008)>>>18,b[u++]=128|(o&258048)>>>12,b[u++]=128|(o&4032)>>>6,b[u++]=128|(o&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=y._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,S(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let o=this._h0,c=this._h1,n=this._h2,a=this._h3,s=this._h4,r,l,f;for(let m=0;m<80;m++)m<20?(r=c&n|~c&a,l=1518500249):m<40?(r=c^n^a,l=1859775393):m<60?(r=c&n|c&a|n&a,l=2400959708):(r=c^n^a,l=3395469782),f=S(o,5)+r+s+l+b.getUint32(m*4,!1)&4294967295,s=a,a=n,n=S(c,30),c=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[14],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(k){return Array.isArray(k)}e.isArray=w;function L(k){return typeof k=="string"}e.isString=L;function D(k){return Array.isArray(k)&&k.every(R=>L(R))}e.isStringArray=D;function M(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=M;function P(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=P;function E(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=E;function h(k){return k===!0||k===!1}e.isBoolean=h;function g(k){return typeof k=="undefined"}e.isUndefined=g;function i(k){return!I(k)}e.isDefined=i;function I(k){return g(k)||k===null}e.isUndefinedOrNull=I;function S(k,R){if(!k)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=S;function p(k){if(I(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=p;function t(...k){const R=[];for(let A=0;A<k.length;A++){const F=k[A];if(I(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);R.push(F)}return R}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function y(k){if(!M(k))return!1;for(let R in k)if(d.call(k,R))return!1;return!0}e.isEmptyObject=y;function v(k){return typeof k=="function"}e.isFunction=v;function b(...k){return k.length>0&&k.every(v)}e.areFunctions=b;function u(k,R){const A=Math.min(k.length,R.length);for(let F=0;F<A;F++)o(k[F],R[F])}e.validateConstraints=u;function o(k,R){if(L(R)){if(typeof k!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(v(R)){try{if(k instanceof R)return}catch{}if(!I(k)&&k.constructor===R||R.length===1&&R.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(k){let R=[],A=Object.getPrototypeOf(k);for(;Object.prototype!==A;)R=R.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return R}e.getAllPropertyNames=c;function n(k){const R=[];for(const A of c(k))typeof k[A]=="function"&&R.push(A);return R}e.getAllMethodNames=n;function a(k,R){const A=H=>function(){const te=Array.prototype.slice.call(arguments,0);return R(H,te)};let F={};for(const H of k)F[H]=A(H);return F}e.createProxyObject=a;function s(k){return k===null?void 0:k}e.withNullAsUndefined=s;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function l(k){return class{constructor(){return new Proxy({},{get(R,A){if(R[A])return R[A];throw new Error(`Not Implemented: ${k}->${String(A)}`)}})}}}e.NotImplementedProxy=l;function f(k,R="Unreachable"){throw new Error(R)}e.assertNever=f;function m(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=m}),define(Z[33],x([0,1,8,3,25,14]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(s){return s===47||s===92}e.isPathSeparator=P;function E(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=E;function h(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function g(s,r=w.posix.sep){if(!s)return"";const l=s.length,f=s.charCodeAt(0);if(P(f)){if(P(s.charCodeAt(1))&&!P(s.charCodeAt(2))){let k=3;const R=k;for(;k<l&&!P(s.charCodeAt(k));k++);if(R!==k&&!P(s.charCodeAt(k+1))){for(k+=1;k<l;k++)if(P(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(v(f)&&s.charCodeAt(1)===58)return P(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(P(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=g;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const f=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(f===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,r=L.isWindows){const l=r?I:S;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function d(s,r,l){const f=s===r;return!l||f?f:!s||!r?!1:(0,D.equalsIgnoreCase)(s,r)}e.isEqual=d;function y(s,r,l,f=w.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let k=r.length;return r.charAt(r.length-1)===f&&k--,s.charAt(k)===f}return r.charAt(r.length-1)!==f&&(r+=f),s.indexOf(r)===0}e.isEqualOrParent=y;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function b(s,r){return L.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(r,s)),s=(0,w.normalize)(s),L.isWindows?(s=(0,D.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,D.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=b;function u(s){const r=(0,w.normalize)(s);return L.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===w.posix.sep}e.isRootOrDriveLetter=u;function o(s){return L.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(s){return o(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=n;function a(s){const r=s.split(":");let l,f,m;if(r.forEach(k=>{const R=Number(k);(0,M.isNumber)(R)?f===void 0?f=R:m===void 0&&(m=R):l=l?[l,k].join(":"):k}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[43],x([0,1,14]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const y=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?y[v]=L(d[v]):y[v]=d[v]}),y}e.deepClone=L;function D(d){if(!d||typeof d!="object")return d;const y=[d];for(;y.length>0;){const v=y.shift();Object.freeze(v);for(const b in v)if(M.call(v,b)){const u=v[b];typeof u=="object"&&!Object.isFrozen(u)&&y.push(u)}}return d}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function P(d,y){return E(d,y,new Set)}e.cloneAndChange=P;function E(d,y,v){if((0,w.isUndefinedOrNull)(d))return d;const b=y(d);if(typeof b!="undefined")return b;if((0,w.isArray)(d)){const u=[];for(const o of d)u.push(E(o,y,v));return u}if((0,w.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let o in d)M.call(d,o)&&(u[o]=E(d[o],y,v));return v.delete(d),u}return d}function h(d,y,v=!0){return(0,w.isObject)(d)?((0,w.isObject)(y)&&Object.keys(y).forEach(b=>{b in d?v&&((0,w.isObject)(d[b])&&(0,w.isObject)(y[b])?h(d[b],y[b],v):d[b]=y[b]):d[b]=y[b]}),d):y}e.mixin=h;function g(d,y){if(d===y)return!0;if(d==null||y===null||y===void 0||typeof d!=typeof y||typeof d!="object"||Array.isArray(d)!==Array.isArray(y))return!1;let v,b;if(Array.isArray(d)){if(d.length!==y.length)return!1;for(v=0;v<d.length;v++)if(!g(d[v],y[v]))return!1}else{const u=[];for(b in d)u.push(b);u.sort();const o=[];for(b in y)o.push(b);if(o.sort(),!g(u,o))return!1;for(v=0;v<u.length;v++)if(!g(d[u[v]],y[u[v]]))return!1}return!0}e.equals=g;function i(d){const y=new Set;return JSON.stringify(d,(v,b)=>{if((0,w.isObject)(b)||Array.isArray(b)){if(y.has(b))return"[Circular]";y.add(b)}return b})}e.safeStringify=i;function I(d,y,v){const b=y(d);return typeof b=="undefined"?v:b}e.getOrDefault=I;function S(d,y){const v=Object.create(null);return!d||!y||Object.keys(y).forEach(u=>{const o=d[u],c=y[u];g(o,c)||(v[u]=c)}),v}e.distinct=S;function p(d,y){const v=y.toLowerCase(),b=Object.keys(d).find(u=>u.toLowerCase()===v);return b?d[b]:d[y]}e.getCaseInsensitive=p;function t(d,y){const v=Object.create(null);for(const b of Object.keys(d))y(b,d[b])&&(v[b]=d[b]);return v}e.filter=t}),define(Z[7],x([0,1,8,3]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function E(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(s,r){return!s&&!r?"file":s}function g(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,l,f,m,k,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=h(r,R),this.authority=l||i,this.path=g(this.scheme,f||i),this.query=m||i,this.fragment=k||i,E(this,R))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:f,path:m,query:k,fragment:R}=r;return l===void 0?l=this.scheme:l===null&&(l=i),f===void 0?f=this.authority:f===null&&(f=i),m===void 0?m=this.path:m===null&&(m=i),k===void 0?k=this.query:k===null&&(k=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&f===this.authority&&m===this.path&&k===this.query&&R===this.fragment?this:new d(l,f,m,k,R)}static parse(r,l=!1){const f=S.exec(r);return f?new d(f[2]||i,a(f[4]||i),a(f[5]||i),a(f[7]||i),a(f[9]||i),l):new d(i,i,i,i,i)}static file(r){let l=i;if(L.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const f=r.indexOf(I,2);f===-1?(l=r.substring(2),r=I):(l=r.substring(2,f),r=r.substring(f)||I)}return new d("file",l,r,i,i)}static from(r){const l=new d(r.scheme,r.authority,r.path,r.query,r.fragment);return E(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&r.scheme==="file"?f=p.file(w.win32.join(u(r,!0),...l)).path:f=w.posix.join(r.path,...l),r.with({path:f})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const l=new d(r);return l._formatted=r.external,l._fsPath=r._sep===t?r.fsPath:null,l}}else return r}}e.URI=p;const t=L.isWindows?1:void 0;class d extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,r){let l,f=-1;for(let m=0;m<s.length;m++){const k=s.charCodeAt(m);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)f!==-1&&(l+=encodeURIComponent(s.substring(f,m)),f=-1),l!==void 0&&(l+=s.charAt(m));else{l===void 0&&(l=s.substr(0,m));const R=y[k];R!==void 0?(f!==-1&&(l+=encodeURIComponent(s.substring(f,m)),f=-1),l+=R):f===-1&&(f=m)}}return f!==-1&&(l+=encodeURIComponent(s.substring(f))),l!==void 0?l:s}function b(s){let r;for(let l=0;l<s.length;l++){const f=s.charCodeAt(l);f===35||f===63?(r===void 0&&(r=s.substr(0,l)),r+=y[f]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function u(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=u;function o(s,r){const l=r?b:v;let f="",{scheme:m,authority:k,path:R,query:A,fragment:F}=s;if(m&&(f+=m,f+=":"),(k||m==="file")&&(f+=I,f+=I),k){let H=k.indexOf("@");if(H!==-1){const te=k.substr(0,H);k=k.substr(H+1),H=te.indexOf(":"),H===-1?f+=l(te,!1):(f+=l(te.substr(0,H),!1),f+=":",f+=l(te.substr(H+1),!1)),f+="@"}k=k.toLowerCase(),H=k.indexOf(":"),H===-1?f+=l(k,!1):(f+=l(k.substr(0,H),!1),f+=k.substr(H))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const H=R.charCodeAt(1);H>=65&&H<=90&&(R=`/${String.fromCharCode(H+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const H=R.charCodeAt(0);H>=65&&H<=90&&(R=`${String.fromCharCode(H+32)}:${R.substr(2)}`)}f+=l(R,!0)}return A&&(f+="?",f+=l(A,!1)),F&&(f+="#",f+=r?F:v(F,!1)),f}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(n)?s.replace(n,r=>c(r)):s}}),define(Z[110],x([0,1,7]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(g){const i=g;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function D(g){const i=[];let I;try{const S=JSON.parse(g.arguments),p=S[S.length-1];p&&p.__$stack&&(S.pop(),I=p.__$stack),i.push(...S)}catch(S){i.push("Unable to log remote console arguments",g.arguments)}return{args:i,stack:I}}e.parse=D;function M(g){if(typeof g!="string")return M(D(g).stack);const i=g;if(i){const I=P(i),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(S&&S.length===4)return{uri:w.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=M;function P(g){if(!g)return g;const i=g.indexOf(`
`);return i===-1?g:g.substring(0,i)}function E(g,i){const{args:I,stack:S}=D(g),p=typeof I[0]=="string"&&I.length===1;let t=P(S);t&&(t=`(${t.trim()})`);let d=[];if(typeof I[0]=="string"?t&&p?d=[`%c[${i}] %c${I[0]} %c${t}`,h("blue"),h(""),h("grey")]:d=[`%c[${i}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:d=[`%c[${i}]%`,h("blue"),...I],t&&!p&&d.push(t),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,d)}e.log=E;function h(g){return`color: ${g}`}});var Et=this&&this.__classPrivateFieldSet||function(j,e,w,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(j,w):D?D.value=w:e.set(j,w),w},qe=this&&this.__classPrivateFieldGet||function(j,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(j):L?L.value:e.get(j)};define(Z[40],x([0,1,31,25,7]),function(j,e,w,L,D){"use strict";var M,P,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function h(s,r,l){let f=s.get(r);return f===void 0&&(f=l,s.set(r,f)),f}e.getOrSet=h;function g(s){const r=[];return s.forEach((l,f)=>{r.push(`${f} => ${l}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=g;function i(s){const r=[];return s.forEach(l=>{r.push(l)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return l-f}value(){return this._value[this._pos]}}e.StringIterator=I;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class p{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var t;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(t||(t={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(v||(v={}));class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new d(r))}static forPaths(){return new b(new p)}static forStrings(){return new b(new I)}static forConfigKeys(){return new b(new S)}clear(){this._root=void 0}fill(r,l){if(l){const f=l.slice(0);(0,w.shuffle)(f);for(let m of f)this.set(m,r)}else{const f=r.slice(0);(0,w.shuffle)(f);for(let m of f)this.set(m[0],m[1])}}set(r,l){const f=this._iter.reset(r);let m;this._root||(this._root=new y,this._root.segment=f.value());const k=[];for(m=this._root;;){const A=f.cmp(m.segment);if(A>0)m.left||(m.left=new y,m.left.segment=f.value()),k.push([-1,m]),m=m.left;else if(A<0)m.right||(m.right=new y,m.right.segment=f.value()),k.push([1,m]),m=m.right;else if(f.hasNext())f.next(),m.mid||(m.mid=new y,m.mid.segment=f.value()),k.push([0,m]),m=m.mid;else break}const R=m.value;m.value=l,m.key=r;for(let A=k.length-1;A>=0;A--){const F=k[A][1];F.updateHeight();const H=F.balanceFactor();if(H<-1||H>1){const te=k[A][0],se=k[A+1][0];if(te===1&&se===1)k[A][1]=F.rotateLeft();else if(te===-1&&se===-1)k[A][1]=F.rotateRight();else if(te===1&&se===-1)F.right=k[A+1][1]=k[A+1][1].rotateRight(),k[A][1]=F.rotateLeft();else if(te===-1&&se===1)F.left=k[A+1][1]=k[A+1][1].rotateLeft(),k[A][1]=F.rotateRight();else throw new Error;if(A>0)switch(k[A-1][0]){case-1:k[A-1][1].left=k[A][1];break;case 1:k[A-1][1].right=k[A][1];break;case 0:k[A-1][1].mid=k[A][1];break}else this._root=k[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let f=this._root;for(;f;){const m=l.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else break}return f}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const f=this._iter.reset(r),m=[];let k=this._root;for(;k;){const R=f.cmp(k.segment);if(R>0)m.push([-1,k]),k=k.left;else if(R<0)m.push([1,k]),k=k.right;else if(f.hasNext())f.next(),m.push([0,k]),k=k.mid;else break}if(!!k){if(l?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const R=this._min(k.right),{key:A,value:F,segment:H}=R;this._delete(R.key,!1),k.key=A,k.value=F,k.segment=H}else{const R=k.left??k.right;if(m.length>0){const[A,F]=m[m.length-1];switch(A){case-1:F.left=R;break;case 0:F.mid=R;break;case 1:F.right=R;break}}else this._root=R}for(let R=m.length-1;R>=0;R--){const A=m[R][1];A.updateHeight();const F=A.balanceFactor();if(F>1?(A.right.balanceFactor()>=0||(A.right=m[R+1][1]=m[R+1][1].rotateRight()),m[R][1]=A.rotateLeft()):F<-1&&(A.left.balanceFactor()<=0||(A.left=m[R+1][1]=m[R+1][1].rotateLeft()),m[R][1]=A.rotateRight()),R>0)switch(m[R-1][0]){case-1:m[R-1][1].left=m[R][1];break;case 1:m[R-1][1].right=m[R][1];break;case 0:m[R-1][1].mid=m[R][1];break}else this._root=m[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const l=this._iter.reset(r);let f=this._root,m;for(;f;){const k=l.cmp(f.segment);if(k>0)f=f.left;else if(k<0)f=f.right;else if(l.hasNext())l.next(),m=f.value||m,f=f.mid;else break}return f&&f.value||m}findSuperstr(r){const l=this._iter.reset(r);let f=this._root;for(;f;){const m=l.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[l,f]of this)r(f,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=l=>{if(!l)return!0;const f=l.balanceFactor();return f<-1||f>1?!1:r(l.left)&&r(l.right)};return r(this._root)}}e.TernarySearchTree=b;class u{constructor(r,l){this[M]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=l??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),l),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[f,m]of this.map)r(m,D.URI.parse(f),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield D.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[D.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[D.URI.parse(r[0]),r[1]]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class c{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const f=this._map.get(r);if(!!f)return l!==0&&this.touch(f,l),f.value}set(r,l,f=0){let m=this._map.get(r);if(m)m.value=l,f!==0&&this.touch(m,f);else{switch(m={key:r,value:l,next:void 0,previous:void 0},f){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const f=this._state;let m=this._head;for(;m;){if(l?r.bind(l)(m.value,m.key,this):r(m.value,m.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,l=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return m}values(){const r=this,l=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return m}entries(){const r=this,l=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return m}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,f=this.size;for(;l&&f>r;)this._map.delete(l.key),l=l.next,f--;this._head=l,this._size=f,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,f=r.previous;if(!l||!f)throw new Error("Invalid list");l.previous=f,f.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const f=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(f.previous=m,m.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const f=r.next,m=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=m,m.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,f)=>{r.push([f,l])}),r}fromJSON(r){this.clear();for(const[l,f]of r)this.set(l,f)}}e.LinkedMap=c;class n extends c{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class a{constructor(r){E.set(this,void 0),Et(this,E,r,"f")}get size(){return qe(this,E,"f").size}forEach(r,l){qe(this,E,"f").forEach(r,l)}get(r){return qe(this,E,"f").get(r)}has(r){return qe(this,E,"f").has(r)}entries(){return qe(this,E,"f").entries()}keys(){return qe(this,E,"f").keys()}values(){return qe(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return qe(this,E,"f").entries()}}e.ReadonlyMapView=a}),define(Z[111],x([0,1,17,25,7]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,h)}e.stringify=M;function P(i){let I=JSON.parse(i);return I=g(I),I}e.parse=P;var E;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function h(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function g(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof w.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let S=0;S<i.length;++S)i[S]=g(i[S],I+1);else for(const S in i)Object.hasOwnProperty.call(i,S)&&(i[S]=g(i[S],I+1))}return i}e.revive=g}),define(Z[10],x([0,1,3,7]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,g,i){this._hosts[h]=g,this._ports[h]=i}setConnectionToken(h,g){this._connectionTokens[h]=g}rewrite(h){if(this._delegate)return this._delegate(h);const g=h.authority;let i=this._hosts[g];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[g],S=this._connectionTokens[g];let p=`path=${encodeURIComponent(h.path)}`;return typeof S=="string"&&(p+=`&tkn=${encodeURIComponent(S)}`),L.URI.from({scheme:w.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new M;class P{asBrowserUri(h,g){const i=this.toUri(h,g);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(h,g){const i=this.toUri(h,g);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(h,g){return L.URI.isUri(h)?h:L.URI.parse(g.toUrl(h))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Z[69],x([0,1,40]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new w.LRUCache(1e4);function D(g){return h(g,"NFC",L)}e.normalizeNFC=D;const M=new w.LRUCache(1e4);function P(g){return h(g,"NFD",M)}e.normalizeNFD=P;const E=/[^\u0000-\u0080]/;function h(g,i,I){if(!g)return g;const S=I.get(g);if(S)return S;let p;return E.test(g)?p=g.normalize(i):p=g,I.set(g,p),p}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(i){return P(i).replace(g,"")}}()}),define(Z[15],x([0,1,33,10,8,3,25,7]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(p){return(0,E.uriToFsPath)(p,!0)}e.originalFSPath=h;class g{constructor(t){this._ignorePathCasing=t}compare(t,d,y=!1){return t===d?0:(0,P.compare)(this.getComparisonKey(t,y),this.getComparisonKey(d,y))}isEqual(t,d,y=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,y)===this.getComparisonKey(d,y)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,y=!1){if(t.scheme===d.scheme){if(t.scheme===L.Schemas.file)return w.isEqualOrParent(h(t),h(d),this._ignorePathCasing(t))&&t.query===d.query&&(y||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return w.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(y||t.fragment===d.fragment)}return!1}joinPath(t,...d){return E.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===L.Schemas.file?d=E.URI.file(D.dirname(h(t))).path:(d=D.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===L.Schemas.file?d=E.URI.file(D.normalize(h(t))).path:d=D.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===L.Schemas.file){const b=D.relative(h(t),h(d));return M.isWindows?w.toSlashes(b):b}let y=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let b=0;for(const u=Math.min(y.length,v.length);b<u&&!(y.charCodeAt(b)!==v.charCodeAt(b)&&y.charAt(b).toLowerCase()!==v.charAt(b).toLowerCase());b++);y=v.substr(0,b)+y.substr(b)}return D.posix.relative(y,v)}resolvePath(t,d){if(t.scheme===L.Schemas.file){const y=E.URI.file(D.resolve(h(t),d));return t.with({authority:y.authority,path:y.path})}return d=w.toPosixPath(d),t.with({path:D.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||(0,P.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=D.sep){if(t.scheme===L.Schemas.file){const y=h(t);return y.length>w.getRoot(y).length&&y[y.length-1]===d}else{const y=t.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=D.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=D.sep){let y=!1;if(t.scheme===L.Schemas.file){const v=h(t);y=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;y=v.length===1&&v.charCodeAt(v.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(p=>p.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new g(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,t){const d=[];for(let y=0;y<p.length;y++){const v=t(p[y]);p.some((b,u)=>u===y?!1:(0,e.isEqualOrParent)(v,t(b)))||d.push(p[y])}return d}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(d){const y=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[o,c]=u.split(":");o&&c&&y.set(o,c)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&y.set(p.META_DATA_MIME,b),y}p.parseMetaData=t})(I=e.DataUri||(e.DataUri={}));function S(p,t,d){if(t){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:d,authority:t,path:y})}return p.with({scheme:d})}e.toLocalResource=S}),define(Z[9],x([0,1,23,16,4,2,15]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(N){return!!N&&typeof N.then=="function"}e.isThenable=E;function h(N){const B=new w.CancellationTokenSource,U=N(B.token),_=new Promise((X,W)=>{const z=B.token.onCancellationRequested(()=>{z.dispose(),B.dispose(),W((0,L.canceled)())});Promise.resolve(U).then(K=>{z.dispose(),B.dispose(),X(K)},K=>{z.dispose(),B.dispose(),W(K)})});return new class{cancel(){B.cancel()}then(X,W){return _.then(X,W)}catch(X){return this.then(void 0,X)}finally(X){return _.finally(X)}}}e.createCancelablePromise=h;function g(N,B,U){return Promise.race([N,new Promise(_=>B.onCancellationRequested(()=>_(U)))])}e.raceCancellation=g;async function i(N){let B=-1;const U=N.map((X,W)=>X.then(z=>(B=W,z))),_=await Promise.race(U);return N.forEach((X,W)=>{W!==B&&X.cancel()}),_}e.raceCancellablePromises=i;function I(N,B,U){let _;const X=setTimeout(()=>{_?.(void 0),U?.()},B);return Promise.race([N.finally(()=>clearTimeout(X)),new Promise(W=>_=W)])}e.raceTimeout=I;function S(N){return new Promise((B,U)=>{const _=N();E(_)?_.then(B,U):B(_)})}e.asPromise=S;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(U,U).then(_)})}return new Promise((U,_)=>{this.queuedPromise.then(U,_)})}return this.activePromise=B(),new Promise((U,_)=>{this.activePromise.then(X=>{this.activePromise=null,U(X)},X=>{this.activePromise=null,_(X)})})}}e.Throttler=p;class t{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=t;class d{constructor(){this.promiseMap=new Map}queue(B,U){const X=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(B)===X&&this.promiseMap.delete(B)});return this.promiseMap.set(B,X),X}}e.SequencerByKey=d;class y{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,U=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,X)=>{this.doResolve=_,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class v{constructor(B){this.delayer=new y(B),this.throttler=new p}trigger(B,U){return this.delayer.trigger(()=>this.throttler.queue(B),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class b{constructor(){this._isOpen=!1,this._promise=new Promise((B,U)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class u extends b{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(N,B){return B?new Promise((U,_)=>{const X=setTimeout(()=>{W.dispose(),U()},N),W=B.onCancellationRequested(()=>{clearTimeout(X),W.dispose(),_((0,L.canceled)())})}):h(U=>o(N,U))}e.timeout=o;function c(N,B=0){const U=setTimeout(N,B);return(0,M.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=c;function n(N){const B=[];let U=0;const _=N.length;function X(){return U<_?N[U++]():null}function W(z){z!=null&&B.push(z);const K=X();return K?K.then(W):Promise.resolve(B)}return Promise.resolve(null).then(W)}e.sequence=n;function a(N,B=_=>!!_,U=null){let _=0;const X=N.length,W=()=>{if(_>=X)return Promise.resolve(U);const z=N[_++];return Promise.resolve(z()).then(O=>B(O)?Promise.resolve(O):W())};return W()}e.first=a;function s(N,B=_=>!!_,U=null){if(N.length===0)return Promise.resolve(U);let _=N.length;const X=()=>{_=-1;for(const W of N)W.cancel?.()};return new Promise((W,z)=>{for(const K of N)K.then(O=>{--_>=0&&B(O)?(X(),W(O)):_===0&&W(U)}).catch(O=>{--_>=0&&(X(),z(O))})})}e.firstParallel=s;class r{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((U,_)=>{this.outstandingPromises.push({factory:B,c:U,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class f{constructor(){this.queues=new Map}queueFor(B,U=P.extUri){const _=U.getComparisonKey(B);let X=this.queues.get(_);return X||(X=new l,D.Event.once(X.onFinished)(()=>{X?.dispose(),this.queues.delete(_)}),this.queues.set(_,X)),X}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(B,U){this._token=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},U)}setIfNotSet(B,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},U))}}e.TimeoutTimer=m;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setInterval(()=>{B()},U)}}e.IntervalTimer=k;class R{constructor(B,U){this.timeoutToken=-1,this.runner=B,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class A{constructor(B,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class F extends R{constructor(B,U){super(B,U);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class H extends M.Disposable{constructor(B,U,_,X){super();this.maxWorkChunkSize=B,this.maxPendingWork=U,this.throttleDelay=_,this.handler=X,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const B=setTimeout(()=>{const _=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0,clearTimeout(B))}}}:e.runWhenIdle=(N,B)=>{const U=requestIdleCallback(N,typeof B=="number"?{timeout:B}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(U))}}}}();class te{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function se(N,B,U){let _;for(let X=0;X<U;X++)try{return await N()}catch(W){_=W,await o(B)}throw _}e.retry=se;class G{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,U,_){return this._pending={taskId:B,cancel:()=>_?.(),promise:U},U.then(()=>this.donePending(B),()=>this.donePending(B)),U}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let U,_;const X=new Promise((W,z)=>{U=W,_=z});this._next={run:B,promise:X,promiseResolve:U,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class T{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,U)=>{this.completeCallback=B,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(U=>{this.completeCallback(B),this.resolved=!0,U()})}error(B){return new Promise(U=>{this.errorCallback(B),this.rejected=!0,U()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=T;var V;(function(N){async function B(_){let X;const W=await Promise.all(_.map(z=>z.then(K=>K,K=>{X||(X=K)})));if(typeof X!="undefined")throw X;return W}N.settled=B;function U(_){return new Promise(async(X,W)=>{try{await _(X,W)}catch(z){W(z)}})}N.withAsyncBody=U})(V=e.Promises||(e.Promises={}))}),define(Z[34],x([0,1,33,10,8,3,15,25,7]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(r,l,f){if(typeof r=="string"&&(r=h.URI.file(r)),f){const k=f.getWorkspaceFolder(r);if(k){const R=f.getWorkspace().folders.length>1;let A;if((0,P.isEqual)(k.uri,r)?A="":A=(0,P.relativePath)(k.uri,r),R){const F=k.name?k.name:(0,P.basename)(k.uri);A=A?F+" \u2022 "+A:F}return A}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(r.fsPath))return(0,D.normalize)(I(r.fsPath));let m=(0,D.normalize)(r.fsPath);return!M.isWindows&&l?.userHome&&(m=p(m,l.userHome.fsPath)),m}e.getPathLabel=g;function i(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const l=(0,P.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,w.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=i;function I(r){return(0,w.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let S=Object.create(null);function p(r,l){if(M.isWindows||!r||!l)return r;let f=S.original===l?S.normalized:void 0;return f||(f=`${(0,E.rtrim)(l,D.posix.sep)}${D.posix.sep}`,S={original:l,normalized:f}),(M.isLinux?r.startsWith(f):(0,E.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=p;function t(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=t;const d="\u2026",y="\\\\",v="~";function b(r,l=D.sep){const f=new Array(r.length);let m=!1;for(let k=0;k<r.length;k++){let R=r[k];if(R===""){f[k]=`.${l}`;continue}if(!R){f[k]=R;continue}m=!0;let A="";R.indexOf(y)===0?(A=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length)):R.indexOf(l)===0?(A=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(v)===0&&(A=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const F=R.split(l);for(let H=1;m&&H<=F.length;H++)for(let te=F.length-H;m&&te>=0;te--){m=!1;let se=F.slice(te,te+H).join(l);for(let G=0;!m&&G<r.length;G++)if(G!==k&&r[G]&&r[G].indexOf(se)>-1){const ee=te+H===F.length,T=te>0&&r[G].indexOf(l)>-1?l+se:se,V=r[G].endsWith(T);m=!ee||V}if(!m){let G="";(F[0].endsWith(":")||A!=="")&&(te===1&&(te=0,H++,se=F[0]+l+se),te>0&&(G=F[0]+l),G=A+G),te>0&&(G=G+d+l),G=G+se,te+H<F.length&&(G=G+l+d),f[k]=G}}m&&(f[k]=R)}return f}e.shorten=b;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function o(r,l=Object.create(null)){const f=[];let m=!1,k="";for(const R of r)if(R==="$"||m&&R==="{")k&&f.push({value:k,type:u.TEXT}),k="",m=!0;else if(R==="}"&&m){const A=l[k];if(typeof A=="string")A.length&&f.push({value:A,type:u.VARIABLE});else if(A){const F=f[f.length-1];(!F||F.type!==u.SEPARATOR)&&f.push({value:A.label,type:u.SEPARATOR})}k="",m=!1}else k+=R;return k&&!m&&f.push({value:k,type:u.TEXT}),f.filter((R,A)=>{if(R.type===u.SEPARATOR){const F=f[A-1],H=f[A+1];return[F,H].every(te=>te&&(te.type===u.VARIABLE||te.type===u.TEXT)&&te.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function c(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function n(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function a(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=a;function s(r){const l=r.indexOf("/")!==-1?D.posix:D.win32,f=l.basename(r),m=l.dirname(r);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(Z[28],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(h){return w.test(h)}e.isUUID=L;const D=new Uint8Array(16),M=[];for(let h=0;h<256;h++)M.push(h.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(h){for(let g=0;g<h.length;g++)h[g]=Math.floor(Math.random()*256);return h};function E(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let h=0,g="";return g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g+="-",g+=M[D[h++]],g+=M[D[h++]],g+="-",g+=M[D[h++]],g+=M[D[h++]],g+="-",g+=M[D[h++]],g+=M[D[h++]],g+="-",g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g+=M[D[h++]],g}e.generateUuid=E}),define(Z[112],x([0,1,61,29,42]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(P,E){if(await new Promise((i,I)=>{const S=L.createReadStream(P),p=w.createHash("sha1");S.pipe(p);const t=(0,D.once)((d,y)=>{S.removeAllListeners(),p.removeAllListeners(),d?I(d):i(y)});S.once("error",t),S.once("end",t),p.once("error",t),p.once("data",d=>t(void 0,d.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[113],x([0,1,241]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new w.StringDecoder(M),this.remaining=null}write(M){const P=[],E=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(E.length<1)return P;let h=0,g,i=h;for(;i<E.length;)if(g=E.charCodeAt(i),g===13||g===10){if(P.push(E.substring(h,i)),i++,i<E.length){const I=g;g=E.charCodeAt(i),(I===13&&g===10||I===10&&g===13)&&i++}h=i}else i++;return this.remaining=h<E.length?E.substr(h):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(Z[114],x([0,1,26]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(E){const h=E.replace(/\-/g,":").toLowerCase();return!L.has(h)}function M(){return new Promise(async(E,h)=>{const g=setTimeout(()=>h("Unable to retrieve mac address (timeout after 10s)"),1e4);try{E(await P())}catch(i){h(i)}finally{clearTimeout(g)}})}e.getMac=M;function P(){return new Promise((E,h)=>{try{const g=(0,w.networkInterfaces)();for(let i in g){const I=g[i];if(I){for(const{mac:S}of I)if(D(S))return E(S)}}h("Unable to retrieve mac address (unexpected format)")}catch(g){h(g)}})}}),define(Z[70],x([0,1,26,16,40,28,114]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const S=(0,w.networkInterfaces)();for(let p in S){const t=S[p];if(t)for(const{mac:d,internal:y}of t)y||(I+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let E;async function h(){return E||(E=(async()=>await g()||M.generateUuid())()),E}e.getMachineId=h;async function g(){try{const i=await new Promise((S,p)=>{j(["crypto"],S,p)}),I=await(0,P.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[20],x([0,1,29,26,115,9,33,69,8,3,15,7,28]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function t(T,V=p.UNLINK){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return V===p.UNLINK?y(T):d(T)}async function d(T){try{const V=(0,h.join)((0,L.tmpdir)(),(0,S.generateUuid)());try{await e.Promises.rename(T,V)}catch(N){return y(T)}y(V).catch(N=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function v(T){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(T,{recursive:!0})}e.rimrafSync=v;async function b(T,V){return c(await(V?u(T):(0,D.promisify)(w.readdir)(T)))}async function u(T){try{return await(0,D.promisify)(w.readdir)(T,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const V=[],N=await b(T);for(const B of N){let U=!1,_=!1,X=!1;try{const W=await e.Promises.lstat((0,h.join)(T,B));U=W.isFile(),_=W.isDirectory(),X=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:B,isFile:()=>U,isDirectory:()=>_,isSymbolicLink:()=>X})}return V}function o(T){return c(w.readdirSync(T))}e.readdirSync=o;function c(T){return T.map(V=>typeof V=="string"?g.isMacintosh?(0,E.normalizeNFC)(V):V:(V.name=g.isMacintosh?(0,E.normalizeNFC)(V.name):V.name,V))}async function n(T){const V=await b(T),N=[];for(const B of V)await s.existsDirectory((0,h.join)(T,B))&&N.push(B);return N}function a(T,V=1e3){return new Promise(N=>{let B=!1;const U=setInterval(()=>{B||(B=!0,w.access(T,_=>{B=!1,_&&(clearInterval(U),N(void 0))}))},V)})}e.whenDeleted=a;var s;(function(T){async function V(U){let _;try{if(_=await e.Promises.lstat(U),!_.isSymbolicLink())return{stat:_}}catch(X){}try{return{stat:await e.Promises.stat(U),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(g.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw W}throw X}}T.stat=V;async function N(U){try{const{stat:_,symbolicLink:X}=await T.stat(U);return _.isFile()&&X?.dangling!==!0}catch(_){}return!1}T.existsFile=N;async function B(U){try{const{stat:_,symbolicLink:X}=await T.stat(U);return _.isDirectory()&&X?.dangling!==!0}catch(_){}return!1}T.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new M.ResourceQueue;function l(T,V,N){return r.queueFor(I.URI.file(T),i.extUriBiasedIgnorePathCase).queue(()=>{const B=R(N);return new Promise((U,_)=>m(T,V,B,X=>X?_(X):U()))})}let f=!0;function m(T,V,N,B){if(!f)return w.writeFile(T,V,{mode:N.mode,flag:N.flag},B);w.open(T,N.flag,N.mode,(U,_)=>{if(U)return B(U);w.writeFile(_,V,X=>{if(X)return w.close(_,()=>B(X));w.fdatasync(_,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),w.close(_,z=>B(z))))})})}function k(T,V,N){const B=R(N);if(!f)return w.writeFileSync(T,V,{mode:B.mode,flag:B.flag});const U=w.openSync(T,B.flag,B.mode);try{w.writeFileSync(U,V);try{w.fdatasyncSync(U)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),f=!1}}finally{w.closeSync(U)}}e.writeFileSync=k;function R(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function A(T,V){if(T===V)return;async function N(B){try{const U=await e.Promises.lstat(B);if(U.isDirectory()||U.isSymbolicLink())return;await e.Promises.utimes(B,U.atime,new Date)}catch(U){}}try{await e.Promises.rename(T,V),await N(V)}catch(B){if(T.toLowerCase()!==V.toLowerCase()&&B.code==="EXDEV"||T.endsWith("."))await F(T,V,{preserveSymlinks:!1}),await t(T,p.MOVE),await N(V);else throw B}}async function F(T,V,N){return te(T,V,{root:{source:T,target:V},options:N,handledSourcePaths:new Set})}const H=511;async function te(T,V,N){if(N.handledSourcePaths.has(T))return;N.handledSourcePaths.add(T);const{stat:B,symbolicLink:U}=await s.stat(T);if(U){if(N.options.preserveSymlinks)try{return await ee(T,V,N)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(U.dangling)return}return B.isDirectory()?se(T,V,B.mode&H,N):G(T,V,B.mode&H)}async function se(T,V,N,B){await e.Promises.mkdir(V,{recursive:!0,mode:N});const U=await b(T);for(const _ of U)await te((0,h.join)(T,_),(0,h.join)(V,_),B)}async function G(T,V,N){await e.Promises.copyFile(T,V),await e.Promises.chmod(V,N)}async function ee(T,V,N){let B=await e.Promises.readlink(T);(0,P.isEqualOrParent)(B,N.root.source,!g.isLinux)&&(B=(0,h.join)(N.root.target,B.substr(N.root.source.length+1))),await e.Promises.symlink(B,V)}e.Promises=new class{get access(){return(0,D.promisify)(w.access)}get stat(){return(0,D.promisify)(w.stat)}get lstat(){return(0,D.promisify)(w.lstat)}get utimes(){return(0,D.promisify)(w.utimes)}get read(){return(0,D.promisify)(w.read)}get readFile(){return(0,D.promisify)(w.readFile)}get write(){return(0,D.promisify)(w.write)}get appendFile(){return(0,D.promisify)(w.appendFile)}get fdatasync(){return(0,D.promisify)(w.fdatasync)}get truncate(){return(0,D.promisify)(w.truncate)}get rename(){return(0,D.promisify)(w.rename)}get copyFile(){return(0,D.promisify)(w.copyFile)}get open(){return(0,D.promisify)(w.open)}get close(){return(0,D.promisify)(w.close)}get symlink(){return(0,D.promisify)(w.symlink)}get readlink(){return(0,D.promisify)(w.readlink)}get chmod(){return(0,D.promisify)(w.chmod)}get mkdir(){return(0,D.promisify)(w.mkdir)}get unlink(){return(0,D.promisify)(w.unlink)}get rmdir(){return(0,D.promisify)(w.rmdir)}get realpath(){return(0,D.promisify)(w.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return n}get writeFile(){return l}get rm(){return t}get move(){return A}get copy(){return F}}}),define(Z[83],x([0,1,29,8,25,20]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const I=(0,L.dirname)(i);if(i===I)return i;const S=((0,L.basename)(i)||i).toLowerCase();try{const t=(0,M.readdirSync)(I).filter(d=>d.toLowerCase()===S);if(t.length===1){const d=P(I);if(d)return(0,L.join)(d,t[0])}else if(t.length>1){const d=t.indexOf(S);if(d>=0){const y=P(I);if(y)return(0,L.join)(y,t[d])}}}catch(p){}return null}e.realcaseSync=P;async function E(i){try{return await M.Promises.realpath(i)}catch(I){const S=g(i);return await M.Promises.access(S,w.constants.R_OK),S}}e.realpath=E;function h(i){try{return w.realpathSync(i)}catch(I){const S=g(i);return w.accessSync(S,w.constants.R_OK),S}}e.realpathSync=h;function g(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[116],x([0,1,62]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(E,h,g,i=1){let I=!1;return new Promise(S=>{const p=setTimeout(()=>{if(!I)return I=!0,S(0)},g);D(E,h,i,t=>{if(!I)return I=!0,clearTimeout(p),S(t)})})}e.findFreePort=L;function D(E,h,g,i){if(h===0)return i(0);const I=new w.Socket;I.once("connect",()=>(P(I),D(E+g,h-1,g,i))),I.once("data",()=>{}),I.once("error",S=>(P(I),S.code!=="ECONNREFUSED"?D(E+g,h-1,g,i):i(E))),I.connect(E,"127.0.0.1")}function M(E,h,g){let i=!1,I,S=1;const p=w.createServer({pauseOnConnect:!0});function t(d,y){i||(i=!0,p.removeAllListeners(),p.close(),I&&clearTimeout(I),y(d))}return new Promise(d=>{I=setTimeout(()=>{t(0,d)},g),p.on("listening",()=>{t(E,d)}),p.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&S<h?(E++,S++,p.listen(E,"127.0.0.1")):t(0,d)}),p.on("close",()=>{t(0,d)}),p.listen(E,"127.0.0.1")})}e.findFreePortFaster=M;function P(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),define(Z[117],x([0,1,26,8,20]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(h||(h={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(c,n,a){this.exePath=c,this.displayName=n,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:c=!1}={}){const n=S({useAlternateBitness:o});if(!n)return null;const a=L.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let s=-1,r=null;for(const m of await D.Promises.readdir(a)){let k=-1;if(c){const A=m.indexOf("-");if(A<0)continue;const F=m.substring(0,A);if(!M.test(F)||m.substring(A+1)!=="preview")continue;k=parseInt(F,10)}else{if(!M.test(m))continue;k=parseInt(m,10)}if(k<=s)continue;const R=L.join(a,m,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(r=R,s=k)}if(!r)return null;const l=n.includes("x86")?" (x86)":"",f=c?" Preview":"";return new I(r,`PowerShell${f}${l}`,!0)}async function t({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:a}=o?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(n.test(s)){const r=L.join(c,s,"pwsh.exe");return new I(r,a)}return null}function d(){const o=L.join(w.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function y(){const o=L.join(process.env.windir,g===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*v(){let o=await p();o&&(yield o),o=await p({useAlternateBitness:!0}),o&&(yield o),o=await t(),o&&(yield o),o=d(),o&&(yield o),o=await p({findPreview:!0}),o&&(yield o),o=await t({findPreview:!0}),o&&(yield o),o=await p({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=y(),o&&(yield o)}async function*b(){for await(const o of v())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=b;async function u(){for await(const o of b())return o;return null}e.getFirstAvailablePowerShellInstallation=u}),define(Z[84],x([0,1,44,10]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((E,h)=>{let g;const i=new Map;function I(p,t,d,y,v){const b=i.get(t);if(p===P||b){const u={name:S(d),cmd:d,pid:p,ppid:t,load:y,mem:v};i.set(p,u),p===P&&(g=u),b&&(b.children||(b.children=[]),b.children.push(u),b.children.length>1&&(b.children=b.children.sort((o,c)=>o.pid-c.pid)))}}function S(p){const t=/--disable-blink-features=Auxclick/,d=/\\watcher\\win32\\CodeHelper\.exe/,y=/--crashes-directory/,v=/\\pipe\\winpty-control/,b=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(d.exec(p))return"watcherService ";if(y.exec(p))return"electron-crash-reporter";if(v.exec(p))return"winpty-process";if(b.exec(p))return"console-window-host (Windows internal process)";let o=u.exec(p);if(o&&o.length===2)return o[1]==="renderer"?t.exec(p)?"shared-process":"window":o[1];const c=/[a-zA-Z-]+\.js/g;let n="";do o=c.exec(p),o&&(n+=o+" ");while(o);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{j(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(P,d=>{t.getProcessCpuUsage(d,y=>{const v=new Map;y.forEach(b=>{const u=p(b.commandLine||"");v.set(b.pid,{name:S(u),cmd:u,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),g=v.get(P),g?(v.forEach(b=>{const u=v.get(b.ppid);u&&(u.children||(u.children=[]),u.children.push(b))}),v.forEach(b=>{b.children&&(b.children=b.children.sort((u,o)=>u.pid-o.pid))}),E(g)):h(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[g];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);y+=" "+d.join(" "),(0,w.exec)(y,{},(v,b,u)=>{if(v||u)h(v||new Error(u.toString()));else{const o=b.toString().split(`
`);for(let c=0;c<d.length;c++){const n=i.get(d[c]);n.load=parseFloat(o[c])}if(!g){h(new Error(`Root process ${P} not found`));return}E(g)}})};(0,w.exec)("which ps",{},(t,d,y)=>{if(t||y)if(process.platform!=="linux")h(t||new Error(y.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,w.exec)(v,{},(b,u,o)=>{b||o?h(b||new Error(o.toString())):(M(u,I),p())})}else{const v=d.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,o,c)=>{u||c&&!c.includes("screen size is bogus")?h(u||new Error(c.toString())):(M(o,I),process.platform==="linux"?p():g?E(g):h(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function M(P,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=P.toString().split(`
`);for(const i of g){const I=h.exec(i.trim());I&&I.length===6&&E(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Z[118],x([0,1,29,23,33,2,69,8,3,20]),function(j,e,w,L,D,M,P,E,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(t,d,y){return S({path:t,isDirectory:!1},d,y)}e.watchFile=i;function I(t,d,y){return S({path:t,isDirectory:!0},d,y)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function S(t,d,y){if(h.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return y(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=(0,E.basename)(t.path),b=new Map;let u=!1,o=[(0,M.toDisposable)(()=>{b.forEach(c=>(0,M.dispose)(c)),b.clear()})];try{const c=(0,w.watch)(t.path);o.push((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const n=new Set;t.isDirectory&&g.Promises.readdir(t.path).then(a=>a.forEach(s=>n.add(s))),c.on("error",(a,s)=>{u||y(`Failed to watch ${t.path} for changes using fs.watch() (${a}, ${s})`)}),c.on("change",(a,s)=>{if(u)return;let r="";if(s&&(r=s.toString(),h.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const l=t.isDirectory?(0,E.join)(t.path,r):t.path;if(t.isDirectory)if(a==="rename"){const f=b.get(l);f&&(0,M.dispose)(f);const m=setTimeout(async()=>{b.delete(l);const k=await g.Promises.exists(l);if(u)return;let R;k?n.has(r)?R="changed":(R="added",n.add(r)):(n.delete(r),R="deleted"),d(R,l)},e.CHANGE_BUFFER_DELAY);b.set(l,(0,M.toDisposable)(()=>clearTimeout(m)))}else{let f;n.has(r)?f="changed":(f="added",n.add(r)),d(f,l)}else if(a==="rename"||r!==v){const f=setTimeout(async()=>{const m=await g.Promises.exists(l);u||(m?(d("changed",l),o=[S(t,d,y)]):d("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(f))]}else d("changed",l)})}catch(c){g.Promises.exists(t.path).then(n=>{n&&!u&&y(`Failed to watch ${t.path} for changes using fs.watch() (${c.toString()})`)})}return(0,M.toDisposable)(()=>{u=!0,o=(0,M.dispose)(o)})}async function p(t,d,y,v=512){const b=await g.Promises.open(t,"r"),u=Buffer.allocUnsafe(v),o=new L.CancellationTokenSource(y);let c,n=!1;const a=i(t,async s=>{if(s==="changed"){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await g.Promises.read(b,u,0,v,null);if(!r||o.token.isCancellationRequested)break;d(u.slice(0,r))}}catch(r){c=new Error(r),o.dispose(!0)}finally{n=!1}}},s=>{c=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await g.Promises.close(b),c?r(c):s()})})}e.watchFileContents=p}),define(Z[119],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[120],x([0,1,13,14,119]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){w.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(E,h,g,i,I)=>{const S=P(E,i,g);S.popup({window:(0,L.withNullAsUndefined)(w.BrowserWindow.fromWebContents(E.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{S&&E.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=M;function P(E,h,g){const i=new w.Menu;return g.forEach(I=>{let S;I.type==="separator"?S=new w.MenuItem({type:I.type}):Array.isArray(I.submenu)?S=new w.MenuItem({submenu:P(E,h,I.submenu),label:I.label}):S=new w.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(p,t,d)=>E.sender.send(h,I.id,d)}),i.append(S)}),i}});var he=this&&this.__decorate||function(j,e,w,L){var D=arguments.length,M=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,w,L);else for(var E=j.length-1;E>=0;E--)(P=j[E])&&(M=(D<3?P(M):D>3?P(e,w,M):P(e,w))||M);return D>3&&M&&Object.defineProperty(e,w,M),M};define(Z[35],x([0,1,31,9,17,23,47,16,4,2,111,25,14]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function y(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(v||(v={}));class b{constructor(_){this.buffer=_,this.pos=0}read(_){const X=this.buffer.slice(this.pos,this.pos+_);return this.pos+=X.byteLength,X}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(o||(o={}));function c(U){const _=D.VSBuffer.alloc(4);return _.writeUInt32BE(U,0),_}function n(U){return U.read(4).readUInt32BE(0)}function a(U){const _=D.VSBuffer.alloc(1);return _.writeUInt8(U,0),_}const s={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},r=typeof Buffer!="undefined";function l(U,_){if(typeof _=="undefined")U.write(s.Undefined);else if(typeof _=="string"){const X=D.VSBuffer.fromString(_);U.write(s.String),U.write(c(X.byteLength)),U.write(X)}else if(r&&Buffer.isBuffer(_)){const X=D.VSBuffer.wrap(_);U.write(s.Buffer),U.write(c(X.byteLength)),U.write(X)}else if(_ instanceof D.VSBuffer)U.write(s.VSBuffer),U.write(c(_.byteLength)),U.write(_);else if(Array.isArray(_)){U.write(s.Array),U.write(c(_.length));for(const X of _)l(U,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(_));U.write(s.Object),U.write(c(X.byteLength)),U.write(X)}}function f(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(n(U)).toString();case o.Buffer:return U.read(n(U)).buffer;case o.VSBuffer:return U.read(n(U));case o.Array:{const X=n(U),W=[];for(let z=0;z<X;z++)W.push(f(U));return W}case o.Object:return JSON.parse(U.read(n(U)).toString())}}class m{constructor(_,X,W=null,z=1e3){this.protocol=_,this.ctx=X,this.logger=W,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(_,X){this.channels.set(_,X),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const X=this.send([_.type]);this.logger&&this.logger.logOutgoing(X,0,1,y(_.type));return}case 201:case 202:case 204:case 203:{const X=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(X,_.id,1,y(_.type),_.data);return}}}send(_,X=void 0){const W=new u;return l(W,_),l(W,X),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(X){return 0}}onRawMessage(_){const X=new b(_),W=f(X),z=f(X),K=W[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onPromise({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onEventListen({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]})}}onPromise(_){const X=this.channels.get(_.channelName);if(!X){this.collectPendingRequest(_);return}const W=new M.CancellationTokenSource;let z;try{z=X.call(this.ctx,_.name,_.arg,W.token)}catch(q){z=Promise.reject(q)}const K=_.id;z.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(_.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(_.id)});const O=(0,g.toDisposable)(()=>W.cancel());this.activeRequests.set(_.id,O)}onEventListen(_){const X=this.channels.get(_.channelName);if(!X){this.collectPendingRequest(_);return}const W=_.id,K=X.listen(this.ctx,_.name,_.arg)(O=>this.sendResponse({id:W,data:O,type:204}));this.activeRequests.set(_.id,K)}disposeActiveRequest(_){const X=this.activeRequests.get(_.id);X&&(X.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let X=this.pendingRequests.get(_.channelName);X||(X=[],this.pendingRequests.set(_.channelName,X));const W=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:_,timeoutTimer:W})}flushPendingRequests(_){const X=this.pendingRequests.get(_);if(X){for(const W of X)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var k;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(_,X=null){this.protocol=_,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=X}getChannel(_){const X=this;return{call(W,z,K){return X.isDisposed?Promise.reject(E.canceled()):X.requestPromise(_,W,z,K)},listen(W,z){return X.isDisposed?Promise.reject(E.canceled()):X.requestEvent(_,W,z)}}}requestPromise(_,X,W,z=M.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:_,name:X,arg:W};if(z.isCancellationRequested)return Promise.reject(E.canceled());let C;return new Promise((J,Q)=>{if(z.isCancellationRequested)return Q(E.canceled());const ne=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(K),J(ge.data);break;case 202:this.handlers.delete(K);const de=new Error(ge.data.message);de.stack=ge.data.stack,de.name=ge.data.name,Q(de);break;case 203:this.handlers.delete(K),Q(ge.data);break}};this.handlers.set(K,ce),this.sendRequest(q)};let le=null;this.state===v.Idle?ne():(le=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),le.then(()=>{le=null,ne()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:K,type:101}),Q(E.canceled())},re=z.onCancellationRequested(oe);C=(0,g.combinedDisposable)((0,g.toDisposable)(oe),re),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(_,X,W){const z=this.lastRequestId++,O={id:z,type:102,channelName:_,name:X,arg:W};let q=null;const C=new h.Emitter({onFirstListenerAdd:()=>{q=(0,L.createCancelablePromise)(J=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(C),this.sendRequest(O)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(C),this.sendRequest({id:z,type:103}))}}),$=J=>C.fire(J.data);return this.handlers.set(z,$),C.event}sendRequest(_){switch(_.type){case 100:case 102:{const X=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(X,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const X=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(X,_.id,0,t(_.type));return}}}send(_,X=void 0){const W=new u;return l(W,_),l(W,X),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(X){return 0}}onBuffer(_){const X=new b(_),W=f(X),z=f(X),K=W[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,y(K)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],0,y(K),z),this.onResponse({type:W[0],id:W[1],data:z})}}onResponse(_){if(_.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(_.id);X&&X(_)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([P.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class A{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:X,onDidClientDisconnect:W})=>{h.Event.once(X.onMessage)(K=>{const O=new b(K),q=f(O),C=new m(X,q),$=new R(X);this.channels.forEach((Q,ne)=>C.registerChannel(ne,Q));const J={channelServer:C,channelClient:$,ctx:q};this._connections.add(J),this._onDidAddConnection.fire(J),W(()=>{C.dispose(),$.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const _=[];return this._connections.forEach(X=>_.push(X)),_}getChannel(_,X){const W=this;return{call(z,K,O){let q;if((0,S.isFunction)(X)){let $=(0,w.getRandomElement)(W.connections.filter(X));q=$?Promise.resolve($):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,X))}else q=X.routeCall(W,z,K);const C=q.then($=>$.channelClient.getChannel(_));return H(C).call(z,K,O)},listen(z,K){if((0,S.isFunction)(X))return W.getMulticastEvent(_,X,z,K);const O=X.routeEvent(W,z,K).then(q=>q.channelClient.getChannel(_));return H(O).listen(z,K)}}}getMulticastEvent(_,X,W,z){const K=this;let O=new g.DisposableStore;const q=new h.Emitter({onFirstListenerAdd:()=>{O=new g.DisposableStore;const C=new h.EventMultiplexer,$=new Map,J=ne=>{const oe=ne.channelClient.getChannel(_).listen(W,z),re=C.add(oe);$.set(ne,re)},Q=ne=>{const le=$.get(ne);!le||(le.dispose(),$.delete(ne))};K.connections.filter(X).forEach(J),h.Event.filter(K.onDidAddConnection,X)(J,void 0,O),K.onDidRemoveConnection(Q,void 0,O),C.event(q.fire,q,O),O.add(C)},onLastListenerRemove:()=>{O.dispose()}});return q.event}registerChannel(_,X){this.channels.set(_,X),this._connections.forEach(W=>{W.channelServer.registerChannel(_,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class F{constructor(_,X,W=null){const z=new u;l(z,X),_.send(z.buffer),this.channelClient=new R(_,W),this.channelServer=new m(_,X,W)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,X){this.channelServer.registerChannel(_,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function H(U){return{call(_,X,W){return U.then(z=>z.call(_,X,W))},listen(_,X){const W=new h.Relay;return U.then(z=>W.input=z.listen(_,X)),W.event}}}e.getDelayedChannel=H;function te(U){let _=!1;return{call(X,W,z){return _?U.call(X,W,z):(0,L.timeout)(0).then(()=>_=!0).then(()=>U.call(X,W,z))},listen(X,W){if(_)return U.listen(X,W);const z=new h.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>z.input=U.listen(X,W)),z.event}}}e.getNextTickChannel=te;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const X of _.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await h.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var G;(function(U){function _(K,O){const q=K,C=O&&O.disableMarshalling,$=new Map;for(const J in q)W(J)&&$.set(J,h.Event.buffer(q[J],!0));return new class{listen(J,Q,ne){const le=$.get(Q);if(le)return le;if(z(Q)){const oe=q[Q];if(typeof oe=="function")return oe.call(q,ne)}throw new Error(`Event not found: ${Q}`)}call(J,Q,ne){const le=q[Q];if(typeof le=="function"){if(!C&&Array.isArray(ne))for(let oe=0;oe<ne.length;oe++)ne[oe]=(0,i.revive)(ne[oe]);return le.apply(q,ne)}throw new Error(`Method not found: ${Q}`)}}}U.fromService=_;function X(K,O){const q=O&&O.disableMarshalling;return new Proxy({},{get(C,$){if(typeof $=="string")return O?.properties?.has($)?O.properties.get($):z($)?function(J){return K.listen($,J)}:W($)?K.listen($):async function(...J){let Q;O&&!(0,S.isUndefinedOrNull)(O.context)?Q=[O.context,...J]:Q=J;const ne=await K.call($,Q);return q?ne:(0,i.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=X;function W(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function z(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let _=U.toString();if(_!=="[object Object]")return _}return U}function V(U){return Array.isArray(U)?U.map(T):T(U)}function N(U,_,X,W,z,K,O){O=V(O);const q=ee[z],C=q[W%q.length];let $=[`%c[${U}]%c[${String(_).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(K)?($=$.concat(O),$.push(")")):$.push(O),console.log.apply(console,$)}e.logWithColors=N;class B{constructor(_,X){this._outgoingPrefix=_,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,X,W,z,K){this._totalOutgoing+=_,N(this._outgoingPrefix,this._totalOutgoing,_,X,W,z,K)}logIncoming(_,X,W,z,K){this._totalIncoming+=_,N(this._incomingPrefix,this._totalIncoming,_,X,W,z,K)}}e.IPCLogger=B}),define(Z[121],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[122],x([0,1,17,4,35]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",g=>w.VSBuffer.wrap(g.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class P extends D.IPCClient{constructor(h,g){const i=new M(h);super(i,g);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[85],x([0,1,17,4,2,3,32,35]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var h;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function i(){return g||(g=w.VSBuffer.alloc(0)),g}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let f=w.VSBuffer.alloc(r),m=0,k=0;for(;r>0;){const R=this._chunks[k];if(R.byteLength>r){const A=R.slice(0,r);f.set(A,m),m+=r,l&&(this._chunks[k]=R.slice(r),this._totalLength-=r),r-=r}else f.set(R,m),m+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,r-=R.byteLength}return f}}e.ChunkStream=I;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(S||(S={}));var p;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(r,l,f,m){this.type=r,this.id=l,this.ack=f,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends D.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const f=this._state.messageType,m=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(f,m,k,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=w.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._writeSoon(l,r.data)}_bufferAdd(r,l){const f=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,f}_bufferTake(){const r=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends D.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new t(1,0,0,r))}}e.Protocol=v;class b extends E.IPCClient{constructor(r,l,f=null){super(r,l,f);this.protocol=r}static fromSocket(r,l){return new b(new v(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=b;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class o{constructor(r){this.data=r,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,f=this._first;for(;f;)r[l++]=f.data,f=f.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new o(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class n{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<n._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=n._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const r=Date.now(),l=(1+n._HISTORY_LENGTH)*1e3;let f=0;for(let m=0;m<n._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=l&&f++;return 1-f/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class a{constructor(r,l=null,f=n.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=f,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new t(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const l=new t(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let l=0,f=r.length;l<f;l++)this._socketWriter.write(r[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new t(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const l=this._outgoingUnackMsg.toArray();for(let f=0,m=l.length;f<m;f++)this._socketWriter.write(l[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new t(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(r){const l=new t(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new t(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=a}),define(Z[123],x([0,1,13,17,4,2,35,121]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(i,I){const S=D.Event.fromNodeEventEmitter(w.ipcMain,I,(t,d)=>({event:t,message:d})),p=D.Event.filter(S,({event:t})=>t.sender.id===i);return D.Event.map(p,({message:t})=>t&&L.VSBuffer.wrap(t))}class g extends P.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const I=D.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(I,S=>{const p=S.id,t=g.Clients.get(p);t&&t.dispose();const d=new D.Emitter;g.Clients.set(p,(0,M.toDisposable)(()=>d.fire()));const y=h(p,"vscode:message"),v=D.Event.any(D.Event.signal(h(p,"vscode:disconnect")),d.event);return{protocol:new E.Protocol(S,y),onDidClientDisconnect:v}})}}e.Server=g,g.Clients=new Map}),define(Z[86],x([0,1,13,4,28,122]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends M.Client{constructor(g,i){super({addEventListener:(I,S)=>g.addListener(I,S),removeEventListener:(I,S)=>g.removeListener(I,S),postMessage:I=>g.postMessage(I),start:()=>g.start(),close:()=>g.close()},i)}}e.Client=P;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,D.generateUuid)();h.webContents.send("vscode:createMessageChannel",g);const i=L.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(S,p)=>({nonce:p,port:S.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,S=>S.nonce===g)));return I}e.connect=E}),define(Z[87],x([0,1,9,4,2,14]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function E(I){const S=I;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var h;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(h||(h={}));class g extends D.Disposable{constructor(S,p=Object.create(null)){super();this.database=S,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((p,t)=>this.accept(t,p)),S.deleted?.forEach(p=>this.accept(p,void 0))}accept(S,p){if(this.state===h.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(p)?t=this.cache.delete(S):this.cache.get(S)!==p&&(this.cache.set(S,p),t=!0),t&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,p){const t=this.cache.get(S);return(0,M.isUndefinedOrNull)(t)?p:t}getBoolean(S,p){const t=this.get(S);return(0,M.isUndefinedOrNull)(t)?p:t==="true"}getNumber(S,p){const t=this.get(S);return(0,M.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(S,p){if(this.state===h.Closed)return;if((0,M.isUndefinedOrNull)(p))return this.delete(S);const t=String(p);if(this.cache.get(S)!==t)return this.cache.set(S,t),this.pendingInserts.set(S,t),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}async delete(S){if(!(this.state===h.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(S){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((p,t)=>this.items.set(t,p)),S.delete&&S.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[124],x([0,1,9,4,40,8,20]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=(0,M.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>I.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,D.mapToString)(I.insert):"0"}), delete(${I.delete?(0,D.setToString)(I.delete):"0"})`),this.transaction(i,()=>{const S=I.insert,p=I.delete;if(S&&S.size>0){const t=[];t.push([]);let d=0;S.forEach((y,v)=>{let b=t[d];b.length>E.MAX_HOST_PARAMETERS&&(d++,b=[],t.push(b)),b.push(v,y)}),t.forEach(y=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,v=>v.run(y),()=>{const v=[];let b=0;return S.forEach((u,o)=>{v.push(o),b+=u.length}),`Keys: ${v.join(", ")} Length: ${b}`})})}if(p&&p.size){const t=[];t.push([]);let d=0;p.forEach(y=>{let v=t[d];v.length>E.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(y)}),t.forEach(y=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,v=>v.run(y),()=>{const v=[];return p.forEach(b=>{v.push(b)}),`Keys: ${v.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((S,p)=>{i.db.close(t=>(t&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?S():!i.isErroneous&&!i.isInMemory?this.backup().then(S,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),S())):typeof I=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const y=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:I()}).then(()=>y(),v=>(y(),Promise.reject(v)))})).then(S,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return P.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,S=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?S.integrity_check:S.quick_check;return I.isErroneous?`${p} (last error: ${I.lastError})`:I.isInMemory?`${p} (in-memory!)`:p}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&I)return await(0,w.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await P.Promises.unlink(i);try{await P.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,S)=>{new Promise((p,t)=>{j(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,d=>d?t.db?t.db.close(()=>S(d)):S(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(t),y=>t.db.close(()=>S(y)))),isInMemory:i===E.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},S)})}exec(i,I){return new Promise((S,p)=>{i.db.exec(I,t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${t}`),p(t)):S())})}get(i,I){return new Promise((S,p)=>{i.db.get(I,(t,d)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${t}`),p(t)):S(d))})}all(i,I){return new Promise((S,p)=>{i.db.all(I,(t,d)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${t}`),p(t)):S(d))})}transaction(i,I){return new Promise((S,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${t}`),p(t)):S())})})}prepare(i,I,S,p){const t=i.db.prepare(I),d=y=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${y} (${I}). Details: ${p()}`)};t.on("error",d),S(t),t.finalize(y=>{y&&d(y),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class h{constructor(i){i&&typeof i.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[125],x([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[126],x([0,1,125]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,M=D*24,P=M*7,E=M*30,h=M*365;function g(I,S){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,w.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(p<30)return(0,w.localize)(1,null);let t;return p<L?(t=p,S?t===1?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):t===1?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t)):p<D?(t=Math.floor(p/L),S?t===1?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):t===1?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):p<M?(t=Math.floor(p/D),S?t===1?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):t===1?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t)):p<P?(t=Math.floor(p/M),S?t===1?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):t===1?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):p<E?(t=Math.floor(p/P),S?t===1?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):t===1?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t)):p<h?(t=Math.floor(p/E),S?t===1?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):t===1?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):(t=Math.floor(p/h),S?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t))}e.fromNow=g;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[127],x([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[55],x([0,1,31,14,127]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(g,i){return i&&(g.stack||g.stacktrace)?D.localize(0,null,E(g),P(g.stack)||P(g.stacktrace)):E(g)}function P(g){return Array.isArray(g)?g.join(`
`):g}function E(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?D.localize(1,null,g.message):g.message||D.localize(2,null)}function h(g=null,i=!1){if(!g)return D.localize(3,null);if(Array.isArray(g)){const I=w.coalesce(g),S=h(I[0],i);return I.length>1?D.localize(4,null,S,I.length):S}if(L.isString(g))return g;if(g.detail){const I=g.detail;if(I.error)return M(I.error,i);if(I.exception)return M(I.exception,i)}return g.stack?M(g,i):g.message?g.message:D.localize(5,null)}e.toErrorMessage=h}),define(Z[128],x([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Z[129],x([0,1,128]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(P,E,h=E){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=E,this.modifierLabels[3]=h}toLabel(P,E,h){if(E.length===0)return null;const g=[];for(let i=0,I=E.length;i<I;i++){const S=E[i],p=h(S);if(p===null)return null;g[i]=D(S,p,this.modifierLabels[P])}return g.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,P,E){if(P===null)return"";const h=[];return M.ctrlKey&&h.push(E.ctrlKey),M.shiftKey&&h.push(E.shiftKey),M.altKey&&h.push(E.altKey),M.metaKey&&h.push(E.metaKey),P!==""&&h.push(P),h.join(E.separator)}}),define(Z[130],x([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[71],x([0,1,44,33,10,43,8,3,32,81,14,113,20,130]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function t(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(n,a){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};a&&(s.cwd=a);const r=w.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],s);return new Promise(l=>{r.once("error",f=>{l({success:!1,error:f})}),r.once("exit",(f,m)=>{l(f===0?{success:!0}:{success:!1,code:f!==null?f:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(r=>{w.execFile(s,[n.pid.toString()],{encoding:"utf8",shell:!0},(l,f,m)=>{r(l?{success:!1,error:l}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function y(n){!n||(delete n.DEBUG,E.isMacintosh&&delete n.DYLD_LIBRARY_PATH,E.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function v(n=h.env){return n.comspec||"cmd.exe"}e.getWindowsShell=v;class b{constructor(a,s,r,l){if(s!==void 0&&r!==void 0&&l!==void 0)this.cmd=a,this.args=s,this.shell=r,this.options=l;else{const f=a;this.cmd=f.command,this.shell=f.isShellCommand,this.args=f.args.slice(0),this.options=f.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const f=Object.create(null);Object.keys(h.env).forEach(m=>{f[m]=h.env[m]}),Object.keys(this.options.env).forEach(m=>{f[m]=this.options.env[m]}),this.options.env=f}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const s=a.lastIndexOf(P.sep);return s!==-1&&(a=a.substring(s+1)),b.WellKnowCommands[a]?a:"other"}start(a){return E.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(h.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(s=>{let r,l;const f=new Promise((m,k)=>{r=m,l=k});if(s){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=w.exec(m,this.options,(k,R,A)=>{this.childProcess=null;const F=k;F&&F.killed?l({killed:this.terminateRequested,stdout:R.toString(),stderr:A.toString()}):this.handleExec(r,a,k,R,A)})}else{let m=null;const k=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,r,a,l);const A={terminated:this.terminateRequested};i.isNumber(R)&&(A.cmdCode=R),r(A)};if(this.shell&&E.isWindows){const R=M.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let A=!1,F=!1;const H=[];let te=this.ensureQuotes(this.cmd);H.push(te.value),A=te.quoted,this.args&&this.args.forEach(G=>{te=this.ensureQuotes(G),H.push(te.value),F=F&&te.quoted});const se=["/s","/c"];A?F?se.push('"'+H.join(" ")+'"'):H.length>1?se.push('"'+H[0]+'" '+H.slice(1).join(" ")):se.push('"'+H[0]+'"'):se.push(H.join(" ")),m=w.spawn(v(),se,R)}else this.cmd&&(m=w.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(i.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",R=>{this.childProcess=null,l({terminated:this.terminateRequested,error:R})}),m.pid&&(this.childProcess.on("close",k),this.handleSpawn(m,r,a,l,!0)))}return f})}handleClose(a,s,r,l){}ensureQuotes(a){return b.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,d(a,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!E.isWindows)return a(!1);const s=w.spawn(v(),["/s","/c"]);s.on("error",r=>a(!0)),s.on("exit",r=>a(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class u extends b{constructor(a,s,r,l){super(a,s,r,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,s,r,l,f){[l,f].forEach((m,k)=>{const R=new I.LineDecoder;R.write(m).forEach(H=>{s({line:H,source:k===0?0:1})});const F=R.end();F&&s({line:F,source:k===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,s,r,l,f){const m=new I.LineDecoder,k=new I.LineDecoder;a.stdout.on("data",R=>{m.write(R).forEach(F=>r({line:F,source:0}))}),a.stderr.on("data",R=>{k.write(R).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=k}handleClose(a,s,r,l){const f=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;f&&r({line:f,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&r({line:m,source:1})}}e.LineProcess=u;function o(n){let a=[],s=!1;const r=function(l){if(s){a.push(l);return}(!n.send(l,m=>{if(m&&console.error(m),s=!1,a.length>0){const k=a.slice(0);a=[],k.forEach(R=>r(R))}})||E.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=o;var c;(function(n){async function a(s,r,l){if(P.isAbsolute(s))return s;if(r===void 0&&(r=h.cwd()),P.dirname(s)!=="."||(l===void 0&&i.isString(h.env.PATH)&&(l=h.env.PATH.split(P.delimiter)),l===void 0||l.length===0))return P.join(r,s);async function m(k){if(await S.Promises.exists(k)){let R;try{R=await S.Promises.stat(k)}catch(A){A.message.startsWith("EACCES")&&(R=await S.Promises.lstat(k))}return R?!R.isDirectory():!1}return!1}for(let k of l){let R;if(P.isAbsolute(k)?R=P.join(k,s):R=P.join(r,k,s),await m(R))return R;let A=R+".com";if(await m(A)||(A=R+".exe",await m(A)))return A}return P.join(r,s)}n.findExecutable=a})(c=e.win32||(e.win32={}))}),define(Z[131],x([0,1,26,3,117,71]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(p,t){return p===1?L.isWindows?I():M.getWindowsShell(t):g(p,t)}e.getSystemShell=P;function E(p,t){return p===1?L.isWindows?S(t):M.getWindowsShell(t):g(p,t)}e.getSystemShellSync=E;let h=null;function g(p,t){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!h){let d;if(L.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,w.userInfo)().shell}catch(y){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}h=d}return h}let i=null;async function I(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function S(p){if(i)return i;const t=L.isWindows&&parseFloat((0,w.release)())>=10,d=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${p.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?y:M.getWindowsShell(p)}}),define(Z[72],x([0,1,44,9,17,23,110,16,4,2,43,71,35]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends S.ChannelServer{constructor(y){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(b){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(y,v){this.modulePath=y,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new L.Delayer(b),this.child=null,this._client=null}getChannel(y){const v=this;return{call(b,u,o){return v.requestPromise(y,b,u,o)},listen(b,u){return v.requestEvent(y,b,u)}}}requestPromise(y,v,b,u=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(y),c=(0,L.createCancelablePromise)(s=>o.call(v,b,s)),n=u.onCancellationRequested(()=>c.cancel()),a=(0,g.toDisposable)(()=>c.cancel());return this.activeRequests.add(a),c.finally(()=>{n.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(y,v,b){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const o=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(y).listen(v,b)(o.fire,o),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,I.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,y,v);const b=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,P.isRemoteConsoleLog)(r)){(0,P.log)(r,`IPC Library: ${this.options.serverName}`);return}b.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,c=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),n=b.event,a={send:c,onMessage:n};this._client=new S.ChannelClient(a);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(f=>(0,g.dispose)(f)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(y){let v=this.channels.get(y);return v||(v=this.client.getChannel(y),this.channels.set(y,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[132],x([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[133],x([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[134],x([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[135],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[136],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[137],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Z[138],x([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[139],x([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[140],x([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[141],x([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[142],x([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[143],x([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[144],x([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[145],x([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[146],x([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[147],x([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[148],x([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[149],x([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[150],x([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[151],x([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[152],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[153],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[154],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[155],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[156],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[157],x([0,1,4,2]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(E,h,g){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(E,h,g){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,h,g){this.channel.call("attach",[E,h,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,h){this.channel.call("terminate",[E,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.channel.call("openExtensionDevelopmentHostWindow",[E,h])}}e.ExtensionHostDebugChannelClient=M}),define(Z[158],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(P){this.driver=P}listen(P,E){throw new Error(`No event found: ${E}`)}call(P,E,h){switch(E){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=w;class L{constructor(P){this.channel=P}click(P,E,h){return this.channel.call("click",[P,E,h])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,E){return this.channel.call("setValue",[P,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,E){return this.channel.call("getElements",[P,E])}getElementXY(P,E,h){return this.channel.call("getElementXY",[P,E,h])}typeInEditor(P,E){return this.channel.call("typeInEditor",[P,E])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,E){return this.channel.call("writeInTerminal",[P,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(Z[159],x([0,1,126,47,10,8,32,15,7]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(d,y,v){this._args=d,this.paths=y,this.productService=v}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(h.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=P.env.VSCODE_PORTABLE;return d?h.URI.file((0,M.join)(d,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,M.resolve)(d):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const y=P.env.VSCODE_EXTENSIONS;if(y)return y;const v=P.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,M.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],g.prototype,"appRoot",null),he([L.memoize],g.prototype,"userHome",null),he([L.memoize],g.prototype,"userDataPath",null),he([L.memoize],g.prototype,"appSettingsHome",null),he([L.memoize],g.prototype,"tmpDir",null),he([L.memoize],g.prototype,"userRoamingDataHome",null),he([L.memoize],g.prototype,"settingsResource",null),he([L.memoize],g.prototype,"userDataSyncHome",null),he([L.memoize],g.prototype,"userDataSyncLogResource",null),he([L.memoize],g.prototype,"sync",null),he([L.memoize],g.prototype,"machineSettingsResource",null),he([L.memoize],g.prototype,"globalStorageHome",null),he([L.memoize],g.prototype,"workspaceStorageHome",null),he([L.memoize],g.prototype,"keybindingsResource",null),he([L.memoize],g.prototype,"keyboardLayoutResource",null),he([L.memoize],g.prototype,"argvResource",null),he([L.memoize],g.prototype,"snippetsHome",null),he([L.memoize],g.prototype,"isExtensionDevelopment",null),he([L.memoize],g.prototype,"untitledWorkspacesHome",null),he([L.memoize],g.prototype,"installSourcePath",null),he([L.memoize],g.prototype,"builtinExtensionsPath",null),he([L.memoize],g.prototype,"extensionsPath",null),he([L.memoize],g.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],g.prototype,"extensionDevelopmentKind",null),he([L.memoize],g.prototype,"extensionTestsLocationURI",null),he([L.memoize],g.prototype,"debugExtensionHost",null),he([L.memoize],g.prototype,"serviceMachineIdResource",null),he([L.memoize],g.prototype,"telemetryLogResource",null),he([L.memoize],g.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=g;function i(t,d){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=i;function I(t,d){return p(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=I;function S(t,d){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=S;function p(t,d,y,v,b,u){const c=Number(d||t)||(v?null:y),n=c?Boolean(!!d):!1;let a;if(u)try{a=JSON.parse(u)}catch{}return{port:c,break:n,debugId:b,env:a}}}),define(Z[88],x([0,1,242,3,135]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function E(t,d,y=P){const v={},b=[],u=[];for(let a in d){const s=d[a];s.alias&&(v[a]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(a),s.deprecates&&b.push(s.deprecates)):s.type==="boolean"&&(u.push(a),s.deprecates&&u.push(s.deprecates))}const o=w(t,{string:b,boolean:u,alias:v}),c={},n=o;c._=o._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(let a in d){const s=d[a];s.alias&&delete n[s.alias];let r=n[a];s.deprecates&&n.hasOwnProperty(s.deprecates)&&(r||(r=n[s.deprecates]),delete n[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),y.onMultipleValues(a,r)),c[a]=r),delete n[a]}for(let a in n)y.onUnknownOption(a);return c}e.parseArgs=E;function h(t,d){let y="";return d.args&&(Array.isArray(d.args)?y=` <${d.args.join("> <")}>`:y=` <${d.args}>`),d.alias?`-${d.alias} --${t}${y}`:`--${t}${y}`}function g(t,d){let y=0,v=[];for(const c in t){const n=t[c],a=h(c,n);y=Math.max(y,a.length),v.push([a,n.description])}let b=y+2+1;if(d-b<25)return v.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let u=d-b-1,o=[];for(const c of v){let n=c[0],a=I(c[1],u),s=i(b-n.length-2);o.push("  "+n+s+a[0]);for(let r=1;r<a.length;r++)o.push(i(b)+a[r])}return o}e.formatOptions=g;function i(t){return" ".repeat(t)}function I(t,d){let y=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),b=t.slice(0,v).trim();t=t.slice(v),y.push(b)}return y}function S(t,d,y,v,b=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${t} ${y}`];o.push(""),o.push(`${(0,D.localize)(32,null)}: ${d} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),o.push(""),b&&(L.isWindows?o.push((0,D.localize)(35,null,d)):o.push((0,D.localize)(36,null,d)),o.push(""));const c={};for(const n in v){const a=v[n];if(a.description&&a.cat){let s=c[a.cat];s||(c[a.cat]=s={}),s[n]=a}}for(let n in c){const a=n;let s=c[a];s&&(o.push(M[a]),o.push(...g(s,u)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=S;function p(t,d){return`${t||(0,D.localize)(37,null)}
${d||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[160],x([0,1,62,157,88]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,h,g){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1]):super.call(E,h,g)}async openExtensionDevelopmentHostWindow(E,h){const g=(0,D.parseArgs)(E,D.OPTIONS);g.debugRenderer=h;const i=g.extensionDevelopmentPath;if(!i)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:g});if(!h)return{success:!0};const S=I.win;if(!S)return{success:!0};const p=S.webContents.debugger;let t=p.isAttached()?Infinity:0;const d=(0,w.createServer)(y=>{t++==0&&p.attach();let v=!1;const b=c=>{v||y.write(JSON.stringify(c)+"\0")},u=(c,n,a,s)=>b({method:n,params:a,sessionId:s});S.on("close",()=>{p.removeListener("message",u),y.end(),v=!0}),p.addListener("message",u);let o=Buffer.alloc(0);y.on("data",c=>{o=Buffer.concat([o,c]);for(let n=o.indexOf(0);n!==-1;n=o.indexOf(0)){let a;try{const s=o.slice(0,n).toString("utf8");o=o.slice(n+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}p.sendCommand(a.method,a.params,a.sessionId).then(s=>b({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>b({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),y.on("error",c=>{console.error("error on cdp pipe:",c)}),y.on("close",()=>{v=!0,--t==0&&p.detach()})});return await new Promise(y=>d.listen(0,y)),S.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,w,L,D){function M(E){const h=P(E),g=[h];return e.isAbsolute(h)||g.unshift(D),e.resolve(...g)}function P(E){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,L);const i=E["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(I,"AppData","Roaming")}break;case"darwin":g=e.join(w.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[161],x([0,243,26,10,15,32]),function(e,w,L,D,M,P){const E=M.dirname(D.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(M.joinPath(E,"package.json").fsPath);return j(w,L,h.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),L=require("os");module.exports=j(w,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[162],x([0,1,26,159,161]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(E,h){super(E,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},h)}}e.NativeEnvironmentService=M}),define(Z[163],x([0,1,29,26,8]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(P){const E=(0,D.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return w.writeFileSync(E,""),P&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){P&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=M}),define(Z[164],x([0,1,139]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(S){return S=S.trim(),S==="*"||L.test(S)}e.isValidVersionStr=M;function P(S){if(!M(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=S.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function E(S){if(!S)return null;let p=S.majorBase,t=S.majorMustEqual,d=S.minorBase,y=S.minorMustEqual,v=S.patchBase,b=S.patchMustEqual;S.hasCaret&&(p===0||(y=!1),b=!1);let u=0;if(S.preRelease){const o=D.exec(S.preRelease);if(o){const[,c,n,a]=o;u=Date.UTC(Number(c),Number(n)-1,Number(a))}}return{majorBase:p,majorMustEqual:t,minorBase:d,minorMustEqual:y,patchBase:v,patchMustEqual:b,isMinimum:S.hasGreaterEquals,notBefore:u}}e.normalizeVersion=E;function h(S,p,t){let d;typeof S=="string"?d=E(P(S)):d=S;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let v;if(typeof t=="string"?v=E(P(t)):v=t,!d||!v)return!1;let b=d.majorBase,u=d.minorBase,o=d.patchBase,c=v.majorBase,n=v.minorBase,a=v.patchBase,s=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,f=v.patchMustEqual;return v.isMinimum?b>c?!0:b<c?!1:u>n?!0:u<n||y&&y<s?!1:o>=a:(b===1&&c===0&&(!r||!l||!f)&&(c=1,n=0,a=0,r=!0,l=!1,f=!1),b<c?!1:b>c?!r:u<n?!1:u>n?!l:o<a?!1:o>a?!f:!(y&&y<s))}e.isValidVersion=h;function g(S,p,t,d){return t.isBuiltin||typeof t.main=="undefined"?!0:I(S,p,t.engines.vscode,d)}e.isValidExtensionVersion=g;function i(S,p,t){return S==="*"||I(p,t,S)}e.isEngineValid=i;function I(S,p,t,d=[]){let y=E(P(t));if(!y)return d.push(w.localize(0,null,t)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return d.push(w.localize(1,null,t)),!1}else if(!y.majorMustEqual)return d.push(w.localize(2,null,t)),!1;return h(S,p,y)?!0:(d.push(w.localize(3,null,S,t)),!1)}}),define(Z[73],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(D,M=[],P=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=w}),define(Z[165],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=w;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let P of this._nodes.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const E=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(P);E.outgoing.set(this._hashFn(P),h),h.incoming.set(this._hashFn(M),E)}removeNode(M){const P=this._hashFn(M);this._nodes.delete(P);for(let E of this._nodes.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(M){const P=this._hashFn(M);let E=this._nodes.get(P);return E||(E=new w(M),this._nodes.set(P,E)),E}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[P,E]of this._nodes)M.push(`${P}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,P]of this._nodes){const E=new Set([M]),h=this._findCycle(P,E);if(h)return h}}_findCycle(M,P){for(let[E,h]of M.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const g=this._findCycle(h,P);if(g)return g;P.delete(E)}}}e.Graph=L}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function h(g){return g[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=h})(w=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(E,h,g,i){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:E,index:g,optional:i}):(h[w.DI_DEPENDENCIES]=[{id:E,index:g,optional:i}],h[w.DI_TARGET]=h)}function D(E){if(w.serviceIds.has(E))return w.serviceIds.get(E);const h=function(g,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(h,g,I,!1)};return h.toString=()=>E,w.serviceIds.set(E,h),h}e.createDecorator=D;function M(E){return E}e.refineServiceDecorator=M;function P(E){return function(h,g,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(E,h,i,!0)}}e.optional=P}),define(Z[74],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,P)=>j(["vscode-encrypt"],M,P))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(P){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(P){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[166],x([0,1,10,138,5]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function P(b){switch(b){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function E(b){switch(b){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function h(b,u){switch(b){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function g(b,u){return u==="web"&&!b.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function i(b,u,o){return g(u,o)?!1:b==="undefined"||b==="universal"?!0:b==="unknown"?!1:b===o?!0:I(o).includes(b)}e.isTargetPlatformCompatible=i;function I(b){switch(b){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function S(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=S;var p;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=10]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var t;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var d;(function(b){b.Install="install",b.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var y;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(u,o){super(u);this.code=o,this.name=o}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=w.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Z[167],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[90],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[168],x([0,1,44,10,8,3,81,20,71,140,90]),function(j,e,w,L,D,M,P,E,h,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=g.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends S{openTerminal(o,c){return this.spawnTerminal(w,o,h.getWindowsShell(),c)}spawnTerminal(o,c,n,a){const s=c.windowsExec||p.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const r=D.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((f,m)=>{const k=y(process),R=o.spawn(n,l,{cwd:a,env:k});R.on("error",m),R.on("exit",()=>f())})}runInTerminal(o,c,n,a,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,f)=>{const m=`"${c} - ${I}"`,k=`""${n.join('" "')}" & pause"`,R=["/c","start",m,"/wait",r,"/c",k],A=Object.assign({},y(process),a);Object.keys(A).filter(te=>A[te]===null).forEach(te=>delete A[te]);const F={cwd:c,env:A,windowsVerbatimArguments:!0};w.spawn(p.CMD,R,F).on("error",te=>{f(v(te))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends S{openTerminal(o,c){return this.spawnTerminal(w,o,c)}runInTerminal(o,c,n,a,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((l,f)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const m=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,j).fsPath,"-t",o||I,"-w",c];for(let H of n)R.push("-a"),R.push(H);if(a){const H=Object.assign({},y(process),a);for(let te in H){const se=H[te];se===null?(R.push("-u"),R.push(te)):(R.push("-e"),R.push(`${te}=${se}`))}}let A="";const F=w.spawn(t.OSASCRIPT,R);F.on("error",H=>{f(v(H))}),F.stderr.on("data",H=>{A+=H.toString()}),F.on("exit",H=>{if(H===0)l(void 0);else if(A){const te=A.split(`
`,1);f(new Error(te[0]))}else f(new Error(g.localize(1,null,m,H)))})}else f(new Error(g.localize(2,null,r)))})}spawnTerminal(o,c,n){const a=c.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const l=["-a",a];n&&l.push(n);const f=y(process),m=o.spawn("/usr/bin/open",l,{cwd:n,env:f});m.on("error",r),m.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends S{openTerminal(o,c){return this.spawnTerminal(w,o,c)}runInTerminal(o,c,n,a,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{let m=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const R=`${b(n)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;m.push(`''${R}''`);const A=Object.assign({},y(process),a);Object.keys(A).filter(se=>A[se]===null).forEach(se=>delete A[se]);const F={cwd:c,env:A};let H="";const te=w.spawn(k,m,F);te.on("error",se=>{f(v(se))}),te.stderr.on("data",se=>{H+=se.toString()}),te.on("exit",se=>{if(se===0)l(void 0);else if(H){const G=H.split(`
`,1);f(new Error(G[0]))}else f(new Error(g.localize(4,null,k,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await E.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{o?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,c,n){const a=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{a.then(l=>{const f=y(process),m=o.spawn(l,[],{cwd:n,env:f});m.on("error",r),m.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=g.localize(3,null);function y(u){const o={...u.env};return(0,P.sanitizeProcessEnvironment)(o),o}function v(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(g.localize(5,null,u.path)):u}function b(u){let o="";for(let c of u)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(Z[18],x([0,1,40,8,25,14,7,142,5]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function g(T){return T.create===!0}e.isFileOpenForWriteOptions=g;var i;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(T){T[T.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var S;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=y;var v;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(V,N){super(V);this.code=N}}e.FileSystemProviderError=b;function u(T,V){const N=new b(T.toString(),V);return c(N,V),N}e.createFileSystemProviderError=u;function o(T){return T||u((0,E.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=o;function c(T,V){return T.name=V?`${V} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=c;function n(T){if(!T)return v.Unknown;if(T instanceof b)return T.code;const V=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!V)return v.Unknown;switch(V[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function a(T){if(T instanceof k)return T.fileOperationResult;switch(n(T)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,N,B){this.resource=V,this.operation=N,this.target=B}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var l;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const U of V){const _=B.get(U.type);_?_.push([U.resource,U]):B.set(U.type,[[U.resource,U]])}for(const[U,_]of B)switch(U){case 1:this.added=w.TernarySearchTree.forUris(()=>N),this.added.fill(_);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>N),this.updated.fill(_);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>N),this.deleted.fill(_);break}}contains(V,...N){return this.doContains(V,{includeChildren:!1},...N)}affects(V,...N){return this.doContains(V,{includeChildren:!0},...N)}doContains(V,N,...B){if(!V)return!1;const U=B.length>0;return!!((!U||B.includes(1))&&(this.added?.get(V)||N.includeChildren&&this.added?.findSuperstr(V))||(!U||B.includes(0))&&(this.updated?.get(V)||N.includeChildren&&this.updated?.findSuperstr(V))||(!U||B.includes(2))&&(this.deleted?.findSubstr(V)||N.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(T,V,N){return!T||!V||T===V||V.length>T.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),N?(0,D.startsWithIgnoreCase)(T,V):T.indexOf(V)===0)}e.isParent=m;class k extends Error{constructor(V,N,B){super(V);this.fileOperationResult=N,this.options=B}}e.FileOperationError=k;class R extends k{constructor(V,N,B){super(V,2,B);this.stat=N}}e.NotModifiedSinceFileOperationError=R;var A;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=H;async function te(T,V){if(!V.hasProvider(P.URI.from({scheme:T.scheme})))return new Promise(N=>{const B=V.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===T.scheme&&U.added&&(B.dispose(),N())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<se.KB?(0,E.localize)(1,null,V.toFixed(0)):V<se.MB?(0,E.localize)(2,null,(V/se.KB).toFixed(2)):V<se.GB?(0,E.localize)(3,null,(V/se.MB).toFixed(2)):V<se.TB?(0,E.localize)(4,null,(V/se.GB).toFixed(2)):(0,E.localize)(5,null,(V/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var G;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function ee(T){return{maxFileSize:T===0?300*se.MB:16*se.GB,maxHeapSize:T===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=ee}),define(Z[56],x([0,1,244,136,88,18]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(S,p){const t={onUnknownOption:y=>{console.warn((0,L.localize)(0,null,y))},onMultipleValues:(y,v)=>{console.warn((0,L.localize)(1,null,y,v))}},d=(0,D.parseArgs)(S,D.OPTIONS,p?t:void 0);return d.goto&&d._.forEach(y=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(2,null))),d["max-memory"]&&w(parseInt(d["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function E(S){const p=S.findIndex(t=>!/^-/.test(t));if(p>-1)return[...S.slice(0,p),...S.slice(p+1)]}function h(S){let[,...p]=S;process.env.VSCODE_DEV&&(p=E(p)||[]);const t=!I(process.env);return P(p,t)}e.parseMainProcessArgv=h;function g(S){const[,,...p]=S;return P(p,!0)}e.parseCLIProcessArgv=g;function i(S,...p){const t=S.indexOf("--");return t===-1?S.push(...p):S.splice(t,0,...p),S}e.addArg=i;function I(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Z[91],x([0,1,44,8,137,23,55,16,3,28,131,56,9]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let t;async function d(v,b,u){return b["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(u)&&!b["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=S.Promises.withAsyncBody(async(o,c)=>{const n=new M.CancellationTokenSource,a=setTimeout(()=>{n.dispose(!0),c(new Error((0,D.localize)(0,null)))},p);try{o(await y(v,n.token))}catch(s){!(0,E.isPromiseCanceledError)(s)&&!n.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(s)))):o({})}finally{clearTimeout(a),n.dispose()}})),t)}e.resolveShellEnv=d;async function y(v,b){const u=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",u);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",o);const c=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",a);const s=await(0,i.getSystemShell)(h.OS,a);return v.trace("getUnixShellEnvironment#shell",s),new Promise((r,l)=>{if(b.isCancellationRequested)return l((0,E.canceled)());const f=(0,L.basename)(s);let m,k;/^pwsh(-preview)?$/.test(f)?(m=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,k=["-Login","-Command"]):(m=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,k=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),m);const R=(0,w.spawn)(s,[...k,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});b.onCancellationRequested(()=>(R.kill(),l((0,E.canceled)()))),R.on("error",H=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(H)),l(H)});const A=[];R.stdout.on("data",H=>A.push(H));const F=[];R.stderr.on("data",H=>F.push(H)),R.on("close",(H,te)=>{const se=Buffer.concat(A).toString("utf8");v.trace("getUnixShellEnvironment#raw",se);const G=Buffer.concat(F).toString("utf8");if(G.trim()&&v.trace("getUnixShellEnvironment#stderr",G),H||te)return l(new Error((0,D.localize)(2,null,H,te)));const ee=n.exec(se),T=ee?ee[1]:"{}";try{const V=JSON.parse(T);u?V.ELECTRON_RUN_AS_NODE=u:delete V.ELECTRON_RUN_AS_NODE,o?V.ELECTRON_NO_ATTACH_CONSOLE=o:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){v.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(V)),l(V)}})})}}),define(Z[49],x([0,1,2,3,7,18]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class P extends w.Disposable{}e.WatcherService=P;function E(i){return i.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=E;function h(i){const I=new g;for(const S of i)I.processEvent(S);return I.normalize()}e.normalizeFileChanges=h;class g{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return L.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const S=this.mapPathToChange.get(this.toKey(I));let p=!1;if(S){const t=S.type,d=I.type;S.path!==I.path&&I.type===2?p=!0:t===1&&d===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(S)):t===2&&d===1?S.type=0:t===1&&d===0||(S.type=d)}else p=!0;p&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],S=[];return Array.from(this.normalized).filter(p=>p.type!==2?(I.push(p),!1):!0).sort((p,t)=>p.path.length-t.path.length).filter(p=>S.some(t=>(0,M.isParent)(p.path,t,!L.isLinux))?!1:(S.push(p.path),!0)).concat(I)}}}),define(Z[92],x([0,1,9,2,8,83,20,118,49]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends L.Disposable{constructor(I,S,p,t){super();this.path=I,this.onDidFilesChange=S,this.onLogMessage=p,this.verboseLogging=t,this.fileChangesDelayer=this._register(new w.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:S}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(S)try{p=await(0,M.realpath)(p)}catch(t){if(this.onError(t),S.dangling)return}I.isDirectory()?this._register((0,E.watchFolder)(p,(t,d)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(d))})},t=>this.onError(t))):this._register((0,E.watchFile)(p,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,h.normalizeFileChanges)(S);if(this.verboseLogging)for(const t of p)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(Z[169],x([0,1,10,35,72,49]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,g,i){super();this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new D.Client(w.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P}),define(Z[170],x([0,1,2,10,35,72,49]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends P.WatcherService{constructor(g,i,I){super();this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=I,this.serviceDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const g=new w.DisposableStore;this.serviceDisposables.value=g;const i=g.add(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));g.add(i.onDidProcessExit(()=>{this.restartCounter<=E.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(i.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),g.add(this.service.onDidChangeFile(I=>this.onDidFilesChange(I))),g.add(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}restart(g){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.service?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.service?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${g}`})}dispose(){return this.service=void 0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[171],x([0,1,10,35,72,49]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,g,i,I={}){super();this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=i,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const h=this._register(new D.Client(w.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}async watch(h){this.requests=h,await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Z[75],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...D){this._entries=new Map;for(let[M,P]of D)this.set(M,P)}set(D,M){const P=this._entries.get(D);return this._entries.set(D,M),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=w}),define(Z[172],x([0,1,9,16,73,165,5,75]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class g extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class i{constructor(t=new E.ServiceCollection,d=!1,y){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=y,this._services.set(P.IInstantiationService,this)}createChild(t){return new i(t,this._strict,this)}invokeFunction(t,...d){let y=S.traceInvocation(t),v=!1;try{return t({get:(u,o)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(u,y);if(!c&&o!==P.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return c}},...d)}finally{v=!0,y.stop()}}createInstance(t,...d){let y,v;return t instanceof D.SyncDescriptor?(y=S.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),y)):(y=S.traceCreation(t),v=this._createInstance(t,d,y)),y.stop(),v}_createInstance(t,d=[],y){let v=P._util.getServiceDependencies(t).sort((o,c)=>o.index-c.index),b=[];for(const o of v){let c=this._getOrCreateServiceInstance(o.id,y);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${o.id}.`);b.push(c)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${d.length} static arguments`);let o=u-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,u)}return new t(...[...d,...b])}_setServiceInstance(t,d){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let y=this._getServiceInstanceOrDescriptor(t);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,y,d.branch(t,!0)):(d.branch(t,!1),y)}_safeCreateAndCacheServiceInstance(t,d,y){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,y)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,y){const v=new M.Graph(o=>o.id.toString());let b=0;const u=[{id:t,desc:d,_trace:y}];for(;u.length;){const o=u.pop();if(v.lookupOrInsertNode(o),b++>1e3)throw new g(v);for(let c of P._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(c.id);if(!n&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const a={id:c.id,desc:n,_trace:o._trace.branch(c.id,!0)};v.insertEdge(o,a),u.push(a)}}}for(;;){const o=v.roots();if(o.length===0){if(!v.isEmpty())throw new g(v);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,y=[],v,b){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(d,y,v,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,y,v,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],y,v){if(y){const b=new w.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(u,o){if(o in u)return u[o];let c=b.value,n=c[o];return typeof n!="function"||(n=n.bind(c),u[o]=n),n},set(u,o,c){return b.value[o]=c,!0}})}else return this._createInstance(t,d,v)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class S{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new S(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(t){return h?new S(0,t.name):S._None}branch(t,d){let y=new S(2,t.toString());return this._dep.push([t,d,y]),y}stop(){let t=Date.now()-this._start;S._totals+=t;let d=!1;function y(b,u){let o=[],c=new Array(b+1).join("	");for(const[n,a,s]of u._dep)if(a&&s){d=!0,o.push(`${c}CREATES -> ${n}`);let r=y(b+1,s);r&&o.push(r)}else o.push(`${c}uses -> ${n}`);return o.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[173],x([0,1,16,129,59]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(E,h){super();if(h.length===0)throw(0,w.illegalArgument)("parts");this._os=E,this._parts=h}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new D.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=M}),define(Z[174],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(M,P,E,h,g,i,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?L(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=L(M.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=E,this.when=h,this.isDefault=g,this.extensionId=i,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=w;function L(D){let M=[];for(let P=0,E=D.length;P<E;P++){const h=D[P];if(!h)return M;M.push(h)}return M}e.removeElementsAfterNulls=L}),define(Z[175],x([0,1,80,59,173,174]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(h,g){super(g,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return w.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const g=w.KeyCodeUtils.toUserSettingsUS(h.keyCode);return g&&g.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return P.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let g="";return h.ctrlKey&&(g+="ctrl+"),h.shiftKey&&(g+="shift+"),h.altKey&&(g+="alt+"),h.metaKey&&(g+="meta+"),g+=w.KeyCodeUtils.toString(h.keyCode),g}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const g=w.IMMUTABLE_CODE_TO_KEY_CODE[h];if(g!==-1)return g;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof L.SimpleKeybinding)return h;const g=this._scanCodeToKeyCode(h.scanCode);return g===0?null:new L.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,g)}static resolveUserBinding(h,g){const i=(0,M.removeElementsAfterNulls)(h.map(I=>this._resolveSimpleUserBinding(I)));return i.length>0?[new P(new L.ChordKeybinding(i),g)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Z[176],x([0,1,9]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(D,M){if(D.length===0)return Promise.resolve(!1);const P=[];let E=!1;for(let h of D){if(h===!0)return Promise.resolve(!0);(0,w.isThenable)(h)&&P.push(h.then(g=>{g&&(E=!0)},g=>{M(g),E=!0}))}return w.Promises.settled(P).then(()=>E)}e.handleVetos=L}),define(Z[6],x([0,1,55,4,2,3,5]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function E(){return new Date().toISOString()}var h;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class g extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class i extends g{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...a){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([n,...a]))}debug(n,...a){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([n,...a]))}info(n,...a){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([n,...a]))}warn(n,...a){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([n,...a]))}error(n,...a){if(this.checkLogLevel(h.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(h.Error,this.format(s))}else this.log(h.Error,this.format([n,...a]))}critical(n,...a){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([n,...a]))}flush(){}format(n){let a="";for(let s=0;s<n.length;s++){let r=n[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}a+=(s>0?" ":"")+r}return a}}e.AbstractMessageLogger=i;class I extends g{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!M.isWindows}trace(n,...a){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...a):console.log(`[main ${E()}]`,n,...a))}debug(n,...a){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...a):console.log(`[main ${E()}]`,n,...a))}info(n,...a){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...a):console.log(`[main ${E()}]`,n,...a))}warn(n,...a){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,n,...a):console.warn(`[main ${E()}]`,n,...a))}error(n,...a){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,n,...a):console.error(`[main ${E()}]`,n,...a))}critical(n,...a){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,n,...a):console.error(`[main ${E()}]`,n,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class S extends g{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...a){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",n,...a)}debug(n,...a){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...a)}info(n,...a){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",n,...a)}warn(n,...a){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",n,...a)}error(n,...a){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",n,...a)}critical(n,...a){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...a)}dispose(){}flush(){}}e.ConsoleLogger=S;class p extends g{constructor(n,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(a)}trace(n,...a){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(n),...a])}debug(n,...a){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(n),...a])}info(n,...a){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(n),...a])}warn(n,...a){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(n),...a])}error(n,...a){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(n),...a])}critical(n,...a){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(n),...a])}extractMessage(n){return typeof n=="string"?n:(0,w.toErrorMessage)(n,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class t extends g{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const a of this.logServices)a.setLevel(n);super.setLevel(n)}trace(n,...a){for(const s of this.logServices)s.trace(n,...a)}debug(n,...a){for(const s of this.logServices)s.debug(n,...a)}info(n,...a){for(const s of this.logServices)s.info(n,...a)}warn(n,...a){for(const s of this.logServices)s.warn(n,...a)}error(n,...a){for(const s of this.logServices)s.error(n,...a)}critical(n,...a){for(const s of this.logServices)s.critical(n,...a)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=t;class d extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...a){this.logger.trace(n,...a)}debug(n,...a){this.logger.debug(n,...a)}info(n,...a){this.logger.info(n,...a)}warn(n,...a){this.logger.warn(n,...a)}error(n,...a){this.logger.error(n,...a)}critical(n,...a){this.logger.critical(n,...a)}flush(){this.logger.flush()}}e.LogService=d;class y extends D.Disposable{constructor(n,a){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,a){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,a?.always?h.Trace:this.logLevel,a),this.loggers.set(n.toString(),s),a?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return h.Info}trace(n,...a){}debug(n,...a){}info(n,...a){}warn(n,...a){}error(n,...a){}critical(n,...a){}dispose(){}flush(){}}e.NullLogService=v;function b(c){if(c.verbose)return h.Trace;if(typeof c.logLevel=="string"){const n=u(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function u(c){switch(c){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=u;function o(c){switch(c){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=o});var ie=this&&this.__param||function(j,e){return function(w,L){e(w,L,j)}};define(Z[177],x([0,1,9,17,39,79,48,18,5,6]),function(j,e,w,L,D,M,P,E,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(S){S.ERROR_INVALID_FILE="ERROR_INVALID_FILE",S.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(p,t,d){this.environmentService=p,this.fileService=t,this.logService=d,this.queue=new w.Queue}async updateSettings(p,t){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,p,t))}async doWrite(p,t,d){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,p.toString(),t);const{value:y,mtime:v,etag:b}=await this.fileService.readFile(p,{atomic:!0});let u=y.toString();const o=[];if((0,D.parse)(u,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(t,u,d)[0];if(c){u=u.substring(0,c.offset)+c.content+u.substring(c.offset+c.length);try{await this.fileService.writeFile(p,L.VSBuffer.fromString(u),{etag:b,mtime:v})}catch(n){if(n.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:p,path:t},d,y){return t.length?(0,M.setProperty)(d,t,p,y):[{content:JSON.stringify(p,null,y.insertSpaces&&y.tabSize?" ".repeat(y.tabSize):"	"),length:d.length,offset:0}]}};I=he([ie(0,P.IEnvironmentService),ie(1,E.IFileService),ie(2,g.ILogService)],I),e.UserConfigurationFileService=I}),define(Z[178],x([0,1,31,9,16,4,2,8,49,6]),function(j,e,w,L,D,M,P,E,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends P.Disposable{constructor(S){super();this.logService=S,this._onDidErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(S,p){return p.recursive?this.watchRecursive(S,p):this.watchNonRecursive(S)}watchRecursive(S,p){const t={path:this.toFilePath(S),excludes:p.excludes},d=(0,w.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}watchNonRecursive(S){const p=this.createNonRecursiveWatcher(this.toFilePath(S),d=>this._onDidChangeFile.fire((0,h.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===g.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,P.combinedDisposable)(p,t)}onWatcherLogMessage(S){S.type==="error"&&this._onDidErrorOccur.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,E.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(Z[179],x([0,1,13,144,3,4,7,18,92,17,60,23,8,2,49,6]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends p.Disposable{constructor(u,o){super();this.provider=u,this.logService=o,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(u,o,c){switch(o){case"stat":return this.stat(P.URI.revive(c[0]));case"readdir":return this.readdir(P.URI.revive(c[0]));case"open":return this.open(P.URI.revive(c[0]),c[1]);case"close":return this.close(c[0]);case"read":return this.read(c[0],c[1],c[2]);case"readFile":return this.readFile(P.URI.revive(c[0]));case"write":return this.write(c[0],c[1],c[2],c[3],c[4]);case"writeFile":return this.writeFile(P.URI.revive(c[0]),c[1],c[2]);case"rename":return this.rename(P.URI.revive(c[0]),P.URI.revive(c[1]),c[2]);case"copy":return this.copy(P.URI.revive(c[0]),P.URI.revive(c[1]),c[2]);case"mkdir":return this.mkdir(P.URI.revive(c[0]));case"delete":return this.delete(P.URI.revive(c[0]),c[1]);case"watch":return this.watch(c[0],c[1],P.URI.revive(c[2]),c[3]);case"unwatch":return this.unwatch(c[0],c[1])}throw new Error(`IPC Command ${o} not found`)}listen(u,o,c){switch(o){case"fileChange":return this.onFileChange(c[0]);case"readFileStream":return this.onReadFileStream(P.URI.revive(c[0]),c[1])}throw new Error(`Unknown event ${o}`)}stat(u){return this.provider.stat(u)}readdir(u){return this.provider.readdir(u)}async readFile(u){const o=await this.provider.readFile(u);return g.VSBuffer.wrap(o)}onReadFileStream(u,o){const c=new I.CancellationTokenSource,n=new M.Emitter({onLastListenerRemove:()=>{c.cancel()}}),a=this.provider.readFileStream(u,o,c.token);return(0,i.listenStream)(a,{onData:s=>n.fire(g.VSBuffer.wrap(s)),onError:s=>n.fire(s),onEnd:()=>{n.fire("end"),n.dispose(),c.dispose()}}),n.event}writeFile(u,o,c){return this.provider.writeFile(u,o.buffer,c)}open(u,o){return this.provider.open(u,o)}close(u){return this.provider.close(u)}async read(u,o,c){const n=g.VSBuffer.alloc(c),a=0,s=await this.provider.read(u,o,n.buffer,a,c);return[n,s]}write(u,o,c,n,a){return this.provider.write(u,o,c.buffer,n,a)}mkdir(u){return this.provider.mkdir(u)}async delete(u,o){if(!o.useTrash)return this.provider.delete(u,o);const c=(0,S.normalize)(u.fsPath);try{await w.shell.trashItem(c)}catch(n){throw(0,E.createFileSystemProviderError)(D.isWindows?(0,L.localize)(0,null,(0,S.basename)(c)):(0,L.localize)(1,null,(0,S.basename)(c)),E.FileSystemProviderErrorCode.Unknown)}}rename(u,o,c){return this.provider.rename(u,o,c)}copy(u,o,c){return this.provider.copy(u,o,c)}onFileChange(u){const o=new M.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(u,new v(o,this.logService))},onLastListenerRemove:()=>{(0,p.dispose)(this.sessionToWatcher.get(u)),this.sessionToWatcher.delete(u)}});return o.event}async watch(u,o,c,n){if(n.recursive)throw(0,E.createFileSystemProviderError)("Recursive watcher is not supported from main process",E.FileSystemProviderErrorCode.Unavailable);const a=this.sessionToWatcher.get(u);if(a){const s=a.watch(o,c);this.watchRequests.set(u+o,s)}}async unwatch(u,o){const c=u+o,n=this.watchRequests.get(c);n&&((0,p.dispose)(n),this.watchRequests.delete(c))}dispose(){super.dispose(),this.watchRequests.forEach(u=>(0,p.dispose)(u)),this.watchRequests.clear(),this.sessionToWatcher.forEach(u=>(0,p.dispose)(u)),this.sessionToWatcher.clear()}}e.DiskFileSystemProviderChannel=y;class v extends p.Disposable{constructor(u,o){super();this.sessionEmitter=u,this.logService=o,this.watcherRequests=new Map}watch(u,o){const c=new p.DisposableStore;this.watcherRequests.set(u,c),c.add((0,p.toDisposable)(()=>this.watcherRequests.delete(u)));const n=c.add(new h.FileWatcher((0,S.normalize)(o.fsPath),a=>this.sessionEmitter.fire((0,t.toFileChanges)(a)),a=>this.onWatcherLogMessage(a),this.logService.getLevel()===d.LogLevel.Trace));return c.add(this.logService.onDidChangeLogLevel(()=>{n.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})),c}onWatcherLogMessage(u){u.type==="error"&&this.sessionEmitter.fire(u.message),this.logService[u.type](u.message)}dispose(){super.dispose(),this.watcherRequests.forEach(u=>(0,p.dispose)(u)),this.watcherRequests.clear()}}}),define(Z[93],x([0,1,6]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,P){switch(P){case w.LogLevel.Trace:return M.trace;case w.LogLevel.Debug:return M.debug;case w.LogLevel.Info:return M.info;case w.LogLevel.Warning:return M.warn;case w.LogLevel.Error:return M.error;case w.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends w.AbstractLogger{constructor(P=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(P){this._logger=P;for(const{level:E,args:h}of this.buffer)L(P,E).apply(P,h);this.buffer=[]}_log(P,...E){this._logger?L(this._logger,P).apply(this._logger,E):this.getLevel()<=P&&this.buffer.push({level:P,args:E})}trace(P,...E){this._log(w.LogLevel.Trace,P,...E)}debug(P,...E){this._log(w.LogLevel.Debug,P,...E)}info(P,...E){this._log(w.LogLevel.Info,P,...E)}warn(P,...E){this._log(w.LogLevel.Warning,P,...E)}error(P,...E){this._log(w.LogLevel.Error,P,...E)}critical(P,...E){this._log(w.LogLevel.Critical,P,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[180],x([0,1,9,17,15,18,5,93,6]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*M.ByteSize.MB;let i=class extends h.AbstractLogger{constructor(p,t,d,y,v){super();this.name=p,this.resource=t,this.donotUseFormatters=y,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(h.LogLevel.Error,this.format(t))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(p,t){this._log(p,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>g&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(d))})}getCurrentTimestamp(){const p=y=>y<10?`0${y}`:y,t=y=>y<10?`00${y}`:y<100?`0${y}`:y,d=new Date;return`${d.getFullYear()}-${p(d.getMonth()+1)}-${p(d.getDate())} ${p(d.getHours())}:${p(d.getMinutes())}:${p(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(p){let t="";for(let d=0;d<p.length;d++){let y=p[d];if(typeof y=="object")try{y=JSON.stringify(y)}catch(v){}t+=(d>0?" ":"")+y}return t}};i=he([ie(4,M.IFileService)],i),e.FileLogger=i;let I=class extends h.AbstractLoggerService{constructor(p,t,d){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(p,t,d){const y=new E.BufferLogService(t);return(0,M.whenProviderRegistered)(p,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(i,(0,D.basename)(p),p,y.getLevel(),!!d?.donotUseFormatters)),y}};I=he([ie(0,h.ILogService),ie(1,P.IInstantiationService),ie(2,M.IFileService)],I),e.FileLoggerService=I}),define(Z[181],x([0,1,4,7,6]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(S){this.service=S,this.onDidChangeLogLevel=w.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(S,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=M;class P{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){P.setLevel(this.channel,S)}static setLevel(S,p){return S.call("setLevel",p)}}e.LogLevelChannelClient=P;class E{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,p){throw new Error(`Event not found: ${p}`)}async call(S,p,t){switch(p){case"createLogger":this.createLogger(L.URI.revive(t[0]),t[1]);return;case"log":return this.log(L.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(S,p){this.loggers.set(S.toString(),this.loggerService.createLogger(S,p))}consoleLog(S,p){let t=console.log;switch(S){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(S,p){const t=this.loggers.get(S.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,y]of p)switch(d){case D.LogLevel.Trace:t.trace(y);break;case D.LogLevel.Debug:t.debug(y);break;case D.LogLevel.Info:t.info(y);break;case D.LogLevel.Warning:t.warn(y);break;case D.LogLevel.Error:t.error(y);break;case D.LogLevel.Critical:t.critical(y);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=E;class h extends D.AbstractLoggerService{constructor(S,p,t){super(S,p);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,p)=>{this.channel.call("consoleLog",[S,p])}})}doCreateLogger(S,p,t){return new g(this.channel,S,p,t)}}e.LoggerChannelClient=h;class g extends D.AbstractMessageLogger{constructor(S,p,t,d){super(d?.always);this.channel=S,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,p){const t=[[S,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(S){this.channel.call("log",[this.file,S])}}class i extends D.LogService{constructor(S,p){super(p);this.parent=S,this._register(S.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=i}),define(Z[94],x([0,1,18,6]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(h,g,i,I){try{const S=await new Promise((p,t)=>{j(["spdlog"],p,t)});return S.setFlushOn(L.LogLevel.Trace),S.createAsyncRotatingLogger(h,g,i,I)}catch(S){console.error(S)}return null}function M(h,g,i,I){const S=j.__$__nodeRequire("spdlog");return S.setFlushOn(L.LogLevel.Trace),S.createRotatingLogger(h,g,i,I)}e.createRotatingLogger=M;function P(h,g,i){switch(g){case L.LogLevel.Trace:h.trace(i);break;case L.LogLevel.Debug:h.debug(i);break;case L.LogLevel.Info:h.info(i);break;case L.LogLevel.Warning:h.warn(i);break;case L.LogLevel.Error:h.error(i);break;case L.LogLevel.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}class E extends L.AbstractMessageLogger{constructor(g,i,I,S){super();this.name=g,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const g=this.rotating?6:1,i=30/g*w.ByteSize.MB;return D(this.name,this.filepath,i,g).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:S,message:p}of this.buffer)P(this._logger,S,p);this.buffer=[]}})}log(g,i){this._logger?P(this._logger,g,i):this.getLevel()<=g&&this.buffer.push({level:g,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(Z[182],x([0,1,10,15,28,18,180,6,94]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends E.AbstractLoggerService{constructor(I,S){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=S}doCreateLogger(I,S,p){if(I.scheme===w.Schemas.file){const t=new h.SpdLogLogger(p?.name||(0,D.generateUuid)(),I.fsPath,!p?.donotRotate,S);return p?.donotUseFormatters&&t.clearFormatters(),t}else return new P.FileLogger(p?.name??(0,L.basename)(I),I,S,!!p?.donotUseFormatters,this.fileService)}};g=he([ie(0,E.ILogService),ie(1,M.IFileService)],g),e.LoggerService=g}),define(Z[183],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function L(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(P){return!w(P)&&!L(P)&&!D(P)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,32,15]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const E=L.globals.vscode.context.configuration();if(E)P=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const E=(0,M.dirname)(w.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,M.joinPath)(E,"product.json").fsPath);const h=j.__$__nodeRequire((0,M.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:h.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Z[95],x([0,1,17,16,143,18,45]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function E(I,S,p,t,d,y){let v;try{await h(I,S,p,t,d,y)}catch(b){v=b}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v!="undefined"&&p.error(v),p.end()}}e.readFileIntoStream=E;async function h(I,S,p,t,d,y){g(y);const v=await I.open(S,{create:!1});try{g(y);let b=0,u=0,o=d&&typeof d.length=="number"?d.length:void 0,c=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof o=="number"?o:d.bufferSize)),n=d&&typeof d.position=="number"?d.position:0,a=0;do u=await I.read(v,n,c.buffer,a,c.byteLength-a),n+=u,a+=u,b+=u,typeof o=="number"&&(o-=u),a===c.byteLength&&(await p.write(t(c)),c=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof o=="number"?o:d.bufferSize)),a=0);while(u>0&&(typeof o!="number"||o>0)&&g(y)&&i(b,d));if(a>0){let s=a;typeof o=="number"&&(s=Math.min(a,o)),p.write(t(c.slice(0,s)))}}catch(b){throw(0,M.ensureFileSystemProviderError)(b)}finally{await I.close(v)}}function g(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function i(I,S){if(S?.limits){if(typeof S.limits.memory=="number"&&I>S.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null,P.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&I>S.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[184],x([0,1,31,9,17,23,4,68,2,40,10,76,15,60,141,18,95,6]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class Ke extends h.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new P.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new d.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new d.FileChangesEvent(c,!0)))),this.watchedResources=g.TernarySearchTree.forUris(c=>{const n=this.getProvider(c.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const n=new h.DisposableStore;return n.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),n.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&n.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,h.dispose)(n)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(n){c.push(n)}}),!this.provider.has(o)&&await L.Promises.settled(c)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,c){const n=this.provider.get(o.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return E.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,S.isAbsolutePath)(o))throw new d.FileOperationError((0,t.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const n=new Error;throw n.name="ENOPRO",n.message=(0,t.localize)(1,null,o.toString()),n}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(c)||(0,d.hasReadWriteCapability)(c)||(0,d.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(c)||(0,d.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(n){throw(0,d.toFileSystemProviderErrorCode)(n)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,t.localize)(2,null,this.resourceForError(o)),1):(0,d.ensureFileSystemProviderError)(n)}}async doResolveFile(o,c){const n=await this.withProvider(o),a=this.isPathCaseSensitive(n),s=c?.resolveTo,r=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,f=await n.stat(o);let m;return this.toFileStat(n,o,f,void 0,!!l,(k,R)=>(m||(m=g.TernarySearchTree.forUris(()=>!a),m.set(o,!0),s&&m.fill(!0,s)),m.get(k.resource)||m.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?R===1:!1))}async toFileStat(o,c,n,a,s,r){const{providerExtUri:l}=this.getExtUri(o),f={resource:c,name:l.basename(c),isFile:(n.type&d.FileType.File)!=0,isDirectory:(n.type&d.FileType.Directory)!=0,isSymbolicLink:(n.type&d.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&d.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,d.etag)({mtime:n.mtime,size:n.size})};if(f.isDirectory&&r(f,a)){try{const m=await o.readdir(c),k=await L.Promises.settled(m.map(async([R,A])=>{try{const F=l.joinPath(c,R),H=s?await o.stat(F):{type:A};return await this.toFileStat(o,F,H,m.length,s,r)}catch(F){return this.logService.trace(F),null}}));f.children=(0,w.coalesce)(k)}catch(m){this.logService.trace(m),f.children=[]}return f}return f}async resolveAll(o){return L.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(n){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(n){return n}return!0}async doValidateCreateFile(o,c){if(!c?.overwrite&&await this.exists(o))throw new d.FileOperationError((0,t.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(o,n);const a=await this.writeFile(o,c);return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,a)),a}async writeFile(o,c,n){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(a);try{await this.validateWriteFile(a,o,n)||await this.mkdirp(a,s.dirname(o));let l;if((0,d.hasReadWriteCapability)(a)&&!(c instanceof D.VSBuffer))if((0,p.isReadableStream)(c)){const f=await(0,p.peekStream)(c,3);f.ended?l=D.VSBuffer.concat(f.buffer):l=f}else l=(0,p.peekReadable)(c,f=>D.VSBuffer.concat(f),3);else l=c;!(0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a)&&l instanceof D.VSBuffer?await this.doWriteUnbuffered(a,o,n,l):await this.doWriteBuffered(a,o,n,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l)}catch(r){throw new d.FileOperationError((0,t.localize)(4,null,this.resourceForError(o),(0,d.ensureFileSystemProviderError)(r).toString()),(0,d.toFileOperationResult)(r),n)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(c)));let s;try{s=await o.stat(c)}catch(r){return}if((s.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,t.localize)(6,null,this.resourceForError(c)),0,n);if(this.throwIfFileIsReadonly(c,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==d.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,d.etag)({mtime:n.mtime,size:s.size}))throw new d.FileOperationError((0,t.localize)(7,null),3,n);return s}async readFile(o,c){const n=await this.withReadProvider(o);return c?.atomic?this.doReadFileAtomic(n,o,c):this.doReadFile(n,o,c)}async doReadFileAtomic(o,c,n){return new Promise((a,s)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,c,n);a(r)}catch(r){s(r)}})})}async doReadFile(o,c,n){const a=await this.doReadFileStream(o,c,{...n,preferUnbuffered:!0});return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(o,c){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,c)}async doReadFileStream(o,c,n){const a=new M.CancellationTokenSource,s=this.validateReadFile(c,n).then(l=>l,l=>{throw a.cancel(),l});let r;try{return typeof n?.etag=="string"&&n.etag!==d.ETAG_DISABLED&&await s,!((0,d.hasOpenReadWriteCloseCapability)(o)||(0,d.hasFileReadStreamCapability)(o))||(0,d.hasReadWriteCapability)(o)&&n?.preferUnbuffered?r=this.readFileUnbuffered(o,c,n):(0,d.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,c,a.token,n):r=this.readFileBuffered(o,c,a.token,n),{...await s,value:r}}catch(l){r&&await(0,p.consumeStream)(r);const f=(0,t.localize)(8,null,this.resourceForError(c),(0,d.ensureFileSystemProviderError)(l).toString());throw l instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(f,l.stat,n):new d.FileOperationError(f,(0,d.toFileOperationResult)(l),n)}}readFileStreamed(o,c,n,a=Object.create(null)){const s=o.readFileStream(c,a,n);return(0,p.transform)(s,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new d.FileOperationError((0,t.localize)(9,null,this.resourceForError(c),(0,d.ensureFileSystemProviderError)(r).toString()),(0,d.toFileOperationResult)(r),a)},r=>D.VSBuffer.concat(r))}readFileBuffered(o,c,n,a=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(o,c,s,r=>r,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new d.FileOperationError((0,t.localize)(10,null,this.resourceForError(c),(0,d.ensureFileSystemProviderError)(r).toString()),(0,d.toFileOperationResult)(r),a)},n),s}readFileUnbuffered(o,c,n){const a=(0,p.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(c);typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(c,s.byteLength,n),a.end(D.VSBuffer.wrap(s))}catch(s){a.error(s),a.end()}})(),a}async validateReadFile(o,c){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new d.FileOperationError((0,t.localize)(11,null,this.resourceForError(o)),0,c);if(typeof c?.etag=="string"&&c.etag!==d.ETAG_DISABLED&&c.etag===n.etag)throw new d.NotModifiedSinceFileOperationError((0,t.localize)(12,null),n,c);return this.validateReadFileLimits(o,n.size,c),n}validateReadFileLimits(o,c,n){if(n?.limits){let a;if(typeof n.limits.memory=="number"&&c>n.limits.memory&&(a=9),typeof n.limits.size=="number"&&c>n.limits.size&&(a=7),typeof a=="number")throw new d.FileOperationError((0,t.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,c,n){return this.doCanMoveCopy(o,c,"move",n)}async canCopy(o,c,n){return this.doCanMoveCopy(o,c,"copy",n)}async doCanMoveCopy(o,c,n,a){if(o.toString()!==c.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,o,r,c,n,a)}catch(s){return s}return!0}async move(o,c,n){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=await this.doMoveCopy(a,o,s,c,"move",!!n),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,c,n){const a=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=await this.doMoveCopy(a,o,s,c,"copy",!!n),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,c,n,a,s,r){if(c.toString()===a.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,c,n,a,s,r);if(l&&!f&&r&&await this.del(a,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(a)),s==="copy"){if(o===n&&(0,d.hasFileFolderCopyCapability)(o))await o.copy(c,a,{overwrite:r});else{const m=await this.resolve(c);m.isDirectory?await this.doCopyFolder(o,m,n,a):await this.doCopyFile(o,c,n,a)}return s}else return o===n?(await o.rename(c,a,{overwrite:r}),s):(await this.doMoveCopy(o,c,n,a,"copy",r),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,n,a){if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(o,c,n,a);if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(o,c,n,a);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(o,c,n,a);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasReadWriteCapability)(n))return this.doPipeUnbuffered(o,c,n,a)}async doCopyFolder(o,c,n,a){await n.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async s=>{const r=this.getExtUri(n).providerExtUri.joinPath(a,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),n,r):this.doCopyFile(o,s.resource,n,r)}))}async doValidateMoveCopy(o,c,n,a,s,r){let l=!1;if(o===n){const{providerExtUri:m,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(l=m.isEqual(c,a)),l&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&m.isEqualOrParent(a,c))throw new Error((0,t.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const f=await this.exists(a);if(f&&!l){if(!r)throw new d.FileOperationError((0,t.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(o===n){const{providerExtUri:m}=this.getExtUri(o);if(m.isEqualOrParent(c,a))throw new Error((0,t.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:f,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const n=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,n)),n}async mkdirp(o,c){const n=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(c,a.dirname(c));)try{if(((await o.stat(c)).type&d.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,d.toFileSystemProviderErrorCode)(s)!==d.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(a.basename(c)),c=a.dirname(c)}for(let s=n.length-1;s>=0;s--){c=a.joinPath(c,n[s]);try{await o.mkdir(c)}catch(r){if((0,d.toFileSystemProviderErrorCode)(r)!==d.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(n){return n}return!0}async doValidateDelete(o,c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!c?.useTrash&&!(n.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(o)));let s;try{s=await n.stat(o)}catch(l){}if(s)this.throwIfFileIsReadonly(o,s);else throw new d.FileOperationError((0,t.localize)(20,null,this.resourceForError(o)),1);if(!!!c?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(o)))}return n}async del(o,c){const n=await this.doValidateDelete(o,c),a=!!c?.useTrash,s=!!c?.recursive;await n.delete(o,{recursive:s,useTrash:a}),this._onDidRunOperation.fire(new d.FileOperationEvent(o,1))}onDidChangeFile(o,c){this._onDidChangeFilesRaw.fire({changes:o});let n,a;{for(const s of o)this.watchedResources.has(s.resource)?(n||(n=[]),n.push(s)):(a||(a=[]),a.push(s));n&&this._onDidFilesChange.fire(new d.FileChangesEvent(n,!c))}if(a){const s=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,c={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let a=!1,s=()=>{a=!0};return n.add((0,h.toDisposable)(()=>s())),this.doWatch(o,c).then(r=>{a?(0,h.dispose)(r):s=()=>(0,h.dispose)(r)},r=>this.logService.error(r)),c.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),n.add((0,h.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),n}async doWatch(o,c){const n=await this.withProvider(o),a=this.toWatchKey(n,o,c);let s=this.activeWatchers.get(a);return s||(s={count:0,disposable:n.watch(o,c)},this.activeWatchers.set(a,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.activeWatchers.delete(a)))})}toWatchKey(o,c,n){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(c),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,h.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,c,n,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,s,a):await this.doWriteReadableBufferedQueued(o,s,a)}catch(r){throw(0,d.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,c,n){let a=0,s;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(o,c,r,r.byteLength,a,0),a+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,l)=>{(0,p.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,c,f,f.byteLength,a,0)}catch(m){return l(m)}a+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>l(f),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,c,n){let a=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(o,c,s,s.byteLength,a,0),a+=s.byteLength}async doWriteBuffer(o,c,n,a,s,r){let l=0;for(;l<a;)l+=await o.write(c,s+l,n.buffer,r+l,a-l)}async doWriteUnbuffered(o,c,n,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,n,a))}async doWriteUnbufferedQueued(o,c,n,a){let s;a instanceof D.VSBuffer?s=a:(0,p.isReadableStream)(a)?s=await(0,D.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?s=await(0,D.bufferedStreamToBuffer)(a):s=(0,D.readableToBuffer)(a),await o.writeFile(c,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(o,c,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,n,a))}async doPipeBufferedQueued(o,c,n,a){let s,r;try{s=await o.open(c,{create:!1}),r=await n.open(a,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,m=0,k=0;do k=await o.read(s,f,l.buffer,m,l.byteLength-m),await this.doWriteBuffer(n,r,l,k,f,m),f+=k,m+=k,m===l.byteLength&&(m=0);while(k>0)}catch(l){throw(0,d.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,c,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,n,a))}async doPipeUnbufferedQueued(o,c,n,a){return n.writeFile(a,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,n,a))}async doPipeUnbufferedToBufferedQueued(o,c,n,a){const s=await n.open(a,{create:!0,unlock:!1});try{const r=await o.readFile(c);await this.doWriteBuffer(n,s,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,d.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(o,c,n,a){const s=await(0,D.streamToBuffer)(this.readFileBuffered(o,c,M.CancellationToken.None));await this.doWriteUnbuffered(n,a,void 0,s)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new d.FileOperationError((0,t.localize)(22,null,this.resourceForError(c)),6);return o}throwIfFileIsReadonly(o,c){if((c.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,t.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=he([ie(0,v.ILogService)],b),e.FileService=b}),define(Z[96],x([0,1,29,245,9,17,4,33,8,3,15,60,20,145,18,95,92,169,170,171,45,178,55]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(w)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(s)}`)}})();class a extends c.AbstractDiskFileSystemProvider{constructor(r,l){super(r);this.options=l,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:l,symbolicLink:f}=await S.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(l,f),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(r){try{const l=await S.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),f=[];return await Promise.all(l.map(async m=>{try{let k;m.isSymbolicLink()?k=(await this.stat((0,i.joinPath)(r,m.name))).type:k=this.toType(m),f.push([m.name,k])}catch(k){this.logService.trace(k)}})),f}catch(l){throw this.toFileSystemProviderError(l)}}toType(r,l){let f;return l?.dangling?f=t.FileType.Unknown:r.isFile()?f=t.FileType.File:r.isDirectory()?f=t.FileType.Directory:f=t.FileType.Unknown,l&&(f|=t.FileType.SymbolicLink),f}async readFile(r){try{const l=this.toFilePath(r);return await S.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(r,l,f){const m=(0,I.newWriteableStream)(k=>M.VSBuffer.concat(k.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,d.readFileIntoStream)(this,r,m,k=>k.buffer,{...l,bufferSize:256*1024},f),m}async writeFile(r,l,f){let m;try{const k=this.toFilePath(r);if(!f.create||!f.overwrite){if(await S.Promises.exists(k)){if(!f.overwrite)throw(0,t.createFileSystemProviderError)((0,p.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,t.createFileSystemProviderError)((0,p.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(m,0,l,0,l.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(r,k)}finally{typeof m=="number"&&await this.close(m)}}async open(r,l){try{const f=this.toFilePath(r);if((0,t.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:R}=await S.SymlinkSupport.stat(f);R.mode&128||await S.Promises.chmod(f,R.mode|128)}catch(R){this.logService.trace(R)}let m;if((0,t.isFileOpenForWriteOptions)(l)){if(g.isWindows)try{await S.Promises.truncate(f,0),m="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}m||(m="w")}else m="r";const k=await S.Promises.open(f,m);return this.mapHandleToPos.set(k,0),(0,t.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(k,r),k}catch(f){throw(0,t.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(r,f):this.toFileSystemProviderError(f)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await S.Promises.fdatasync(r)}catch(l){this.canFlush=!1,this.logService.error(l)}return await S.Promises.close(r)}catch(l){throw this.toFileSystemProviderError(l)}}async read(r,l,f,m,k){const R=this.normalizePos(r,l);let A=null;try{const F=await S.Promises.read(r,f,m,k,R);return typeof F=="number"?A=F:A=F.bytesRead,A}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(r,R,A)}}normalizePos(r,l){return l===this.mapHandleToPos.get(r)?null:l}updatePos(r,l,f){const m=this.mapHandleToPos.get(r);typeof m=="number"&&(typeof l=="number"||(typeof f=="number"?this.mapHandleToPos.set(r,m+f):this.mapHandleToPos.delete(r)))}async write(r,l,f,m,k){return(0,D.retry)(()=>this.doWrite(r,l,f,m,k),100,3)}async doWrite(r,l,f,m,k){const R=this.normalizePos(r,l);let A=null;try{const F=await S.Promises.write(r,f,m,k,R);return typeof F=="number"?A=F:A=F.bytesWritten,A}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),F)}finally{this.updatePos(r,R,A)}}async mkdir(r){try{await S.Promises.mkdir(this.toFilePath(r))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(r,l){try{const f=this.toFilePath(r);await this.doDelete(f,l)}catch(f){throw this.toFileSystemProviderError(f)}}async doDelete(r,l){l.recursive?await S.Promises.rm(r,S.RimRafMode.MOVE):await S.Promises.unlink(r)}async rename(r,l,f){const m=this.toFilePath(r),k=this.toFilePath(l);if(m!==k)try{await this.validateTargetDeleted(r,l,"move",f.overwrite),await S.Promises.move(m,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(2,null,(0,h.basename)(m),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,l,f){const m=this.toFilePath(r),k=this.toFilePath(l);if(m!==k)try{await this.validateTargetDeleted(r,l,"copy",f.overwrite),await S.Promises.copy(m,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(3,null,(0,h.basename)(m),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,l,f,m){const k=this.toFilePath(r),R=this.toFilePath(l);let A=!1;if(!!(this.capabilities&1024)||(A=(0,E.isEqual)(k,R,!0)),A&&f==="copy")throw(0,t.createFileSystemProviderError)((0,p.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!A&&await S.Promises.exists(R)){if(!m)throw(0,t.createFileSystemProviderError)((0,p.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,l,f,m){let k,R;if(this.options?.watcher?.usePolling)k=u.FileWatcher,R=this.options?.watcher;else{let A=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?A=this.options.legacyWatcher==="on":o.default.quality==="stable"&&(A=r===1),A?g.isLinux?k=u.FileWatcher:k=v.FileWatcher:k=b.FileWatcher}return new k(A=>l(A),A=>f(A),m,R)}createNonRecursiveWatcher(r,l,f,m){return new y.FileWatcher(r,k=>l(k),k=>f(k),m)}toFileSystemProviderError(r){if(r instanceof t.FileSystemProviderError)return r;let l;switch(r.code){case"ENOENT":l=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=t.FileSystemProviderErrorCode.NoPermissions;break;default:l=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(r,l)}async toFileSystemProviderWriteError(r,l){let f=this.toFileSystemProviderError(l);if(r&&f.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await S.SymlinkSupport.stat(this.toFilePath(r));m.mode&128||(f=(0,t.createFileSystemProviderError)(l,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return f}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(Z[185],x([0,1,61,6,21]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(E,h){this.productService=E,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(h);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,i,I]=g;let S=this.trustedExtensionUrlPublicKeys.get(E);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[E],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...S])}const p=Buffer.from(decodeURIComponent(I),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=p.slice(0,6),d=p.readUIntBE(0,6),y=Date.now()-d;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const v=p.slice(6),b=w.createVerify("SHA256");b.write(t),b.write(Buffer.from(i)),b.end();for(let u=0;u<S.length;u++){let o=S[u];if(o!==null){if(typeof o=="string")try{o=w.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),S[u]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${E}:`,c),S[u]=null;continue}if(b.verify(o,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};M=he([ie(0,D.IProductService),ie(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[57],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,13,2,40,10,3,15,7,28,48,6]),function(j,e,w,L,D,M,P,E,h,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends L.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(d,y)=>this.handleResourceRequest(d,y)),t.protocol.interceptFileProtocol(M.Schemas.file,(d,y)=>this.handleFileRequest(d,y)),this._register((0,L.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?L.Disposable.None:(this.validRoots.set(t,!0),(0,L.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,d){const y=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const y=h.URI.parse(t.url),v=M.FileAccess.asFileUri(y);return this.validRoots.findSubstr(v)?d({path:v.fsPath}):this.validExtensions.has((0,E.extname)(v))?d({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}createIPCObjectUrl(){let t;const d=h.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),y=d.toString(),v=async()=>t;return w.ipcMain.handle(y,v),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:d,update:b=>t=b,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),w.ipcMain.removeHandler(y)}}}};S=he([ie(0,i.INativeEnvironmentService),ie(1,I.ILogService)],S),e.ProtocolMainService=S}),define(Z[37],x([0,1,104,14]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,E){w.ok(L.isString(P)),w.ok(L.isObject(E)),w.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,E)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Z[187],x([0,1,4,37]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,g){this.schemasById[D(h)]=g,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new M;L.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[50],x([0,1,31,4,14,133,187,37]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=E.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,o=!0){this.registerConfigurations([u],o)}registerConfigurations(u,o=!0){const c=this.doRegisterConfigurations(u,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(u){const o=this.doDeregisterConfigurations(u);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:u,remove:o}){const c=[];c.push(...this.doDeregisterConfigurations(o)),c.push(...this.doRegisterConfigurations(u,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,w.distinct)(c))}registerDefaultConfigurations(u){const o=[],c=[];for(const n of u)for(const a in n)if(o.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...n[a]};const s={type:"object",default:this.defaultValues[a],description:M.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};c.push(p(a)),this.configurationProperties[a]=s,this.defaultLanguageConfigurationOverridesNode.properties[a]=s}else{this.defaultValues[a]=n[a];const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(u){const o=[];for(const c of u)for(const n in c)if(o.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const a=this.configurationProperties[n];a&&(this.updatePropertyDefaultValue(n,a),this.updateSchema(n,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const o of u)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,o){const c=[];return u.forEach(n=>{c.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),c}doDeregisterConfigurations(u){const o=[],c=n=>{if(n.properties)for(const a in n.properties)o.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,n.properties[a]);n.allOf&&n.allOf.forEach(a=>c(a))};for(const n of u){c(n);const a=this.configurationContributors.indexOf(n);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(u,o=!0,c,n=3){n=D.isUndefinedOrNull(u.scope)?n:u.scope;let a=[],s=u.properties;if(s)for(let l in s){if(o&&y(l)){delete s[l];continue}const f=s[l];if(this.updatePropertyDefaultValue(l,f),e.OVERRIDE_PROPERTY_PATTERN.test(l)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!c?.restrictedConfigurations?.includes(l):f.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),a.push(l)}let r=u.allOf;if(r)for(let l of r)a.push(...this.validateAndRegisterProperties(l,o,c,n));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const o=c=>{let n=c.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let a=c.allOf;a&&a.forEach(o)};o(u)}updateSchema(u,o){switch(e.allSettings.properties[u]=o,o.scope){case 1:e.applicationSettings.properties[u]=o;break;case 2:e.machineSettings.properties[u]=o;break;case 6:e.machineOverridableSettings.properties[u]=o;break;case 3:e.windowSettings.properties[u]=o;break;case 4:e.resourceSettings.properties[u]=o;break;case 5:e.resourceSettings.properties[u]=o,this.resourceLanguageSettingsSchema.properties[u]=o;break}}removeFromSchema(u,o){switch(delete e.allSettings.properties[u],o.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const o=`[${u}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,o){let c=this.defaultValues[u];D.isUndefined(c)&&(c=o.default),D.isUndefined(c)&&(c=t(o.type)),o.default=c}}const S="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(S);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function t(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const d=new I;E.Registry.add(e.Extensions.Configuration,d);function y(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?M.localize(5,null,b):d.getConfigurationProperties()[b]!==void 0?M.localize(6,null,b):null:M.localize(4,null)}e.validateProperty=y;function v(){const b=[],u=d.getConfigurationProperties();for(const o of Object.keys(u))b.push([o,u[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=v}),define(Z[19],x([0,1,43,14,7,50,5,37]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function h(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=h;var g;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(a,s){const r=s?a?s.keys.filter(F=>a.keys.indexOf(F)===-1):[...s.keys]:[],l=a?s?a.keys.filter(F=>s.keys.indexOf(F)===-1):[...a.keys]:[],f=[];if(s&&a){for(const F of a.keys)if(s.keys.indexOf(F)!==-1){const H=v(a.contents,F),te=v(s.contents,F);w.equals(H,te)||f.push(F)}}const m=[],k=F=>{const H={};for(const te of F)for(const se of te.identifiers)H[c(se)]=te;return H},R=s?k(s.overrides):{},A=a?k(a.overrides):{};if(Object.keys(R).length)for(const F of r){const H=R[F];H&&m.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(A).length)for(const F of l){const H=A[F];H&&m.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(R).length&&Object.keys(A).length)for(const F of f){const H=A[F],te=R[F];if(H&&te){const se=I({contents:H.contents,keys:H.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});m.push([(0,M.overrideIdentifierFromKey)(F),[...se.added,...se.removed,...se.updated]])}}return{added:r,removed:l,updated:f,overrides:m}}e.compare=I;function S(a,s){const r=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const m in a[l])f[m]=a[l][m];r.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:p(f,s)})}return r}e.toOverrides=S;function p(a,s){const r=Object.create(null);for(let l in a)t(r,l,a[l],s);return r}e.toValuesTree=p;function t(a,s,r,l){const f=s.split("."),m=f.pop();let k=a;for(let R=0;R<f.length;R++){let A=f[R],F=k[A];switch(typeof F){case"undefined":F=k[A]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${f.slice(0,R+1).join(".")} is ${JSON.stringify(F)}`);return}k=F}if(typeof k=="object"&&k!==null)try{k[m]=r}catch(R){l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=t;function d(a,s){const r=s.split(".");y(a,r)}e.removeFromValueTree=d;function y(a,s){const r=s.shift();if(s.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const l=a[r];typeof l=="object"&&!Array.isArray(l)&&(y(l,s),Object.keys(l).length===0&&delete a[r])}}function v(a,s,r){function l(k,R){let A=k;for(const F of R){if(typeof A!="object"||A===null)return;A=A[F]}return A}const f=s.split("."),m=l(a,f);return typeof m=="undefined"?r:m}e.getConfigurationValue=v;function b(a,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(s[l])?b(a[l],s[l],r):r&&(a[l]=s[l]):a[l]=s[l])})}e.merge=b;function u(){const a=E.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=u;function o(){const a=Object.create(null),s=E.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;t(a,r,l,f=>console.error(`Conflict in default settings: ${f}`))}return a}e.getDefaultValues=o;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function n(a,s,r){const l=a.inspect(s),f=a.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=n}),define(Z[188],x([0,1,31,4,39,2,40,43,14,7,19,50,37]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},a=[],s=[]){this._contents=n,this._keys=a,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,a){const s=this.getContentsForOverrideIdentifer(a);return s?n?(0,i.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){for(const a of this.overrides)if(a.identifiers.indexOf(n)!==-1)return a.keys;return[]}override(n){let a=this.overrideConfigurations.get(n);return a||(a=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,a)),a}merge(...n){const a=E.deepClone(this.contents),s=E.deepClone(this.overrides),r=[...this.keys];for(const l of n){this.mergeContents(a,l.contents);for(const f of l.overrides){const[m]=s.filter(k=>w.equals(k.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):s.push(E.deepClone(f))}for(const f of l.keys)r.indexOf(f)===-1&&r.push(f)}return new p(a,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const a=this.getContentsForOverrideIdentifer(n);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let s={};for(const r of w.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[r],f=a[r];f&&(typeof l=="object"&&typeof f=="object"?(l=E.deepClone(l),this.mergeContents(l,f)):l=f),s[r]=l}return new p(s,this.keys,this.overrides)}mergeContents(n,a){for(const s of Object.keys(a)){if(s in n&&h.isObject(n[s])&&h.isObject(a[s])){this.mergeContents(n[s],a[s]);continue}n[s]=E.deepClone(a[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?E.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const a of this.overrides)if(a.identifiers.indexOf(n)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,a){this.addKey(n),(0,i.addToValueTree)(this.contents,n,a,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let a=this.keys.length;for(let s=0;s<a;s++)n.indexOf(this.keys[s])===0&&(a=s);this.keys.splice(a,1,n)}removeKey(n){let a=this.keys.indexOf(n);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(){const n=(0,i.getDefaultValues)(),a=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(n[r]),contents:(0,i.toValuesTree)(n[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(n,a,s)}}e.DefaultConfigurationModel=t;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,a){if(!h.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,a)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,a){this._raw=n;const{contents:s,keys:r,overrides:l,restricted:f}=this.doParseRaw(n,a);this._configurationModel=new p(s,r,l),this._restrictedConfigurations=f||[]}doParseContent(n){let a={},s=null,r=[],l=[],f=[];function m(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let k={onObjectBegin:()=>{let R={};m(R),l.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let R=[];m(R),l.push(r),r=R,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:m,onError:(R,A,F)=>{f.push({error:R,offset:A,length:F})}};if(n)try{D.visit(n,k),a=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(n,a){const s=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,s,!0,a);n=r.raw;const l=(0,i.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(n),m=(0,i.toOverrides)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:l,keys:f,overrides:m,restricted:r.restricted}}filter(n,a,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const l={},f=[];for(let m in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const k=this.filter(n[m],a,!1,r);l[m]=k.raw,f.push(...k.restricted)}else{const k=a[m],R=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&f.push(m),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&k?.restricted||(l[m]=n[m]))}return{raw:l,restricted:f}}}e.ConfigurationModelParser=d;class y extends M.Disposable{constructor(n,a,s,r){super();this.userSettingsResource=n,this.scopes=a,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class v{constructor(n,a,s=new p,r=new p,l=new P.ResourceMap,f=new p,m=new P.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,a,s){return this.getConsolidateConfigurationModel(a,s).getValue(n)}updateValue(n,a,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,a===void 0?r.removeValue(n):r.setValue(n,a),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,a,s){const r=this.getConsolidateConfigurationModel(a,s),l=this.getFolderConfigurationModelForResource(a.resource,s),f=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,m=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),F=s?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,H=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,te=a.overrideIdentifier?f.override(a.overrideIdentifier).getValue(n):f.getValue(n),se=r.getValue(n),G=w.distinct(w.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(n,ee)!==void 0);return{defaultValue:m,userValue:k,userLocalValue:R,userRemoteValue:A,workspaceValue:F,workspaceFolderValue:H,memoryValue:te,value:se,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:l?.freeze().getValue(n),override:a.overrideIdentifier?l?.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:f.getValue(n),override:a.overrideIdentifier?f.getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(n){const a=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,a){this._folderConfigurations.set(n,a),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,a){const s=a.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,I.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=n.getKeysForOverrideIdentifier(l),k=[...m.filter(R=>f.indexOf(R)===-1),...f.filter(R=>m.indexOf(R)===-1),...f.filter(R=>!E.equals(this._defaultConfiguration.override(l).getValue(R),n.override(l).getValue(R)))];return[l,k]});return this.updateDefaultConfiguration(n),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,n),f=[...a,...s,...r];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,n);let f=[...a,...s,...r];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,n);let f=[...a,...s,...r];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(n,a){const s=this.folderConfigurations.get(n),{added:r,updated:l,removed:f,overrides:m}=(0,i.compare)(s,a);let k=[...r,...l,...f];return(k.length||!s)&&this.updateFolderConfiguration(n,a),{keys:k,overrides:m}}compareAndDeleteFolderConfiguration(n){const a=this.folderConfigurations.get(n);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:l,overrides:f}=(0,i.compare)(a,void 0);return{keys:[...s,...r,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,a){let s=this.getConsolidatedConfigurationModelForResource(n,a);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},a){let s=this.getWorkspaceConsolidatedConfiguration();if(a&&n){const r=a.getFolder(n);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let a=this._foldersConsolidatedConfigurations.get(n);if(!a){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(a=s.merge(r),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(n,a)):a=s}return a}getFolderConfigurationModelForResource(n,a){if(a&&n){const s=a.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,a)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(a);return n.push([a,{contents:s,overrides:r,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>n.add(a)),this.userConfiguration.freeze().keys.forEach(a=>n.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>a.add(r))),[...a.values()]}static parse(n){const a=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),r=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((f,m)=>(f.set(g.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new P.ResourceMap);return new v(a,s,new p,r,l,new p,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function b(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,a=new Map;for(const r of c)r.keys.forEach(l=>n.add(l)),r.overrides.forEach(([l,f])=>{const m=(0,P.getOrSet)(a,l,new Set);f.forEach(k=>m.add(k))});const s=[];return a.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=b;class u{constructor(n,a,s,r){this.change=n,this.previous=a,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(m=>l.add(m)),n.overrides.forEach(([,m])=>m.forEach(k=>l.add(k))),this.affectedKeys=[...l.values()];const f=new p;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(a){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,a,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,a,this.currentWorkspace);return!E.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(n,a){let s=(0,i.toValuesTree)({[a]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(n=n[r],!n)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class o extends u{constructor(n,a,s,r){super({keys:n.allKeys(),overrides:[]},void 0,n,a);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[189],x([0,1,9,4,2,15,19,188,50,37]),function(j,e,w,L,D,M,P,E,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(S,p){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,p)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,p){const t=typeof S=="string"?S:void 0,d=(0,P.isConfigurationOverrides)(S)?S:(0,P.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,d,void 0)}updateValue(S,p,t,d){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(t,p,1)}onDidDefaultConfigurationChange(S){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,S);this.trigger(t,p,6)}trigger(S,p,t){const d=new E.ConfigurationChangeEvent(S,{data:p},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[190],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,E=L.Unknown,h){super(P);this._message=P,this._code=E,this._detail=h,this.isHandled=E===L.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[191],x([0,1,9,17,23,16,4,2,28,85,190]),function(j,e,w,L,D,M,P,E,h,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var S;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function p(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const z=new D.CancellationTokenSource;return setTimeout(()=>z.cancel(),W),z.token}function d(W,z){if(W.isCancellationRequested||z.isCancellationRequested)return D.CancellationToken.Cancelled;const K=new D.CancellationTokenSource;return W.onCancellationRequested(()=>K.cancel()),z.onCancellationRequested(()=>K.cancel()),K.token}class y{constructor(z){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((K,O)=>{this._resolvePromise=K,this._rejectPromise=O}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function v(W,z){const K=new y(z);return K.registerDisposable(W.onControlMessage(O=>{const q=JSON.parse(O.toString()),C=N(q);C?K.reject(C):K.resolve(q)})),K.promise}function b(W,z,K,O,q,C){const $=new y(C);return z.connect(K,O,q,(J,Q)=>{$.didTimeout?(J&&W.error(J),Q?.dispose()):J||!Q?$.reject(J):$.resolve(Q)}),$.promise}function u(W,z){const K=new y(z);return W.then(O=>{K.didTimeout||K.resolve(O)},O=>{K.didTimeout||K.reject(O)}),K.promise}async function o(W,z,K,O){const q=_(W,z);W.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let C;try{C=await b(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,O)}catch(le){throw W.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(le),le}W.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let $,J;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(C,null),$=W.reconnectionProtocol,J=!1):($=new g.PersistentProtocol(C,null),J=!0),W.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const Q=await u(W.signService.createNewMessage((0,h.generateUuid)()),O),ne={type:"auth",auth:W.connectionToken||"00000000000000000000",data:Q.data};$.sendControl(L.VSBuffer.fromString(JSON.stringify(ne)));try{const le=await v($,d(O,t(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(W.logService.trace(`${q} 4/6. received SignRequest control message.`),!await u(W.signService.validate(Q,le.signedData),O)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const re=await u(W.signService.sign(le.data),O),ce={type:"connectionType",commit:W.commit,signedData:re,desiredConnectionType:z};return K&&(ce.args=K),W.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(L.VSBuffer.fromString(JSON.stringify(ce))),{protocol:$,ownsProtocol:J}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(W.logService.error(`${q} the handshake timed out. Error:`),W.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${q} received error control message when negotiating connection. Error:`),W.logService.error(le)),J&&V($),le}}async function c(W,z,K,O){const q=Date.now(),C=_(W,z),{protocol:$,ownsProtocol:J}=await o(W,z,K,O),Q=new y(O);return Q.registerDisposable($.onControlMessage(ne=>{const le=JSON.parse(ne.toString()),oe=N(le);oe?(W.logService.error(`${C} received error control message when negotiating connection. Error:`),W.logService.error(oe),J&&V($),Q.reject(oe)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${X(q)}!`),Q.resolve({protocol:$,firstMessage:le}))})),Q.promise}async function n(W,z){const{protocol:K}=await c(W,1,void 0,z);return{protocol:K}}async function a(W,z,K){const{protocol:O,firstMessage:q}=await c(W,2,z,K),C=q&&q.debugPort;return{protocol:O,debugPort:C}}async function s(W,z,K){const O=Date.now(),q=_(W,3),{protocol:C}=await o(W,3,z,K);return W.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${X(O)}!`),C}async function r(W,z,K){const{host:O,port:q,connectionToken:C}=await W.addressProvider.getAddress();return{commit:W.commit,host:O,port:q,connectionToken:C,reconnectionToken:z,reconnectionProtocol:K,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function l(W,z,K){try{const O=(0,h.generateUuid)(),q=await r(W,O,null),{protocol:C}=await n(q,D.CancellationToken.None);return new ee(W,z,K,O,C)}catch(O){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(O),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentManagement=l;async function f(W,z){try{const K=(0,h.generateUuid)(),O=await r(W,K,null),{protocol:q,debugPort:C}=await a(O,z,D.CancellationToken.None);return new T(W,z,K,q,C)}catch(K){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(K),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=f;async function m(W,z,K){const O=await r(W,(0,h.generateUuid)(),null);return await s(O,{host:z,port:K},D.CancellationToken.None)}e.connectRemoteAgentTunnel=m;function k(W){return(0,w.createCancelablePromise)(z=>new Promise((K,O)=>{const q=setTimeout(K,W*1e3);z.onCancellationRequested(()=>{clearTimeout(q),K()})}))}var R;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(z,K){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=A;class F{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.durationSeconds=O,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class H{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=H;class te{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=4}}e.ConnectionGainEvent=te;class se{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class G extends E.Disposable{constructor(z,K,O,q){super();this._connectionType=z,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=O,this.protocol=q,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(q.onSocketClose(C=>{const $=U(this._connectionType,this.reconnectionToken,!0);C?C.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${C.hadError}).`),C.error&&this._options.logService.error(C.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${C.wasClean}, code: ${C.code}, reason: ${C.reason}).`),C.event&&this._options.logService.error(C.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(()=>{const C=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${C} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(z,K,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=K,this._permanentFailureHandled=O,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const z=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const q=O<K.length?K[O]:K[K.length-1];try{if(q>0){const $=k(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,$)),this._options.logService.info(`${z} waiting for ${q} seconds before reconnecting...`);try{await $}catch{}}if(G._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${z} resolving connection...`);const C=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${C.host}:${C.port}...`),await this._reconnect(C,t(I)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(C){if(C.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(C)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((C.code==="ETIMEDOUT"||C.code==="ENETUNREACH"||C.code==="ECONNREFUSED"||C.code==="ECONNRESET")&&C.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((0,M.isPromiseCanceledError)(C)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if(C instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,i.RemoteAuthorityResolverError.isHandled(C));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(z,K,O){this._onDidStateChange.fire(new se(this.reconnectionToken,z,K,O)),V(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class ee extends G{constructor(z,K,O,q,C){super(1,z,q,C);this.client=this._register(new g.Client(C,{remoteAuthority:K,clientId:O},z.ipcLogger))}async _reconnect(z,K){await n(z,K)}}e.ManagementPersistentConnection=ee;class T extends G{constructor(z,K,O,q,C){super(2,z,O,q);this._startArguments=K,this.debugPort=C}async _reconnect(z,K){await a(z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=T;function V(W){try{W.acceptDisconnect();const z=W.getSocket();W.dispose(),z.dispose()}catch(z){(0,M.onUnexpectedError)(z)}}function N(W){if(W&&W.type==="error"){const z=new Error(`Connection error: ${W.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function B(W,z){for(;W.length<z;)W+=" ";return W}function U(W,z,K){return`[remote-connection][${B(p(W),13)}][${z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function _(W,z){return`${U(z,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function X(W){return`${Date.now()-W} ms`}}),define(Z[63],x([0,1,10]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=L;function D(g){if(!g)return;const i=g.indexOf("+");return i<0?g:g.substr(0,i)}e.getRemoteName=D;function M(g){return g.scheme!==w.Schemas.file&&g.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=M;function P(g){if(g.folders.length)return g.folders.every(i=>M(i.uri))?g.folders[0].uri:void 0;if(g.configuration&&M(g.configuration))return g.configuration}e.getVirtualWorkspaceLocation=P;function E(g){return P(g)?.scheme}e.getVirtualWorkspaceScheme=E;function h(g){return P(g)!==void 0}e.isVirtualWorkspace=h}),define(Z[192],x([0,1,25,5,63]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=M;function P(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,t){if(typeof p=="undefined"||p===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof p=="string"||typeof t=="string"){let d=typeof p=="string"?p:p.value,y=typeof t=="string"?t:t.value;return w.equalsIgnoreCase(d,y)}return p._lower===t._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=h;function g(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function i(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(S,p){if(p&&S.enableProposedApi){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return S.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[193],x([0,1,25,192]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,d){return t.uuid&&d.uuid?t.uuid===d.uuid:t.id===d.id?!0:(0,w.compareIgnoreCase)(t.id,d.id)===0}e.areSameExtensions=D;class M{constructor(d,y){this.version=y,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof M?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=M;function P(t,d){return`${t}.${d}`}e.getExtensionId=P;function E(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function h(t,d){return E(P(t,d))}e.getGalleryExtensionId=h;function g(t,d){const y=[],v=b=>{for(const u of y)if(u.some(o=>D(d(o),d(b))))return u;return null};for(const b of t){const u=v(b);u?u.push(b):y.push([b])}return y}e.groupByExtension=g;function i(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function S(t){const d=new Set;for(const y of t)y.malicious&&d.add(y.id.id);return d}e.getMaliciousExtensionsSet=S;function p(t,d){const y=[],v=d.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const b=v.shift();if(b&&y.every(u=>!D(u.identifier,{id:b}))){const u=t.filter(o=>D(o.identifier,{id:b}));u.length===1&&(y.push(u[0]),v.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(Z[97],x([0,1,4,3,5,6]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function S(t,d){return d?d!==1&&t<1024:!L.isWindows&&t<1024}e.isPortPrivileged=S;let p=class{constructor(d){this.logService=d,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,y){return this._tunnelProvider=d,d?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],y=Array.from(this._tunnels.values());for(let v of y){const b=Array.from(v.values());for(let u of b){const o=await u.value;o&&d.push(o)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:y}of d.values())await y.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,y,v,b,u=!1,o=E.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${v} on local port ${b}.`),!d)return;y||(y="localhost");const n=this.retainOrCreateTunnel(d,y,v,b,u,o,c);return n?n.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(a);return(a.tunnelRemoteHost!==y||a.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const y=this._tunnels.get(d.tunnelRemoteHost);if(y){const v=y.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,y,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${y}.`);const b=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(y),b}}async closeTunnel(d,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${y} `);const v=this._tunnels.get(d);if(v&&v.has(y)){const b=v.get(y);b.refcount=0,await this.tryDisposeTunnel(d,y,b)}}addTunnelToMap(d,y,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(y,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,y){const v=this._tunnels.get(d);v&&(await v.get(y)||v.delete(y),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,y){let v=[d];i(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const b=v.map(u=>this._tunnels.get(u));for(const u of b){const o=u?.get(y);if(o)return o}}canTunnel(d){return!!g(d)}createWithProvider(d,y,v,b,u,o,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${v} on local port ${b}.`);const a={elevationRequired:u?S(b===void 0?v:b):!1},s={remoteAddress:{host:y,port:v},localAddressPort:b,privacy:o,public:o!==E.Private,protocol:c},r=d.forwardPort(s,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(y,v,r),r}};p=he([ie(0,M.ILogService)],p),e.AbstractTunnelService=p}),define(Z[51],x([0,1,17,149,50,5,37]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function h(t){return t.res.statusCode===204}async function g(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=g;async function i(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const y=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(y)}catch(v){throw v.message+=`:
`+y,v}}e.asJson=i;function I(t){p(t)}e.updateProxyConfigurationsScope=I;let S;function p(t){const d=P.Registry.as(D.Extensions.Configuration),y=S;S={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[S],remove:y?[y]:[]})}p(2)}),define(Z[194],x([0,1,195,14]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,E){return P.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:P.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(P,E,h={}){const g=(0,w.parse)(P),i=h.proxyUrl||D(g,E);if(!i)return null;const I=(0,w.parse)(i);if(!/^https?:$/.test(I.protocol||""))return null;const S={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((p,t)=>{j(["http-proxy-agent"],p,t)}))(S):new(await new Promise((p,t)=>{j(["https-proxy-agent"],p,t)}))(S)}e.getProxyAgent=M}),define(Z[196],x([0,1,17,28]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,P,E){let h=E&&E.get("storage.serviceMachineId",0)||null;if(h)return h;try{const i=(await P.readFile(M.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(i)?i:null}catch(g){h=null}if(!h){h=(0,L.generateUuid)();try{await P.writeFile(M.serviceMachineIdResource,w.VSBuffer.fromString(h))}catch(g){}}return E&&E.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=D}),define(Z[77],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[197],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((D,M)=>j(["vsda"],D,M))}async createNewMessage(D){try{const M=await this.vsda(),P=new M.validator;if(P){const E=String(w._nextId++);return this.validators.set(E,P),{id:E,data:P.createNewMessage(D)}}}catch(M){}return{id:"",data:D}}async validate(D,M){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(M)==="ok"}catch(E){return!1}}async sign(D){try{const M=await this.vsda(),P=new M.signer;if(P)return P.sign(D)}catch(M){}return D}}e.SignService=w,w._nextId=1}),define(Z[38],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[22],x([0,1,13,9,4,2,3,32,14,5,176,6,38]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var p;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ct extends M.Disposable{constructor(y,v){super();this.logService=y,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};w.app.addListener("before-quit",y);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",v),w.app.once("will-quit",b=>{this.logService.trace("Lifecycle#app.on(will-quit)"),b.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",y),w.app.removeListener("window-all-closed",v),w.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const y=[];return this._onWillShutdown.fire({join(v){y.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(y)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let v=this.phaseWhen.get(y);v||(v=new L.Barrier,this.phaseWhen.set(y,v)),await v.wait()}registerWindow(y){const v=new M.DisposableStore;this.windowCounter++,v.add(y.onWillLoad(u=>this._onWillLoadWindow.fire({window:y,workspace:u.workspace,reason:u.reason})));const b=(0,h.assertIsDefined)(y.win);b.on("close",u=>{const o=y.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),u.preventDefault(),this.unload(y,1).then(c=>{if(c){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(y),y.close()})}),b.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(y,v){await this.unload(y,3)||y.reload(v)}async unload(y,v){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const b=this._quitRequested?2:v;let u=await this.onBeforeUnloadWindowInRenderer(y,b);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(y,b),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${y.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${y.id})`),await this.onWillUnloadWindowInRenderer(y,b),!1))}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,v){return new Promise(b=>{const u=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${u}`,c=`vscode:cancel${u}`;w.ipcMain.once(o,()=>{b(!1)}),w.ipcMain.once(c,()=>{b(!0)}),y.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(y,v){const b=[];return this._onBeforeUnloadWindow.fire({reason:v,window:y,veto(u){b.push(u)}}),(0,i.handleVetos)(b,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(y,v){return new Promise(b=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(o,()=>b()),y.send("vscode:onWillUnload",{replyChannel:o,reason:v})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${y}`),y&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(y){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(y?.addArgs&&v.push(...y.addArgs),y?.removeArgs)for(const o of y.removeArgs){const c=v.indexOf(o);c>=0&&v.splice(c,1)}const b=()=>{try{if(P.isWindows){const o=(0,E.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:v})};w.app.once("quit",b),await this.quit(!0)&&w.app.removeListener("quit",b)}async kill(y){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of w.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let b;v.webContents&&!v.webContents.isDestroyed()?b=new Promise(u=>v.once("closed",u)):b=Promise.resolve(),v.destroy(),await b}})()]),w.app.exit(y)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([ie(0,I.ILogService),ie(1,S.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[198],x([0,1,4,2,5,22]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(g){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((i,I)=>{j(["native-keymap"],i,I)});this._keyboardLayoutData=E(g),g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([ie(0,M.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function E(h){const g=h.getKeyMap(),i=h.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:i}}}),define(Z[98],x([0,1,9,4,2,14,87,5]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var g;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(y={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,v){v===h?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:v,target:this.getKeyTargets(y)[v]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,v,b){return this.getStorage(v)?.get(y,b)}getBoolean(y,v,b){return this.getStorage(v)?.getBoolean(y,b)}getNumber(y,v,b){return this.getStorage(v)?.getNumber(y,b)}store(y,v,b,u){if((0,M.isUndefinedOrNull)(v)){this.remove(y,b);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,b,u),this.getStorage(b)?.set(y,v)})}remove(y,v){this.withPausedEmitters(()=>{this.updateKeyTarget(y,v,void 0),this.getStorage(v)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,v){const b=[],u=this.getKeyTargets(y);for(const o of Object.keys(u))u[o]===v&&b.push(o);return b}updateKeyTarget(y,v,b){const u=this.getKeyTargets(v);typeof b=="number"?u[y]!==b&&(u[y]=b,this.getStorage(v)?.set(h,JSON.stringify(u))):typeof u[y]=="number"&&(delete u[y],this.getStorage(v)?.set(h,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const v=this.get(h,y);if(v)try{return JSON.parse(v)}catch(b){}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=g.NONE){this._onWillSaveState.fire({reason:y}),await w.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const y=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return t(y,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends S{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=p;async function t(d,y,v,b){const u=l=>{try{return JSON.parse(l)}catch(f){return l}},o=new Map,c=new Map;d.forEach((l,f)=>{o.set(f,l),c.set(f,u(l))});const n=new Map,a=new Map;y.forEach((l,f)=>{n.set(f,l),a.set(f,u(l))}),console.group(`Storage: Global (path: ${v})`);let s=[];o.forEach((l,f)=>{s.push({key:f,value:l})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${b})`);let r=[];n.forEach((l,f)=>{r.push({key:f,value:l})}),console.table(r),console.groupEnd(),console.log(a)}e.logStorage=t}),define(Z[199],x([0,1,3,32,7,28]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(g){if(w.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function E(g,i,I,S,p,t,d,y,v,b){const u=Object.create(null);u["common.machineId"]=d,u.sessionID=(0,M.generateUuid)()+Date.now(),u.commitHash=p,u.version=t,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,w.PlatformToString)(w.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=S,u["common.product"]=b||"desktop";const o=h(y||[]);o&&(u["common.msftInternal"]=o);let c=0;const n=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(u["common.snap"]="true");const a=P(I);a&&(u["common.platformDetail"]=a);try{const s=await g.readFile(D.URI.file(v));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=E;function h(g){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return g.some(S=>I===S)}e.verifyMicrosoftInternalDomain=h}),define(Z[30],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[200],x([0,1,26,68,9,39,10,8,3,7,70,20,84,74,18,21,30]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(n,a){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,l=new Map,f=2e4;function m(A,F,H,te){const se=F.substring(A.length+1);return D.Promises.withAsyncBody(async G=>{let ee;try{ee=await I.Promises.readdir(F,{withFileTypes:!0})}catch(N){G();return}if(te.count>=f){te.count+=ee.length,te.maxReached=!0,G();return}let T=ee.length;if(T===0){G();return}let V=ee;te.count+ee.length>f&&(te.maxReached=!0,T=f-te.count,V=ee.slice(0,T)),te.count+=ee.length;for(const N of V)if(N.isDirectory()){if(H.includes(N.name)||await m(A,(0,E.join)(F,N.name),H,te),--T==0){G();return}}else{const B=N.name.lastIndexOf(".");if(B>=0){const U=N.name.substring(B+1);U&&r.set(U,(r.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(se)!==!1&&U.filePattern.test(N.name)&&l.set(U.tag,(l.get(U.tag)??0)+1);if(--T==0){G();return}}})}const k={count:0,maxReached:!1};await m(n,n,a,k);const R=await o(n);return{configFiles:b(l),fileTypes:b(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function b(n){return[...L.Iterable.map(n.entries(),([a,s])=>({name:a,count:s}))].sort((a,s)=>s.count-a.count)}function u(){const n={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},a=w.cpus();return a&&a.length>0&&(n.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),n}e.getMachineInfo=u;async function o(n){try{const a=new Map,s=(0,E.join)(n,".vscode","launch.json"),r=await I.Promises.readFile(s),l=[],f=(0,M.parse)(r.toString(),l);if(l.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(f)==="object"&&f.configurations)for(const m of f.configurations){const k=m.type;k&&(a.has(k)?a.set(k,a.get(k)+1):a.set(k,1))}return b(a)}catch(a){return[]}}e.collectLaunchConfigs=o;let c=class{constructor(a,s){this.telemetryService=a,this.productService=s}formatMachineInfo(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}formatEnvironment(a){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const r=w.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||s.push(`Load (avg):       ${w.loadavg().map(l=>Math.round(l)).join(", ")}`),s.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,S.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async r=>{let[l,f]=r,m=this.formatProcessList(a,l);return s.forEach(k=>{if((0,p.isRemoteDiagnosticError)(k))m+=`
${k.errorMessage}`,f+=`
${k.errorMessage}`;else if(m+=`

Remote: ${k.hostName}`,k.processes&&(m+=`
${this.formatProcessList(a,k.processes)}`),k.workspaceMetadata){f+=`
|  Remote: ${k.hostName}`;for(const R of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[R];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),f+=`|    Folder (${R}): ${F}`,f+=this.formatWorkspaceStats(A)}}}),{processInfo:m,workspaceInfo:f}})}async getSystemInfo(a,s){const{memory:r,vmHint:l,os:f,cpus:m}=u(),k={os:f,memory:r,cpus:m,vmHint:l,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return h.isWindows||(k.load=`${w.loadavg().map(R=>Math.round(R)).join(", ")}`),h.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(a,s){const r=[];return(0,S.listProcesses)(a.mainPID).then(async l=>(r.push(""),r.push(this.formatEnvironment(a)),r.push(""),r.push(this.formatProcessList(a,l)),a.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(a))),s.forEach(f=>{if((0,p.isRemoteDiagnosticError)(f))r.push(`
${f.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${f.hostName}`),r.push(this.formatMachineInfo(f.machineInfo)),f.processes&&r.push(this.formatProcessList(a,f.processes)),f.workspaceMetadata)for(const m of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[m];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${m}): ${R}`),r.push(this.formatWorkspaceStats(k))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(a){const s=[],r=60;let l=0;const f=(A,F)=>{const H=` ${A}(${F})`;l+H.length>r?(s.push(m),m="|                 ",l=m.length):l+=H.length,m+=H};let m="|      File types:";const k=10;let R=a.fileTypes.length>k?k:a.fileTypes.length;for(let A=0;A<R;A++){const F=a.fileTypes[A];f(F.name,F.count)}if(s.push(m),a.configFiles.length>=0&&(m="|      Conf files:",l=0,a.configFiles.forEach(A=>{f(A.name,A.count)}),s.push(m)),a.launchConfigFiles.length>0){let A="|      Launch Configs:";a.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(a){const s=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${a[r]}`).join(`
                  `)}formatWorkspaceMetadata(a){const s=[],r=[];return a.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(s.push(`|  Window (${l.title})`),l.folderURIs.forEach(f=>{const m=g.URI.revive(f);if(m.scheme===P.Schemas.file){const k=m.fsPath;r.push(v(k,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,E.basename)(k)}): ${A}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${R.toString()})`)}))}else s.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(l=>s.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(a,s){const r=new Map;a.windows.forEach(f=>r.set(f.pid,f.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(a.mainPID,r,l,s,0),l.join(`
`)}formatProcessItem(a,s,r,l,f){const m=f===0;let k;m?k=l.pid===a?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(f)} ${l.name}`,l.name==="window"&&(k=`${k} (${s.get(l.pid)})`));const R=process.platform==="win32"?l.mem:w.totalmem()*(l.mem/100);r.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(l.children)&&l.children.forEach(A=>this.formatProcessItem(a,s,r,A,f+1))}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const r=g.URI.revive(s);if(r.scheme!==P.Schemas.file)continue;const l=r.fsPath;try{const f=await v(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),f.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:m.name,count:m.count})}),f.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:m.name,count:m.count})}),f.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};c=he([ie(0,y.ITelemetryService),ie(1,d.IProductService)],c),e.DiagnosticsService=c}),define(Z[201],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(M){this.appenders=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:E,data:h}){return this.appenders.forEach(g=>g.log(E,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class L{constructor(M){this.channel=M}log(M,P){return this.channel.call("log",{eventName:M,data:P}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[64],x([0,1,43,14,19,30]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,b){return Promise.resolve(void 0)}publicLog2(v,b){return this.publicLog(v,b)}publicLogError(v,b){return Promise.resolve(void 0)}publicLogError2(v,b){return this.publicLogError(v,b)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(v,b,u){}async publicLogError(v,b,u){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(y,v){return v.onDidChangeConfiguration(b=>{b.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(b.source),configurationKeys:t(b.sourceConfig)})})}e.configurationTelemetry=h;function g(y,v){return!(v.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=g;function i(y){const v=y.getValue(M.TELEMETRY_SETTING_ID),b=y.getValue("telemetry.enableCrashReporter");if(y.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(y){const v=Object.create(null),b=Object.create(null),u=Object.create(null);p(y,u);for(let o in u){o=o.length>150?o.substr(o.length-149):o;const c=u[o];typeof c=="number"?b[o]=c:typeof c=="boolean"?b[o]=c?1:0:typeof c=="string"?v[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(v[o]=c)}return{properties:v,measurements:b}}e.validateTelemetryData=I;function S(y){if(!y)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{y.indexOf(`${u}+`)===0&&(v=u)}),v}e.cleanRemoteAuthority=S;function p(y,v,b=0,u){if(!!y)for(let o of Object.getOwnPropertyNames(y)){const c=y[o],n=u?u+o:o;Array.isArray(c)?v[n]=(0,w.safeStringify)(c):c instanceof Date?v[n]=c.toISOString():(0,L.isObject)(c)?b<2?p(c,v,b+1,n+"."):v[n]=(0,w.safeStringify)(c):v[n]=c}}function t(y){if(!y)return[];const v=[];return d(v,"",y),v}function d(y,v,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(u=>d(y,v?`${v}.${u}`:u,b[u])):y.push(v)}}),define(Z[202],x([0,1,31,23,16,43,3,32,7,19,48,166,193,164,18,6,21,51,196,98,30,64]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=P.isWeb?"web":(0,I.getTargetPlatform)(P.platform,E.arch);var a;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished"})(a||(a={}));function s(...C){return String(C.reduce(($,J)=>$|J,0))}var r;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class R{constructor($=k){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,J=this.state.pageSize){return new R({...this.state,pageNumber:$,pageSize:J})}withFilter($,...J){const Q=[...this.state.criteria,...J.length?J.map(ne=>({filterType:$,value:ne})):[{filterType:$}]];return new R({...this.state,criteria:Q})}withSortBy($){return new R({...this.state,sortBy:$})}withSortOrder($){return new R({...this.state,sortOrder:$})}withFlags(...$){return new R({...this.state,flags:$.reduce((J,Q)=>J|Q,0)})}withAssetTypes(...$){return new R({...this.state,assetTypes:$})}get raw(){const{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:le,flags:oe,assetTypes:re}=this.state;return{filters:[{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:le}],assetTypes:re,flags:oe}}get searchText(){const $=this.state.criteria.filter(J=>J.filterType===r.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(C,$){const J=(C||[]).filter(Q=>Q.statisticName===$)[0];return J?J.value:0}function F(C){const $="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(Q=>Q.assetType.indexOf($)===0).reduce((Q,ne)=>{const le=G(C,ne.assetType);return le&&Q.push([ne.assetType.substring($.length),le]),Q},[])}function H(C){if(C.properties){const $=C.properties.filter(ne=>ne.key===l.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=$.filter(ne=>J.test(ne.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return G(C,l.Repository)}function te(C){return{uri:`${C.fallbackAssetUri}/${l.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${l.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function se(C){const $=G(C,l.Icon);if($)return $;const J=I.DefaultIconPath;return{uri:J,fallbackUri:J}}function G(C,$){return C.files.filter(Q=>Q.assetType===$)[0]?{uri:`${C.assetUri}/${$}`,fallbackUri:`${C.fallbackAssetUri}/${$}`}:null}function ee(C,$){const J=C.properties?C.properties.filter(ne=>ne.key===$):[],Q=J.length>0&&J[0].value;return Q?Q.split(",").map(ne=>(0,S.adoptToGalleryExtensionId)(ne)):[]}function T(C){const $=C.properties?C.properties.filter(J=>J.key===f.Engine):[];return $.length>0&&$[0].value||""}function V(C){const $=C.properties?C.properties.filter(Q=>Q.key===f.LocalizedLanguages):[],J=$.length>0&&$[0].value||"";return J?J.split(","):[]}function N(C){return C.indexOf("preview")!==-1}function B(C){return C.targetPlatform?(0,I.toTargetPlatform)(C.targetPlatform):"undefined"}function U(C){const $=(0,w.distinct)(C.versions.map(B)),J=!!C.tags?.includes(I.WEB_EXTENSION_TAG),Q=$.indexOf("web");return J?Q===-1&&$.push("web"):Q!==-1&&$.splice(Q,1),$}function _(C,$){const J=(0,I.getFallbackTargetPlarforms)($);for(let Q=0;Q<C.length;Q++){const ne=C[Q];if(ne.version===C[Q-1]?.version){let le=Q;const oe=B(ne);if(oe===$)for(;le>0&&C[le-1].version===ne.version;)le--;else if(J.includes(oe))for(;le>0&&C[le-1].version===ne.version&&B(C[le-1])!==$;)le--;le!==Q&&(C.splice(Q,1),C.splice(le,0,ne))}}return C}e.sortExtensionVersions=_;function X(C,$,J,Q,ne){const le=U(C);let oe=C.versions[0];return oe=C.versions.find(re=>re.version===oe.version&&(0,I.isTargetPlatformCompatible)(B(re),le,ne))||oe,W(C,oe,le,$,J,Q)}function W(C,$,J,Q,ne,le){const oe={manifest:G($,l.Manifest),readme:G($,l.Details),changelog:G($,l.Changelog),license:G($,l.License),repository:H($),download:te($),icon:se($),coreTranslations:F($)};return{identifier:{id:(0,S.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:$.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,description:C.shortDescription||"",installCount:A(C.statistics,"install"),rating:A(C.statistics,"averagerating"),ratingCount:A(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:J,assets:oe,properties:{dependencies:ee($,f.Dependency),extensionPack:ee($,f.ExtensionPack),engine:T($),localizedLanguages:V($),targetPlatform:B($)},preview:N(C.flags),telemetryData:{index:(ne.pageNumber-1)*ne.pageSize+Q,querySource:le}}}let z=class{constructor($,J,Q,ne,le,oe,re,ce){this.requestService=J,this.logService=Q,this.environmentService=ne,this.telemetryService=le,this.fileService=oe,this.productService=re,this.configurationService=ce;const ge=re.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,$)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,J){const Q=[];let ne=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,$.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...$.map(({id:oe})=>oe.toLowerCase()));$.every(oe=>!oe.version)&&(ne=ne.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ne,n,L.CancellationToken.None);for(let oe=0;oe<le.length;oe++){const re=le[oe];if(!re.versions.length)continue;const ce=(0,S.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ge=$.find(de=>(0,S.areSameExtensions)(de,{id:ce}))?.version;if(ge){const de=re.versions.find(Ee=>Ee.version===ge);de&&Q.push(W(re,de,U(re),oe,ne))}else Q.push(X(re,oe,ne,void 0,n))}return Q}async getCompatibleExtension($,J){const Q=(0,I.isIExtensionIdentifier)($)?null:$;if(Q){if((0,I.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(Q,J))return Q}const{id:ne,uuid:le}=Q?Q.identifier:$;let oe=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?oe=oe.withFilter(r.ExtensionId,le):oe=oe.withFilter(r.ExtensionName,ne);const{galleryExtensions:re}=await this.queryGallery(oe,J,L.CancellationToken.None),[ce]=re;if(!ce||!ce.versions.length)return null;const ge=U(ce);if((0,I.isNotWebExtensionInWebTargetPlatform)(ge,J))return null;for(let de of ce.versions){if(!T(de)){const Ee=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:f.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(de,ge,J))return W(ce,de,ge,0,oe)}return null}async isExtensionCompatible($,J){if(!(0,I.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,J))return!1;let Q=$.properties.engine;if(!Q){const ne=await this.getManifest($,L.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Q=ne.engines.vscode}return(0,p.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible($,J,Q){if(!(0,I.isTargetPlatformCompatible)(B($),J,Q))return!1;const ne=await this.getEngine($);return(0,p.isEngineValid)(ne,this.productService.version,this.productService.date)}async query($,J){const Q=L.CancellationToken.isCancellationToken($)?{}:$,ne=L.CancellationToken.isCancellationToken($)?$:J;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=Q.text||"";const oe=(0,M.getOrDefault)(Q,Pe=>Pe.pageSize,50);let re=new R().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,oe).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(re=re.withFilter(r.Category,ve||Ie),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(re=re.withFilter(r.Tag,ve||Ie),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),re=re.withFilter(r.SearchText,le)),re=re.withSortBy(0)):Q.ids?re=re.withFilter(r.ExtensionId,...Q.ids):Q.names?re=re.withFilter(r.ExtensionName,...Q.names):re=re.withSortBy(4),typeof Q.sortBy=="number"&&(re=re.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(re=re.withSortOrder(Q.sortOrder));const{galleryExtensions:ce,total:ge}=await this.queryGallery(re,n,ne),de=ce.map((Pe,Ie)=>X(Pe,Ie,re,Q.source,n)),Ee=async(Pe,Ie)=>{if(Ie.isCancellationRequested)throw(0,D.canceled)();const ve=re.withPage(Pe+1),{galleryExtensions:ye}=await this.queryGallery(ve,n,Ie);return ye.map((ke,Fe)=>X(ke,Fe,ve,Q.source,n))};return{firstPage:de,total:ge,pageSize:re.pageSize,getPage:Ee}}async queryGallery($,J,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,a.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(a.Unpublished));const ne=await this.commonHeadersPromise,le=JSON.stringify($.raw),oe={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},re=new Date().getTime();let ce,ge,de=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:oe},Q),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:de};const Ee=await(0,v.asJson)(ce);if(Ee){const Pe=Ee.results[0],Ie=Pe.extensions;Ie.forEach(ye=>_(ye.versions,J));const ve=Pe.resultMetadata&&Pe.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return de=ve&&ve.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:de}}return{galleryExtensions:[],total:de}}catch(Ee){throw ge=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-re,success:!!ce&&(0,v.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ge?(0,D.isPromiseCanceledError)(ge)?"canceled":(0,D.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic($,J,Q,ne){if(!this.isEnabled())return;const le=P.isWeb?this.api(`/itemName/${$}.${J}/version/${Q}/statType/${ne==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${J}/${Q}/stats?statType=${ne}`),oe=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:le,headers:ce},L.CancellationToken.None)}catch(ge){}}async download($,J,Q){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const ne=(0,S.getGalleryExtensionTelemetryData)($),le=new Date().getTime(),oe=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ne,duration:de}),re=Q===1?"install":Q===2?"update":"",ce=re?{uri:`${$.assets.download.uri}${h.URI.parse($.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${$.assets.download.fallbackUri}${h.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:$.assets.download,ge=await this.getAsset(ce);await this.fileService.writeFile(J,ge.stream),oe(new Date().getTime()-le)}async getReadme($,J){if($.assets.readme){const Q=await this.getAsset($.assets.readme,{},J);return await(0,v.asText)(Q)||""}return""}async getManifest($,J){if($.assets.manifest){const Q=await this.getAsset($.assets.manifest,{},J),ne=await(0,v.asText)(Q);return ne?JSON.parse(ne):null}return null}async getManifestFromRawExtensionVersion($,J){const Q=G($,l.Manifest);if(!Q)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},le=await this.getAsset(Q,{headers:ne});return await(0,v.asJson)(le)}async getCoreTranslation($,J){const Q=$.assets.coreTranslations.filter(ne=>ne[0]===J.toUpperCase())[0];if(Q){const ne=await this.getAsset(Q[1]),le=await(0,v.asText)(ne);return le?JSON.parse(le):null}return null}async getChangelog($,J){if($.assets.changelog){const Q=await this.getAsset($.assets.changelog,{},J);return await(0,v.asText)(Q)||""}return""}async getAllCompatibleVersions($,J){let Q=new R().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");$.identifier.uuid?Q=Q.withFilter(r.ExtensionId,$.identifier.uuid):Q=Q.withFilter(r.ExtensionName,$.identifier.id);const{galleryExtensions:ne}=await this.queryGallery(Q,J,L.CancellationToken.None);if(!ne.length)return[];const le=U(ne[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,J))return[];const oe=[];for(const re of ne[0].versions)try{oe[oe.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,le,J)&&oe.push({version:re.version,date:re.lastUpdated})}catch(ce){}return oe}async getAsset($,J={},Q=L.CancellationToken.None){const ne=await this.commonHeadersPromise,le={type:"GET"},oe={...ne,...J.headers||{}};J={...J,...le,headers:oe};const re=$.uri,ce=$.fallbackUri,ge={...J,url:re};try{const de=await this.requestService.request(ge,Q);if(de.res.statusCode===200)return de;const Ee=await(0,v.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Ee}`)}catch(de){if((0,D.isPromiseCanceledError)(de))throw de;const Ee=(0,D.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Ee});const Pe={...J,url:ce};return this.requestService.request(Pe,Q)}}async getEngine($){let J=T($);if(!J){const Q=await this.getManifestFromRawExtensionVersion($,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");J=Q.engines.vscode}return J}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,v.asJson)($),Q=new Map;if(J)for(const ne of J.malicious){const le=Q.get(ne)||{id:{id:ne},malicious:!0,slow:!1};le.malicious=!0,Q.set(ne,le)}return[...Q.values()]}};z=he([ie(1,v.IRequestService),ie(2,d.ILogService),ie(3,i.IEnvironmentService),ie(4,o.ITelemetryService),ie(5,t.IFileService),ie(6,y.IProductService),ie(7,g.IConfigurationService)],z);let K=class extends z{constructor($,J,Q,ne,le,oe,re,ce){super($,J,Q,ne,le,oe,re,ce)}};K=he([ie(0,u.IStorageService),ie(1,v.IRequestService),ie(2,d.ILogService),ie(3,i.IEnvironmentService),ie(4,o.ITelemetryService),ie(5,t.IFileService),ie(6,y.IProductService),ie(7,g.IConfigurationService)],K),e.ExtensionGalleryService=K;let O=class extends z{constructor($,J,Q,ne,le,oe,re){super(void 0,$,J,Q,ne,le,oe,re)}};O=he([ie(0,v.IRequestService),ie(1,d.ILogService),ie(2,i.IEnvironmentService),ie(3,o.ITelemetryService),ie(4,t.IFileService),ie(5,y.IProductService),ie(6,g.IConfigurationService)],O),e.ExtensionGalleryServiceWithNoStorageService=O;async function q(C,$,J,Q,ne,le){const oe={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C}`},re=await(0,b.getServiceMachineId)(J,ne,le);return(0,c.supportsTelemetry)($,J)&&(0,c.getTelemetryLevel)(Q)===3&&(oe["X-Market-User-Id"]=re),oe}e.resolveMarketplaceHeaders=q}),define(Z[203],x([0,1,2,43,3,25,150,19,50,45,37,30,64]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(y,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(b),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(b=>{const u=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(y,v){this._experimentProperties[y]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let v=y.sessionID,b=y["common.instanceId"],u=y["common.machineId"],o=y["common.firstSessionDate"],c=y["common.msftInternal"];return{sessionId:v,instanceId:b,machineId:u,firstSessionDate:o,msftInternal:c}}dispose(){this._disposables.dispose()}_log(y,v,b,u){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(o=>{b=(0,L.mixin)(b,o),b=(0,L.mixin)(b,this._experimentProperties),b=(0,L.cloneAndChange)(b,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(y,b))},o=>{console.error(o)})}publicLog(y,v,b){return this._log(y,3,v,b)}publicLog2(y,v,b){return this.publicLog(y,v,b)}publicLogError(y,v){return this.sendErrorTelemetry?this._log(y,2,v,!0):Promise.resolve(void 0)}publicLogError2(y,v){return this.publicLogError(y,v)}_anonymizeFilePaths(y){let v=y;const b=[];for(let n of this._cleanupPatterns)for(;;){const a=n.exec(y);if(!a)break;b.push([a.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const n=o.exec(y);if(!n)break;!u.test(n[0])&&b.every(([a,s])=>n.index<a||n.index>=s)&&(v+=y.substring(c,n.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<y.length&&(v+=y.substr(c)),v}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const v=y.toLowerCase(),b=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":b.test(v)?"<REDACTED: email>":y}_cleanupInfo(y,v){let b=y;v&&(b=this._anonymizeFilePaths(b));for(let u of this._cleanupPatterns)b=b.replace(u,"");return b=this._removePropertiesWithPossibleUserInfo(b),b}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([ie(1,E.IConfigurationService)],p),e.TelemetryService=p;function t(){const d=(0,P.localize)(0,null,g.default.nameLong),y=g.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,P.localize)(3,null),b=(0,P.localize)(4,null),u=(0,P.localize)(5,null),o=(0,P.localize)(6,null),c=(0,P.localize)(7,null),n=`
|       | ${b} | ${u} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${d} ${y} ${v}

&nbsp;

${c}
${n}

&nbsp;

${a}
`}i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,P.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,P.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[204],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Z[205],x([0,1,109,4,2,5,37,204]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var h;(function(y){function v(b){return b&&typeof b=="object"&&typeof b.id=="string"}y.isThemeColor=v})(h=e.ThemeColor||(e.ThemeColor={}));function g(y){return{id:y}}e.themeColorFromId=g;var i;(function(y){function v(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||h.isThemeColor(a.color))}y.isThemeIcon=v;const b=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function u(a){const s=b.exec(a);if(!s)return;let[,r]=s;return{id:r}}y.fromString=u;function o(a,s){let r=a.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),s&&(r=`${r}~${s}`),{id:r}}y.modify=o;function c(a,s){return a.id===s.id&&a.color?.id===s.color?.id}y.isEqual=c;function n(a,s){return{id:a.id,color:s?g(s):void 0}}y.asThemeIcon=n,y.asClassNameArray=w.CSSIcon.asClassNameArray,y.asClassName=w.CSSIcon.asClassName,y.asCSSSelector=w.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function I(y){switch(y){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(v);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new S;P.Registry.add(e.Extensions.ThemingContribution,p);function t(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=t;class d extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,b){let u=this.theme.getColor(v);return u&&b&&(u=b(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(Z[65],x([0,1,13,3,5,38]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",E="#1E1E1E",h="#000000",g="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let S=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(i,null);if(!t){let d;(L.isWindows||L.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(g,"vs-dark").split(" ")[0],t=d==="hc-black"?h:d==="vs"?P:E}return L.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:g,data:d.baseTheme},{key:i,data:d.colorInfo.background},{key:I,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const y of w.BrowserWindow.getAllWindows())if(y.id===t){y.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};S=he([ie(0,M.IStateMainService)],S),e.ThemeMainService=S}),define(Z[41],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,P)=>({type:"idle",updateType:M,error:P}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[206],x([0,1,3,151,50,37]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[207],x([0,1,4,41]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(E){this.service=E}listen(E,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,g){switch(h){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=D;class M{constructor(E){this.channel=E,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[99],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[208],x([0,1,7]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(E){this.handler=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,g){switch(h){case"handleURL":return this.handler.handleURL(w.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class D{constructor(E){this.channel=E}handleURL(E,h){return this.channel.call("handleURL",[E.toJSON(),h])}}e.URLHandlerChannelClient=D;class M{constructor(E){this.next=E}async routeCall(E,h,g,i){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(g){const I=w.URI.revive(g);if(I&&I.query){const S=/\bwindowId=(\d+)/.exec(I.query);if(S){const p=S[1],t=new RegExp(`window:${p}`),d=E.connections.find(y=>t.test(y.ctx));if(d)return d}}}return this.next.routeCall(E,h,g,i)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=M}),define(Z[209],x([0,1,9,2,7,21]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(g,i){const I=[...this.handlers.values()];return(0,w.first)(I.map(S=>()=>S.handleURL(g,i)),void 0,!1).then(S=>S||!1)}registerHandler(g){return this.handlers.add(g),(0,L.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=P;let E=class extends P{constructor(g){super();this.productService=g}create(g){let{authority:i,path:I,query:S,fragment:p}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),D.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:S,fragment:p})}};E=he([ie(0,M.IProductService)],E),e.NativeURLService=E}),define(Z[210],x([0,1,13,9,4,2,3,7]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(i){try{return E.URI.parse(i)}catch(I){return null}}class g{constructor(I,S,p,t,d){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=I,P.isWindows){const b=t.isBuilt?[]:[`"${t.appRoot}"`];b.push("--open-url","--"),w.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,b)}const y=D.Event.map(D.Event.fromNodeEventEmitter(w.app,"open-url",(b,u)=>({event:b,url:u})),({event:b,url:u})=>(b.preventDefault(),u));this.disposables.add(y(b=>{const u=h(b);!u||this.urlService.open(u,{originalUrl:b})})),p.getWindows().filter(b=>b.isReady).length>0?this.flush():D.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||I.push(S);I.length!==0&&(this.uris=I,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(Z[211],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[212],x([0,1,13,2,10,7]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(D.Schemas.vscodeWebview,h)}handleWebviewRequest(h,g){try{const i=M.URI.parse(h.url),I=P.validWebviewFilePaths.get(i.path);if(typeof I=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${I}`,p=D.FileAccess.asFileUri(S,j);return g(decodeURIComponent(p.fsPath))}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[66],x([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(g){return!!g.workspaceUri}e.isWorkspaceToOpen=L;function D(g){return!!g.folderUri}e.isFolderToOpen=D;function M(g){return!!g.fileUri}e.isFileToOpen=M;function P(g){const i=E(g),I=g.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||w.isMacintosh&&w.isNative?"classic":I}e.getMenuBarVisibility=P;function E(g){if(w.isWeb)return"custom";const i=g.getValue("window");if(i){if(w.isMacintosh&&i.nativeTabs===!0||w.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=i.titleBarStyle;if(p==="native"||p==="custom")return p}return w.isLinux?"native":"custom"}e.getTitleBarStyle=E;function h(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=h}),define(Z[36],x([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(g){g[g.INITIAL=1]="INITIAL",g[g.LOAD=2]="LOAD",g[g.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var D;(function(g){g[g.CLOSE=1]="CLOSE",g[g.QUIT=2]="QUIT",g[g.RELOAD=3]="RELOAD",g[g.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const P=function(g=1){return{width:1024,height:768,mode:g}};e.defaultWindowState=P;var E;(function(g){g[g.Maximized=0]="Maximized",g[g.Normal=1]="Normal",g[g.Minimized=2]="Minimized",g[g.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var h;(function(g){g[g.UNRESPONSIVE=1]="UNRESPONSIVE",g[g.CRASHED=2]="CRASHED",g[g.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(Z[213],x([0,1,13,4,2,212,36]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends D.Disposable{constructor(g){super();this.windowsMainService=g,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,i){let I;if(typeof g.windowId=="number"){const{windowId:S}=g,p=this.windowsMainService.getWindowById(S);if(!p?.win)throw new Error(`Invalid windowId: ${S}`);I=p.win.webContents}else{const{webContentsId:S}=g;if(I=w.webContents.fromId(S),!I)throw new Error(`Invalid webContentsId: ${S}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(i)}async findInFrame(g,i,I,S){const p=this.getFrameByName(g,i),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(I,{findNext:S.findNext,forward:S.forward});const d=(y,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),p.removeListener("found-in-frame",d))};p.on("found-in-frame",d)}}async stopFindInFrame(g,i,I){const p=this.getFrameByName(g,i);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,i){const I=this.windowsMainService.getWindowById(g.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${g}`);const S=I.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===i);if(!S)throw new Error(`Unknown frame: ${i}`);return S}};E=he([ie(0,P.IWindowsMainService)],E),e.WebviewMainService=E}),define(Z[214],x([0,1,9,4,2]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:h,getActiveWindowId:g}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(E,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>g()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[215],x([0,1,40,15,7,5]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var P;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function E(S){const p=S;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=E;function h(S){const p=S;return!!(p&&typeof p=="object"&&D.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(p,t,d,y,v){this._id=p,this._transient=d,this._configuration=y,this._ignorePathCasing=v,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class i{constructor(p,t){this.raw=t,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(S){return new i({uri:S,index:0,name:(0,L.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=I}),define(Z[27],x([0,1,33,39,79,34,10,8,3,15,7,154,5,63,215]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(T){return(typeof T=="string"?(0,E.extname)(T):(0,g.extname)(T))===d}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function v(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function b(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=b;function u(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=u;function o(T){const V=T;return typeof V?.id=="string"&&i.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=c;function n(T){const V=T;return typeof V?.id=="string"&&i.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=n;function a(T){const V=T;if(V?.uri)return{id:V.id,uri:i.URI.revive(V.uri)};const N=T;if(N?.configPath)return{id:N.id,configPath:i.URI.revive(N.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=a;function s(T,V){return g.extUriBiasedIgnorePathCase.isEqualOrParent(T,V.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(T){return l(T)||f(T)}e.isStoredWorkspaceFolder=r;function l(T){const V=T;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=l;function f(T){const V=T;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=f;function m(T,V,N,B,U=!h.isWindows,_){if(T.scheme!==B.scheme)return{name:N,uri:T.toString(!0)};let X=V?void 0:_.relativePath(B,T);if(X!==void 0)X.length===0?X=".":h.isWindows&&T.scheme===P.Schemas.file&&!U&&(X=X.replace(/\//g,"\\"));else if(T.scheme===P.Schemas.file)X=T.fsPath,h.isWindows&&(X=(0,M.normalizeDriveLetter)(X),U&&(X=(0,w.toSlashes)(X)));else{if(!_.isEqualAuthority(T.authority,B.authority))return{name:N,uri:T.toString(!0)};X=T.path}return{name:N,path:X}}e.getStoredWorkspaceFolder=m;function k(T,V,N){let B=[],U=new Set;const _=N.dirname(V);for(let X of T){let W;if(l(X))X.path&&(W=N.resolvePath(_,X.path));else if(f(X))try{W=i.URI.parse(X.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(z){console.warn(z)}if(W){let z=N.getComparisonKey(W);if(!U.has(z)){U.add(z);const K=X.name||N.basenameOrAuthority(W);B.push(new t.WorkspaceFolder({uri:W,name:K,index:B.length},X))}}}return B}e.toWorkspaceFolders=k;function R(T,V,N,B,U){let _=A(V,T);const X=U.dirname(V),W=U.dirname(B),z=[],K=F(_.folders);for(const $ of _.folders){const J=l($)?U.resolvePath(X,$.path):i.URI.parse($.uri);let Q;N?Q=!1:Q=!l($)||(0,E.isAbsolute)($.path),z.push(m(J,Q,$.name,W,K,U))}const O={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},q=D.setProperty(T,["folders"],z,O);let C=D.applyEdits(T,q);return _.remoteAuthority===(0,p.getRemoteAuthority)(B)&&(C=D.applyEdits(C,D.removeProperty(C,["remoteAuthority"],O))),C}e.rewriteWorkspaceFileForNewLocation=R;function A(T,V){let N=L.parse(V);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(B=>r(B));else throw new Error(`${T} looks like an invalid workspace file.`);return N}function F(T){return h.isWindows?T.some(V=>l(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function H(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function te(T){return typeof T.folderUri=="string"}function se(T){return typeof T.fileUri=="string"}function G(T,V){const N={workspaces:[],files:[]};if(T){const B=function(_,X){for(let W=0;W<_.length;W++)try{X(_[W],W)}catch(z){V.warn(`Error restoring recent entry ${JSON.stringify(_[W])}: ${z.toString()}. Skip entry.`)}},U=T;if(Array.isArray(U.entries))B(U.entries,_=>{const X=_.label,W=_.remoteAuthority;H(_)?N.workspaces.push({label:X,remoteAuthority:W,workspace:{id:_.workspace.id,configPath:i.URI.parse(_.workspace.configPath)}}):te(_)?N.workspaces.push({label:X,remoteAuthority:W,folderUri:i.URI.parse(_.folderUri)}):se(_)&&N.files.push({label:X,remoteAuthority:W,fileUri:i.URI.parse(_.fileUri)})});else{const _=T;Array.isArray(_.workspaces3)&&B(_.workspaces3,(X,W)=>{const z=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[W]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?N.workspaces.push({label:z,workspace:{id:X.id,configPath:i.URI.parse(X.configURIPath)}}):typeof X=="string"&&N.workspaces.push({label:z,folderUri:i.URI.parse(X)})}),Array.isArray(_.files2)&&B(_.files2,(X,W)=>{const z=Array.isArray(_.fileLabels)&&_.fileLabels[W]||void 0;typeof X=="string"&&N.files.push({label:z,fileUri:i.URI.parse(X)})})}}return N}e.restoreRecentlyOpened=G;function ee(T){const V={entries:[]};for(const N of T.workspaces)b(N)?V.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):V.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of T.files)V.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return V}e.toStoreData=ee}),define(Z[52],x([0,1,5,27]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService");function D(M){const P=M;return P&&(0,L.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=D}),define(Z[53],x([0,1,13,9,82,34,2,69,8,3,14,20,134,5,6,38,27]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let v=class mt{constructor(u,o){this.stateMainService=u,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,o){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},o)}pickFolder(u,o){return this.doPick({...u,pickFolders:!0,title:(0,S.localize)(1,null)},o)}pickFile(u,o){return this.doPick({...u,pickFiles:!0,title:(0,S.localize)(2,null)},o)}pickWorkspace(u,o){const c=(0,S.localize)(3,null),n=(0,M.mnemonicButtonLabel)((0,S.localize)(4,null)),a=y.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:c,filters:a,buttonLabel:n},o)}async doPick(u,o){const c={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};c.defaultPath=u.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(c.properties=void 0,u.pickFiles&&u.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&c.properties.push("treatPackageAsDirectory");const n=o||w.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(c,(0,i.withNullAsUndefined)(n));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,h.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(u){if(u){let o=this.windowDialogQueues.get(u.id);return o||(o=new L.Queue,this.windowDialogQueues.set(u.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(u,o){return this.getWindowDialogQueue(o).queue(async()=>o?w.dialog.showMessageBox(o,u):w.dialog.showMessageBox(u))}async showSaveDialog(u,o){const c=this.acquireFileDialogLock(u,o);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await w.dialog.showSaveDialog(o,u):n=await w.dialog.showSaveDialog(u),n.filePath=this.normalizePath(n.filePath),n})}finally{(0,P.dispose)(c)}}normalizePath(u){return u&&g.isMacintosh&&(u=(0,E.normalizeNFC)(u)),u}normalizePaths(u){return u.map(o=>this.normalizePath(o))}async showOpenDialog(u,o){u.defaultPath&&(await I.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const c=this.acquireFileDialogLock(u,o);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await w.dialog.showOpenDialog(o,u):n=await w.dialog.showOpenDialog(u),n.filePaths=this.normalizePaths(n.filePaths),n})}finally{(0,P.dispose)(c)}}acquireFileDialogLock(u,o){if(!o)return P.Disposable.None;let c=this.windowFileDialogLocks.get(o.id);c||(c=new Set,this.windowFileDialogLocks.set(o.id,c));const n=(0,D.hash)(u);if(!c.has(n))return c.add(n),(0,P.toDisposable)(()=>{c?.delete(n),c?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=he([ie(0,d.IStateMainService),ie(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[216],x([0,1,4,2,27]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(E,h){super();this.logService=E,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,h)=>(E?E.push(h):E=[h],E),M.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const h=new Map,g=new Set;return E.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?h.set(i.key,I):g.add(i.key)}),{changed:Array.from(h.entries()),deleted:Array.from(g.values())}}listen(E,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(E,h,g){const i=(0,D.reviveIdentifier)(g.workspace),I=await this.withStorageInitialized(i);switch(h){case"getItems":return Array.from(I.items.entries());case"updateItems":{const S=g;if(S.insert)for(const[p,t]of S.insert)I.set(p,t);S.delete&&S.delete.forEach(p=>I.delete(p));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(E){const h=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await h.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${g}`)}return h}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[217],x([0,1,4,2,8,28,20,87,124,6,98,30,27]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new w.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new w.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(v);const b=v.getBoolean(i.IS_NEW_KEY);b===void 0?v.set(i.IS_NEW_KEY,!0):b&&v.set(i.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,b){return this.storage.get(v,b)}set(v,b){return this.storage.set(v,b)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends p{constructor(v,b,u){super(b);this.options=v,this.environmentService=u}async doCreate(){let v;return this.options.useInMemoryStorage?v=h.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new h.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(I.instanceStorageKey,void 0)===void 0&&v.set(I.instanceStorageKey,(0,M.generateUuid)()),v.get(I.firstSessionDateStorageKey,void 0)===void 0&&v.set(I.firstSessionDateStorageKey,new Date().toUTCString());const o=v.get(I.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();v.set(I.lastSessionDateStorageKey,typeof o=="undefined"?null:o),v.set(I.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends p{constructor(v,b,u,o){super(u);this.workspace=v,this.options=b,this.environmentService=o}async doCreate(){const{storageFilePath:v,wasCreated:b}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new h.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:b?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:h.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),b=(0,D.join)(v,d.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(v)?{storageFilePath:b,wasCreated:!1}:(await P.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:b,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let b;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?b={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(b={workspace:this.workspace.configPath.toString()}),b)try{const u=(0,D.join)(v,d.WORKSPACE_META_NAME);await P.Promises.exists(u)||await P.Promises.writeFile(u,JSON.stringify(b,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json"}),define(Z[100],x([0,1,42,2,48,5,22,6,217]),function(j,e,w,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let g=class extends L.Disposable{constructor(I,S,p){super();this.logService=I,this.environmentService=S,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,S]of this.mapWorkspaceToStorage)I.join(S.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new h.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let S=this.mapWorkspaceToStorage.get(I.id);return S||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),S=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,S),(0,w.once)(S.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),S}};g=he([ie(0,E.ILogService),ie(1,D.IEnvironmentService),ie(2,P.ILifecycleMainService)],g),e.StorageMainService=g}),define(Z[101],x([0,1,15,7,27]),function(j,e,w,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(h,g,i){for(const S of h){const p=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(p)){const t=i(p);if(t){if(t.folders.some(d=>w.extUriBiasedIgnorePathCase.isEqualOrParent(g,d.uri)))return S}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(g,p.configPath))return S}}const I=h.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(g,S.openedWorkspace.uri));if(I.length)return I.sort((S,p)=>-(S.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function P(h,g){for(const i of h)if((0,D.isWorkspaceIdentifier)(i.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,g)||(0,D.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,g))return i}e.findWindowOnWorkspaceOrFolder=P;function E(h,g){const i=I=>g.some(S=>w.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(I)));for(const I of h)if(I.config?.extensionDevelopmentPath?.some(S=>i(S)))return I}e.findWindowOnExtensionDevelopmentPath=E}),define(Z[218],x([0,1,13,2,3,15,7,19,22,6,38,36,27]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class wt extends L.Disposable{constructor(u,o,c,n,a){super();this.windowsMainService=u,this.stateMainService=o,this.lifecycleMainService=c,this.logService=n,this.configurationService=a,this._state=t(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),n&&(u.lastActiveWindow=this.toWindowState(n))}const o=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);o&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const c=y(u);this.stateMainService.setItem(wt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{const n=(0,S.isWorkspaceIdentifier)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,a=(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(n||a)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(u){return{workspace:(0,S.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const o=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let n;return o.hasDefaultState?n=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),n&&D.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(n=!1)),o.mode===3&&!n&&(o.mode=1),o}doGetNewWindowState(u){const o=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=u.workspace;if((0,S.isWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===l.id).map(k=>k.uiState);if(m.length)return m[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(k=>k.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(k.folderUri,l.uri)).map(k=>k.uiState);if(m.length)return m[0]}else if(u.backupPath){const m=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(m.length)return m[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let c;const n=w.screen.getAllDisplays();if(n.length===1)c=n[0];else{if(D.isMacintosh){const l=w.screen.getCursorScreenPoint();c=w.screen.getDisplayNearestPoint(l)}!c&&o&&(c=w.screen.getDisplayMatching(o.getBounds())),c||(c=w.screen.getPrimaryDisplay()||n[0])}let a=(0,I.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")a.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")a.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,r=a.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};p.windowsStateStorageKey="windowsState",p=he([ie(0,I.IWindowsMainService),ie(1,i.IStateMainService),ie(2,h.ILifecycleMainService),ie(3,g.ILogService),ie(4,E.IConfigurationService)],p),e.WindowsStateHandler=p;function t(b){const u={openedWindows:[]},o=b||{openedWindows:[]};return o.lastActiveWindow&&(u.lastActiveWindow=d(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(u.openedWindows=o.openedWindows.map(c=>d(c))),u}e.restoreWindowsState=t;function d(b){const u={uiState:b.uiState};return b.backupPath&&(u.backupPath=b.backupPath),b.remoteAuthority&&(u.remoteAuthority=b.remoteAuthority),b.folder&&(u.folderUri=P.URI.parse(b.folder)),b.workspaceIdentifier&&(u.workspace={id:b.workspaceIdentifier.id,configPath:P.URI.parse(b.workspaceIdentifier.configURIPath)}),u}function y(b){return{lastActiveWindow:b.lastActiveWindow&&v(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&v(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=y;function v(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(Z[102],x([0,1,61,29,10,3,15]),function(j,e,w,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(g){function i(){let I=g.scheme===D.Schemas.file?(0,P.originalFSPath)(g):g.toString();return M.isLinux||(I=I.toLowerCase()),(0,w.createHash)("md5").update(I).digest("hex")}return{id:i(),configPath:g}}e.getWorkspaceIdentifier=E;function h(g,i){function I(){if(g.scheme!==D.Schemas.file)return(0,w.createHash)("md5").update(g.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(g.fsPath)}catch(t){return}let p;return M.isLinux?p=i.ino:M.isMacintosh?p=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?p=Math.floor(i.birthtimeMs):p=i.birthtime.getTime()),(0,w.createHash)("md5").update(g.fsPath).update(p?String(p):"").digest("hex")}const S=I();if(typeof S=="string")return{id:S,uri:g}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[58],x([0,1,61,62,26,17,16,4,2,8,3,28,35,85,219]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(m){this.socket=m,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const k=R=>m(M.VSBuffer.wrap(R));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(m){const k=R=>{m({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((m,k)=>{if(this.socket.bufferSize===0){m();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),m()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=d;var y;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(v||(v={}));class b extends h.Disposable{constructor(m,k,R,A){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=A,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(M.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,k){let R=2;m.byteLength<126?R+=0:m.byteLength<2**16?R+=2:R+=8;const A=M.VSBuffer.alloc(R);if(k?A.writeUInt8(194,0):A.writeUInt8(130,0),m.byteLength<126)A.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){A.writeUInt8(126,1);let F=1;A.writeUInt8(m.byteLength>>>8&255,++F),A.writeUInt8(m.byteLength>>>0&255,++F)}else{A.writeUInt8(127,1);let F=1;A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(m.byteLength>>>24&255,++F),A.writeUInt8(m.byteLength>>>16&255,++F),A.writeUInt8(m.byteLength>>>8&255,++F),A.writeUInt8(m.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=A.byteLength+m.byteLength,this.socket.write(M.VSBuffer.concat([A,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),A=(R&128)>>>7,F=(R&64)>>>6,H=k.readUInt8(1),te=(H&128)>>>7,se=H&127;this._state.state=2,this._state.readLen=2+(te?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),A=(R&128)>>>7;let F=R&127,H=1;F===126?F=k.readUInt8(++H)*2**8+k.readUInt8(++H):F===127&&(F=k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H));let te=0;A&&(te=k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H)),this._state.state=3,this._state.readLen=F,this._state.mask=te}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);u(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function u(f,m){if(m===0)return;let k=f.byteLength>>>2;for(let se=0;se<k;se++){const G=f.readUInt32BE(se*4);f.writeUInt32BE(G^m,se*4)}let R=k*4,A=f.byteLength-R;const F=m>>>24&255,H=m>>>16&255,te=m>>>8&255;A>=1&&f.writeUInt8(f.readUInt8(R)^F,R),A>=2&&f.writeUInt8(f.readUInt8(R+1)^H,R+1),A>=3&&f.writeUInt8(f.readUInt8(R+2)^te,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const f=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):m=(0,g.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),a(m),m}e.createRandomIPCHandle=c;function n(f,m,k){const R=(0,w.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${m}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${m}.sock`):A=(0,g.join)(f,`${k}-${m}.sock`),a(A),A}e.createStaticIPCHandle=n;function a(f){const m=o[i.platform];typeof m=="number"&&f.length>=m&&console.warn(`WARNING: IPC handle "${f}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends S.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const k=E.Event.fromNodeEventEmitter(m,"connection");return E.Event.map(k,R=>({protocol:new p.Protocol(new d(R)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(f){return new Promise((m,k)=>{const R=(0,L.createServer)();R.on("error",k),R.listen(f,()=>{R.removeListener("error",k),m(new s(R))})})}e.serve=r;function l(f,m){return new Promise((k,R)=>{const A=(0,L.createConnection)(f,()=>{A.removeListener("error",R),k(p.Client.fromSocket(new d(A),m))});A.once("error",R)})}e.connect=l}),define(Z[220],x([0,1,58]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(h){this.driver=h}listen(h,g){throw new Error("No event found")}call(h,g,i){switch(g){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${g}`)}}e.DriverChannel=L;class D{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,g){return this.channel.call("dispatchKeybinding",[h,g])}click(h,g,i,I){return this.channel.call("click",[h,g,i,I])}doubleClick(h,g){return this.channel.call("doubleClick",[h,g])}setValue(h,g,i){return this.channel.call("setValue",[h,g,i])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,g){return this.channel.call("isActiveElement",[h,g])}getElements(h,g,i){return this.channel.call("getElements",[h,g,i])}getElementXY(h,g,i,I){return this.channel.call("getElementXY",[h,g,i,I])}typeInEditor(h,g,i){return this.channel.call("typeInEditor",[h,g,i])}getTerminalBuffer(h,g){return this.channel.call("getTerminalBuffer",[h,g])}writeInTerminal(h,g,i){return this.channel.call("writeInTerminal",[h,g,i])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=D;class M{constructor(h){this.registry=h}listen(h,g){throw new Error(`Event not found: ${g}`)}call(h,g,i){switch(g){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${g}`)}}e.WindowDriverRegistryChannel=M;async function P(E){const h=await(0,w.connect)(E,"driverClient"),g=h.getChannel("driver"),i=new D(g);return{client:h,driver:i}}e.connect=P}),define(Z[221],x([0,1,9,4,106,59,2,3,35,58,158,220,175,22,36]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function d(b){return b<21}let y=class{constructor(u,o,c,n){this.windowServer=u,this.options=o,this.windowsMainService=c,this.lifecycleMainService=n,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const o=this.windowsMainService.getWindowById(u);if(!o?.win)throw new Error("Invalid window");return(await o.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const o=this.windowsMainService.getWindowById(u);if(!o)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(o)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(u,o){await this.whenUnfrozen(u);const c=D.KeybindingParser.parseUserBinding(o);for(let n of c)await this._dispatchKeybinding(u,n)}async _dispatchKeybinding(u,o){if(o instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const c=this.windowsMainService.getWindowById(u);if(!c?.win)throw new Error("Invalid window");const n=c.win.webContents,a=new M.SimpleKeybinding(!1,!1,!1,!1,o.keyCode),r=new S.USLayoutResolvedKeybinding(a.toChord(),E.OS).getElectronAccelerator(),l=[];o.ctrlKey&&l.push("ctrl"),o.metaKey&&l.push("meta"),o.shiftKey&&l.push("shift"),o.altKey&&l.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:r,modifiers:l}),d(o.keyCode)||n.sendInputEvent({type:"char",keyCode:r,modifiers:l}),n.sendInputEvent({type:"keyUp",keyCode:r,modifiers:l}),await(0,w.timeout)(100)}async click(u,o,c,n){await(await this.getWindowDriver(u)).click(o,c,n)}async doubleClick(u,o){await(await this.getWindowDriver(u)).doubleClick(o)}async setValue(u,o,c){await(await this.getWindowDriver(u)).setValue(o,c)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,o){return await(await this.getWindowDriver(u)).isActiveElement(o)}async getElements(u,o,c){return await(await this.getWindowDriver(u)).getElements(o,c)}async getElementXY(u,o,c,n){return await(await this.getWindowDriver(u)).getElementXY(o,c,n)}async typeInEditor(u,o,c){await(await this.getWindowDriver(u)).typeInEditor(o,c)}async getTerminalBuffer(u,o){return await(await this.getWindowDriver(u)).getTerminalBuffer(o)}async writeInTerminal(u,o,c){await(await this.getWindowDriver(u)).writeInTerminal(o,c)}async getLocaleInfo(u){return await(await this.getWindowDriver(u)).getLocaleInfo()}async getLocalizedStrings(u){return await(await this.getWindowDriver(u)).getLocalizedStrings()}async getWindowDriver(u){await this.whenUnfrozen(u);const o=`window:${u}`,c=new h.StaticRouter(a=>a===o),n=this.windowServer.getChannel("windowDriver",c);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await L.Event.toPromise(this.onDidReloadingChange.event)}};y=he([ie(2,t.IWindowsMainService),ie(3,p.ILifecycleMainService)],y),e.Driver=y;async function v(b,u,o,c){const n=o.driverVerbose,a=c.createInstance(y,b,{verbose:n}),s=new I.WindowDriverRegistryChannel(a);b.registerChannel("windowDriverRegistry",s);const r=await(0,g.serve)(u),l=new I.DriverChannel(a);return r.registerChannel("driver",l),(0,P.combinedDisposable)(r,b)}e.serve=v}),define(Z[24],x([0,1,47,8,58,48,162,5]),function(j,e,w,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(M.IEnvironmentService);class h extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([w.memoize],h.prototype,"cachedLanguagesPath",null),he([w.memoize],h.prototype,"backupHome",null),he([w.memoize],h.prototype,"backupWorkspacesPath",null),he([w.memoize],h.prototype,"mainIPCHandle",null),he([w.memoize],h.prototype,"mainLockfile",null),he([w.memoize],h.prototype,"sandbox",null),he([w.memoize],h.prototype,"driverVerbose",null),he([w.memoize],h.prototype,"disableUpdates",null),he([w.memoize],h.prototype,"disableKeytar",null),he([w.memoize],h.prototype,"codeCachePath",null),he([w.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[222],x([0,1,61,29,33,10,8,3,15,7,20,52,19,24,18,6,27]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,a)=>(0,D.isEqual)(n,a,!E.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(n){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let o=[];try{Array.isArray(u.rootURIWorkspaces)&&(o=u.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:g.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch(n){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(n=>g.URI.parse(n)))}catch(n){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,o){this.workspaces.some(n=>u.workspace.id===n.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(u,o){if(L.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),L.existsSync(o))try{L.renameSync(o,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const o=u.id,c=this.workspaces.findIndex(n=>n.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(o=>this.backupUriComparer.isEqual(u,o))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(u,o){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(u){return(0,P.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const o=new Set,c=[];for(let n of u){const a=n.workspace;if(!(0,y.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const s=this.getBackupPath(a.id);await this.doHasBackups(s)?a.configPath.scheme!==M.Schemas.file||await i.Promises.exists(a.configPath.fsPath)?c.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const o=[],c=new Set;for(let n of u){const a=this.backupUriComparer.getComparisonKey(n);if(!c.has(a)){c.add(a);const s=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(s)?n.scheme!==M.Schemas.file||await i.Promises.exists(n.fsPath)?o.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const o=[],c=new Set;for(let n of u){const a=n.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const s=this.getBackupPath(a);await this.doHasBackups(s)?o.push(n):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(u){try{await i.Promises.exists(u)&&await i.Promises.rm(u,i.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await i.Promises.rename(u,c)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{L.renameSync(u,c)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const u=[];for(const o of this.workspaces)await this.hasBackups(o)&&u.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&u.push(o);return u}hasBackups(u){let o;return g.URI.isUri(u)?o=this.getBackupPath(this.getFolderHash(u)):(0,I.isWorkspaceBackupInfo)(u)?o=this.getBackupPath(u.workspace.id):o=u.backupFolder,this.doHasBackups(o)}async doHasBackups(u){try{const o=await i.Promises.readdir(u);for(const c of o)try{if((await i.Promises.readdir((0,P.join)(u,c))).length>0)return!0}catch(n){}}catch(o){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let o;return u.scheme===M.Schemas.file?o=E.isLinux?u.fsPath:u.fsPath.toLowerCase():o=u.toString().toLowerCase(),(0,w.createHash)("md5").update(o).digest("hex")}};v=he([ie(0,p.IEnvironmentMainService),ie(1,S.IConfigurationService),ie(2,d.ILogService)],v),e.BackupMainService=v}),define(Z[223],x([0,1,62,58]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,P,E){const h=i=>E(i,void 0),g=w.createConnection({host:D,port:M},()=>{g.removeListener("error",h);const i=Buffer.alloc(16);for(let t=0;t<16;t++)i[t]=Math.round(Math.random()*256);const I=i.toString("base64");let S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];g.write(S.join(`\r
`)+`\r
\r
`);const p=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",p),E(void 0,new L.NodeSocket(g)))};g.on("data",p)});g.once("error",h)}}}),define(Z[224],x([0,1,62,116,223,9,2,19,6,21,191,97,77]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(v,b,u,o,c){return new t(v,b,u,o,c).waitForReady()}class t extends P.Disposable{constructor(b,u,o,c,n){super();this.defaultTunnelHost=u,this.suggestedLocalPort=n,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=b,this._server=w.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let b=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(b,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(b=0,this._server.listen(b,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(b){b.pause();const u=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,i.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),c=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&b.write(n.buffer),b.on("end",()=>{this._socketsDispose.delete(b.localAddress),c.end()}),b.on("close",()=>c.end()),b.on("error",()=>{this._socketsDispose.delete(b.localAddress),c.destroy()}),c.on("end",()=>b.end()),c.on("close",()=>b.end()),c.on("error",()=>{b.destroy()}),b.pipe(c),c.pipe(b),this._socketsDispose.set(b.localAddress,()=>{b.end(),c.end()})}}let d=class extends I.AbstractTunnelService{constructor(b,u,o,c,n){super(u);this.socketFactory=b,this.signService=o,this.productService=c,this.configurationService=n}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(b,u,o,c,n,a,s){const r=this.getTunnelFromMap(u,o);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,o,c,n,a,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${o} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:b,signService:this.signService,logService:this.logService,ipcLogger:null},f=p(l,this.defaultTunnelHost,u,o,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,o,f),f}}};d=he([ie(1,h.ILogService),ie(2,S.ISignService),ie(3,g.IProductService),ie(4,E.IConfigurationService)],d),e.BaseTunnelService=d;let y=class extends d{constructor(b,u,o,c){super(D.nodeSocketFactory,b,u,o,c)}};y=he([ie(0,h.ILogService),ie(1,S.ISignService),ie(2,g.IProductService),ie(3,E.IConfigurationService)],y),e.TunnelService=y}),define(Z[225],x([0,1,195,9,17,16,2,14,19,48,91,6,194,219]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(y,v,b){super();this.environmentService=v,this.logService=b,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,v){this.logService.trace("RequestService#request",y.url);const{proxyUrl:b,strictSSL:u}=this;let o;try{o=await(0,i.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.logService.error("RequestService#request resolving shell environment failed",a)}const c={...process.env,...o},n=y.agent?y.agent:await(0,S.getProxyAgent)(y.url||"",c,{proxyUrl:b,strictSSL:u});return y.agent=n,y.strictSSL=u,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization}),this._request(y,v)}async getNodeRequest(y){return((0,w.parse)(y.url).protocol==="https:"?await new Promise((u,o)=>{j(["https"],u,o)}):await new Promise((u,o)=>{j(["http"],u,o)})).request}_request(y,v){return L.Promises.withAsyncBody(async(b,u)=>{let o;const c=(0,w.parse)(y.url),n=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),a={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,E.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(a.auth=y.user+":"+y.password),o=n(a,s=>{const r=(0,E.isNumber)(y.followRedirects)?y.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...y,url:s.headers.location,followRedirects:r-1},v).then(b,u);else{let l=s;s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,p.createGunzip)())),b({res:s,stream:(0,D.streamToBufferReadableStream)(l)})}}),o.on("error",u),y.timeout&&o.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&o.write(y.data),o.end(),v.onCancellationRequested(()=>{o.abort(),u((0,M.canceled)())})})}async resolveProxy(y){}};t=he([ie(0,h.IConfigurationService),ie(1,g.INativeEnvironmentService),ie(2,I.ILogService)],t),e.RequestService=t}),define(Z[226],x([0,1,13,225]),function(j,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return w.net.request}class M extends L.RequestService{request(E,h){return super.request({...E||{},getRawRequest:D},h)}}e.RequestMainService=M}),define(Z[227],x([0,1,13,9,4,2,10,14,86,24,22,6,45,57,65]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends M.Disposable{constructor(v,b,u,o,c,n,a){super();this.machineId=v,this.userEnv=b,this.environmentMainService=u,this.lifecycleMainService=o,this.logService=c,this.themeMainService=n,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(v,b)=>this.onWindowConnection(v,b)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(v,b)=>this.onWorkerConnection(v,b)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(v,b){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(v.sender.isDestroyed())return u.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",b,[u])}onWorkerConnection(v,b){this.logService.trace("SharedProcess: onWorkerConnection",b);const u=new M.DisposableStore,o=n=>{this.logService.trace(`SharedProcess: disposing worker (reason: '${n}')`,b),u.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",b)},c=w.BrowserWindow.fromId(b.reply.windowId);if(!c||c.isDestroyed()||c.webContents.isDestroyed()||!b.reply.channel){o("unavailable");return}u.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,n=>n.window.win===c)(()=>o("load"))),u.add(D.Event.fromNodeEventEmitter(c,"closed")(()=>o("closed"))),c.webContents.postMessage(b.reply.channel,b.reply.nonce,v.ports)}onWillShutdown(){const v=this.window;!v||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(b){}this.window=void 0},0))}send(v,...b){const u=this.window;if(!u||u.isDestroyed()||u.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${v}' for shared process window that is destroyed`);return}u.webContents.send(v,...b)}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:S.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,b)=>this._onDidError.fire({type:2,details:b})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,b,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:b}})))}async connect(){await this.whenIpcReady;const v=(0,E.assertIsDefined)(this.window);return(0,h.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};d=he([ie(2,g.IEnvironmentMainService),ie(3,i.ILifecycleMainService),ie(4,I.ILogService),ie(5,t.IThemeMainService),ie(6,p.IProtocolMainService)],d),e.SharedProcess=d}),define(Z[228],x([0,1,9,17,8,14,7,24,18,6]),function(j,e,w,L,D,M,P,E,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,t,d){this.storagePath=p,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const d=this.storage[p];return(0,M.isUndefinedOrNull)(d)?t:d}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:d,data:y}of p)this.storage[d]!==y&&((0,M.isUndefinedOrNull)(y)?(0,M.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=y,t=!0));t&&this.save()}removeItem(p){(0,M.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class St{constructor(p,t,d){this.fileStorage=new i(P.URI.file((0,D.join)(p.userDataPath,St.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([ie(0,E.IEnvironmentMainService),ie(1,g.ILogService),ie(2,h.IFileService)],I),e.StateMainService=I}),define(Z[78],x([0,1,9,23,4,19,24,22,6,21,51,41]),function(j,e,w,L,D,M,P,E,h,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(t,d,y){return`${y.updateUrl}/api/update/${t}/${d}/${y.commit}`}e.createUpdateURL=S;let p=class{constructor(d,y,v,b,u,o){this.lifecycleMainService=d,this.configurationService=y,this.environmentMainService=v,this.requestService=b,this.logService=u,this.productService=o,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),y=this.getProductQuality(d);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,w.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([ie(0,E.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,P.IEnvironmentMainService),ie(3,i.IRequestService),ie(4,h.ILogService),ie(5,g.IProductService)],p),e.AbstractUpdateService=p}),define(Z[229],x([0,1,13,47,4,2,19,24,22,6,21,51,30,41,78]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,b,u,o,c,n,a){super(v,b,o,c,n,a);this.telemetryService=u,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,b)=>b)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,b,u)=>({url:b,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,b,u,o)=>({releaseNotes:b,version:u,productVersion:u,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(p.State.Idle(1,u))}buildUpdateFeedUrl(v){let b;this.productService.darwinUniversalAssetId?b=this.productService.darwinUniversalAssetId:b=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(b,v,this.productService);try{w.autoUpdater.setFeedURL({url:u})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return u}doCheckForUpdates(v){this.setState(p.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(p.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],d.prototype,"onRawError",null),he([L.memoize],d.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],d.prototype,"onRawUpdateAvailable",null),he([L.memoize],d.prototype,"onRawUpdateDownloaded",null),d=he([ie(0,h.ILifecycleMainService),ie(1,P.IConfigurationService),ie(2,S.ITelemetryService),ie(3,E.IEnvironmentMainService),ie(4,I.IRequestService),ie(5,g.ILogService),ie(6,i.IProductService)],d),e.DarwinUpdateService=d}),define(Z[230],x([0,1,44,29,9,4,8,24,22,6,30,41]),function(j,e,w,L,D,M,P,E,h,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(d,y,v){if(this.lifecycleMainService=d,this.logService=v,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,D.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=he([ie(0,h.ILifecycleMainService),ie(1,E.IEnvironmentMainService),ie(2,g.ILogService)],S);let p=class extends S{constructor(d,y,v,b,u,o){super(v,b,u);this.snap=d,this.snapRevision=y,this.telemetryService=o;const c=(0,L.watch)(P.dirname(this.snap)),n=M.Event.fromNodeEventEmitter(c,"change",(l,f)=>f),a=M.Event.filter(n,l=>l==="current"),r=M.Event.debounce(a,(l,f)=>f,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,b)=>(0,L.realpath)(`${P.dirname(this.snap)}/current`,(u,o)=>u?b(u):v(o))),y=P.basename(d);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([ie(2,h.ILifecycleMainService),ie(3,E.IEnvironmentMainService),ie(4,g.ILogService),ie(5,i.ITelemetryService)],p),e.SnapUpdateService=p}),define(Z[46],x([0,1,13,29,4,39,34,2,10,8,3,15,14,20,156,52,53,24,5,6,21,101,27,102]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(l,f,m,k,R){super();this.environmentMainService=l,this.logService=f,this.backupMainService=m,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,f=>(0,L.readFileSync)(f,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,f=>p.Promises.readFile(f,"utf8"))}doResolveLocalWorkspace(l,f){if(!!this.isWorkspacePath(l)&&l.scheme===h.Schemas.file)try{const m=f(l.fsPath);return m instanceof Promise?m.then(k=>this.doResolveWorkspace(l,k),k=>{}):this.doResolveWorkspace(l,m)}catch{return}}isWorkspacePath(l){return(0,n.isUntitledWorkspace)(l,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,f){try{const m=this.doParseStoredWorkspace(l,f),k=(0,a.getWorkspaceIdentifier)(l);return{id:k.id,configPath:k.configPath,folders:(0,n.toWorkspaceFolders)(m.folders,k.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:m.remoteAuthority,transient:m.transient}}catch(m){this.logService.warn(m.toString())}}doParseStoredWorkspace(l,f){const m=(0,M.parse)(f);if(m&&Array.isArray(m.folders))m.folders=m.folders.filter(k=>(0,n.isStoredWorkspaceFolder)(k));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return m}async createUntitledWorkspace(l,f){const{workspace:m,storedWorkspace:k}=this.newUntitledWorkspace(l,f),R=m.configPath.fsPath;return await p.Promises.mkdir((0,g.dirname)(R),{recursive:!0}),await p.Promises.writeFile(R,JSON.stringify(k,null,"	")),m}createUntitledWorkspaceSync(l,f){const{workspace:m,storedWorkspace:k}=this.newUntitledWorkspace(l,f),R=m.configPath.fsPath;return(0,L.mkdirSync)((0,g.dirname)(R),{recursive:!0}),(0,p.writeFileSync)(R,JSON.stringify(k,null,"	")),m}newUntitledWorkspace(l=[],f){const m=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,I.joinPath)(this.untitledWorkspacesHome,m),R=(0,I.joinPath)(k,n.UNTITLED_WORKSPACE_NAME),A=[];for(const F of l)A.push((0,n.getStoredWorkspaceFolder)(F.uri,!0,F.name,k,!i.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:f}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,n.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const f=(0,I.originalFSPath)(l.configPath);try{(0,p.rimrafSync)((0,g.dirname)(f));const m=(0,g.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(m)&&(0,p.writeFileSync)((0,g.join)(m,"obsolete"),"")}catch(m){this.logService.warn(`Unable to delete untitled workspace ${f} (${m}).`)}}getUntitledWorkspacesSync(){const l=[];try{const f=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(m=>(0,I.joinPath)(this.untitledWorkspacesHome,m,n.UNTITLED_WORKSPACE_NAME));for(const m of f){const k=(0,a.getWorkspaceIdentifier)(m),R=this.resolveLocalWorkspaceSync(m);R?l.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(f){f.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${f}).`)}return l}async enterWorkspace(l,f,m){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,f,m))return;const R=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(m));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,f,m){if(!m)return!0;if((0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,m))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(f,m)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,I.basename)(m)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,S.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,f){if(!l.config)return;l.focus();let m;return l.config.extensionDevelopmentPath||(m=this.backupMainService.registerWorkspaceBackupSync({workspace:f,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=f,l.config.backupPath=m,{workspace:f,backupPath:m}}};s=he([ie(0,v.IEnvironmentMainService),ie(1,u.ILogService),ie(2,d.IBackupMainService),ie(3,y.IDialogMainService),ie(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[103],x([0,1,13,31,23,3,14,7,20,19,56,5,6,99,36,27,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let v=class{constructor(u,o,c,n,a){this.logService=u,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=n,this.configurationService=a}async start(u,o){this.logService.trace("Received data from other instance: ",u,o),M.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(u);if(c.length){let n=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(n=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),n.then(()=>{for(const{uri:a,url:s}of c)this.urlService.open(a,{originalUrl:s})})}else return this.startOpenWindow(u,o)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,L.coalesce)(u._urls.map(o=>{try{return{uri:E.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(u,o){const c=(0,i.isLaunchedFromCli)(o)?0:4;let n=[];const a=u.wait&&u.waitMarkerFilePath?E.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0,r={context:c,cli:u,userEnv:o,waitMarkerFileURI:a,remoteAuthority:s};if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,r);else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let l=!1;if(u["new-window"]||u["unity-launch"])l=!0;else if(u["reuse-window"])l=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":l=!0;break;case"off":l=!1;break;default:l=!M.isMacintosh}if(l)n=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const f=this.windowsMainService.getLastActiveWindow();f?(this.windowsMainService.openExistingWindow(f,r),n=[f]):n=this.windowsMainService.open({...r,forceEmpty:!0})}}else n=this.windowsMainService.open({...r,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],gotoLineMode:u.goto});if(a&&n.length===1&&n[0])return Promise.race([n[0].whenClosedOrLoaded,(0,h.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return w.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?u.push(this.codeWindowToInfo(c)):u.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(n=>new Promise(a=>{const s=n.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${n.id}`,l={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(n):void 0};n.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:r,args:l}),w.ipcMain.once(r,(f,m)=>{m||a({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),a(m)}),setTimeout(()=>{a({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else a(void 0)})))).filter(n=>!!n)}getFolderURIs(u){const o=[],c=u.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,d.isWorkspaceIdentifier)(c)){const n=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);n&&n.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(u){const o=this.getFolderURIs(u),c=(0,P.assertIsDefined)(u.win);return this.browserWindowToInfo(c,o,u.remoteAuthority)}browserWindowToInfo(u,o=[],c){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:o,remoteAuthority:c}}};v=he([ie(0,S.ILogService),ie(1,t.IWindowsMainService),ie(2,p.IURLService),ie(3,y.IWorkspacesManagementMainService),ie(4,g.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[54],x([0,1,44,13,26,115,47,4,34,2,10,8,3,7,83,70,20,148,53,24,5,22,6,21,30,65,36,27,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a,s,r,l,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let k=class ut extends g.Disposable{constructor(A,F,H,te,se,G,ee,T,V,N){super();this.sharedProcess=A,this.windowsMainService=F,this.dialogMainService=H,this.lifecycleMainService=te,this.environmentMainService=se,this.telemetryService=G,this.logService=ee,this.productService=T,this.themeMainService=V,this.workspacesManagementMainService=N,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,U,_)=>_),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),E.Event.fromNodeEventEmitter(L.screen,"display-added"),E.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(A,F,H){return Array.isArray(F)?this.doOpenWindow(A,F,H):this.doOpenEmptyWindow(A,F)}async doOpenWindow(A,F,H=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0})}async doOpenEmptyWindow(A,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},F)}async toggleFullScreen(A){const F=this.windowById(A);F&&F.toggleFullScreen()}async handleTitleDoubleClick(A){const F=this.windowById(A);F&&F.handleTitleDoubleClick()}async isMaximized(A){const F=this.windowById(A);return F?.win?F.win.isMaximized():!1}async maximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.maximize()}async unmaximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.unmaximize()}async minimizeWindow(A){const F=this.windowById(A);F?.win&&F.win.minimize()}async focusWindow(A,F){F&&typeof F.windowId=="number"&&(A=F.windowId);const H=this.windowById(A);H&&H.focus({force:F?.force??!1})}async setMinimumSize(A,F,H){const te=this.windowById(A);if(te?.win){const[se,G]=te.win.getSize(),[ee,T]=te.win.getMinimumSize(),[V,N]=[F??ee,H??T],[B,U]=[Math.max(se,V),Math.max(G,N)];(ee!==V||T!==N)&&te.win.setMinimumSize(V,N),(se!==B||G!==U)&&te.win.setSize(B,U)}}async saveWindowSplash(A,F){this.themeMainService.saveWindowSplash(A,F)}async installShellCommand(A){const{source:F,target:H}=await this.getShellCommandLink();try{const{symbolicLink:te}=await y.SymlinkSupport.stat(F);if(te&&!te.dangling){const se=await(0,t.realpath)(F);if(H===se)return}await y.Promises.unlink(F)}catch(te){if(te.code!=="ENOENT")throw te}try{await y.Promises.symlink(H,F)}catch(te){if(te.code!=="EACCES"&&te.code!=="ENOENT")throw te;const{response:se}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${F}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(G)}catch(G){throw new Error((0,v.localize)(3,null,F))}}}async uninstallShellCommand(A){const{source:F}=await this.getShellCommandLink();try{await y.Promises.unlink(F)}catch(H){switch(H.code){case"EACCES":const{response:te}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const se=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(se)}catch(se){throw new Error((0,v.localize)(7,null,F))}break;case"ENOENT":break;default:throw H}}}async getShellCommandLink(){const A=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(A))throw new Error((0,v.localize)(8,null,A));return{source:F,target:A}}async showMessageBox(A,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(A))}async showSaveDialog(A,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(A))}async showOpenDialog(A,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(A))}toBrowserWindow(A){const F=this.windowById(A);if(F?.win)return F.win}async pickFileFolderAndOpen(A,F){const H=await this.dialogMainService.pickFileFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(H.map(async te=>await y.SymlinkSupport.existsDirectory(te)?{folderUri:p.URI.file(te)}:{fileUri:p.URI.file(te)})),F,A))}async pickFolderAndOpen(A,F){const H=await this.dialogMainService.pickFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({folderUri:p.URI.file(te)})),F,A))}async pickFileAndOpen(A,F){const H=await this.dialogMainService.pickFile(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({fileUri:p.URI.file(te)})),F,A))}async pickWorkspaceAndOpen(A,F){const H=await this.dialogMainService.pickWorkspace(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({workspaceUri:p.URI.file(te)})),F,A))}doOpenPicked(A,F,H){this.windowsMainService.open({context:3,contextWindowId:H,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(A,F,H){const te=A?A.length:0;this.telemetryService.publicLog(F,{...H,outcome:te?"success":"canceled",numberOfPaths:te})}async showItemInFolder(A,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(A,F){const H=this.windowById(A);H&&H.setRepresentedFilename(F)}async setDocumentEdited(A,F){const H=this.windowById(A);H&&H.setDocumentEdited(F)}async openExternal(A,F){return S.isLinuxSnap?this.safeSnapOpenExternal(F):L.shell.openExternal(F),!0}safeSnapOpenExternal(A){const F=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=H}moveItemToTrash(A,F){return L.shell.trashItem(F)}async isAdmin(){let A;return S.isWindows?A=(await new Promise((F,H)=>{j(["native-is-elevated"],F,H)}))():A=process.getuid()===0,A}async writeElevated(A,F,H,te){const se=await new Promise((G,ee)=>{j(["sudo-prompt"],G,ee)});return new Promise((G,ee)=>{const T=[`"${this.cliPath}"`];te?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${F.fsPath}"`,`"${H.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(T.join(" "),V,(N,B,U)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),N?ee(N):G(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,F,H){process.kill(F,H)}async readClipboardText(A,F){return L.clipboard.readText(F)}async writeClipboardText(A,F,H){return L.clipboard.writeText(F,H)}async readClipboardFindText(A){return L.clipboard.readFindText()}async writeClipboardFindText(A,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(A,F,H,te){return L.clipboard.writeBuffer(F,Buffer.from(H),te)}async readClipboardBuffer(A,F){return L.clipboard.readBuffer(F)}async hasClipboard(A,F,H){return L.clipboard.has(F,H)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,F){const H=this.windowById(A);H&&H.updateTouchBar(F)}async notifyReady(A){const F=this.windowById(A);F&&F.setReady()}async relaunch(A,F){return this.lifecycleMainService.relaunch(F)}async reload(A,F){const H=this.windowById(A);if(H){if((0,f.isWorkspaceIdentifier)(H.openedWorkspace)){const te=H.openedWorkspace.configPath;if(te.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(te))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(H,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,F){const H=this.windowById(F);if(H?.win)return H.win.close()}async quit(A){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(A,F){await this.lifecycleMainService.kill(F)}async resolveProxy(A,F){const te=this.windowById(A)?.win?.webContents?.session;if(te)return te.resolveProxy(F)}async openDevTools(A,F){const H=this.windowById(A);H?.win&&H.win.webContents.openDevTools(F)}async toggleDevTools(A){const F=this.windowById(A);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(A,F){const H=this.windowById(A);H?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&H.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,F,H,te){if(!S.isWindows)return;const se=await new Promise((G,ee)=>{j(["vscode-windows-registry"],G,ee)});try{return se.GetStringRegKey(F,H,te)}catch{return}}async getPassword(A,F,H){const te=await this.withKeytar(),se=await te.getPassword(F,H);if(se)try{let{content:G,hasNextChunk:ee}=JSON.parse(se);if(!G||!ee)return se;let T=1;for(;ee;){const V=await te.getPassword(F,`${H}-${T}`),N=JSON.parse(V);G+=N.content,ee=N.hasNextChunk,T++}return G}catch{return se}return se}async setPassword(A,F,H,te){const se=await this.withKeytar(),G=3,ee=async(T,V,N)=>{let B=0,U;for(;B<G;)try{await se.setPassword(T,V,N);return}catch(_){U=_,this.logService.warn("Error attempting to set a password: ",_),B++,await new Promise(X=>setTimeout(X,200))}throw U};if(S.isWindows&&te.length>ut.MAX_PASSWORD_LENGTH){let T=0,V=0,N=!0;for(;N;){const B=te.substring(T,T+ut.PASSWORD_CHUNK_SIZE);T+=ut.PASSWORD_CHUNK_SIZE,N=te.length-T>0;const U={content:B,hasNextChunk:N};await ee(F,V?`${H}-${V}`:H,JSON.stringify(U)),V++}}else await ee(F,H,te);this._onDidChangePassword.fire({service:F,account:H})}async deletePassword(A,F,H){const se=await(await this.withKeytar()).deletePassword(F,H);return se&&this._onDidChangePassword.fire({service:F,account:H}),se}async findPassword(A,F){return(await this.withKeytar()).findPassword(F)}async findCredentials(A,F){return(await this.withKeytar()).findCredentials(F)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,F)=>{j(["keytar"],A,F)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([P.memoize],k.prototype,"cliPath",null),k=he([ie(1,l.IWindowsMainService),ie(2,b.IDialogMainService),ie(3,c.ILifecycleMainService),ie(4,u.IEnvironmentMainService),ie(5,s.ITelemetryService),ie(6,n.ILogService),ie(7,a.IProductService),ie(8,r.IThemeMainService),ie(9,m.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Z[231],x([0,1,13,23,4,82,2,28,89,6,54,21,36]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends P.Disposable{constructor(y,v,b,u,o){super();this.logService=y,this.windowsMainService=v,this.nativeHostMainService=b,this.encryptionMainService=u,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=D.Event.fromNodeEventEmitter(w.app,"login",(v,b,u,o,c)=>({event:v,webContents:b,req:u,authInfo:o,callback:c}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:v,req:b,callback:u}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&b.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(o?.username,o?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(y);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const v=String((0,M.hash)({scheme:y.scheme,host:y.host,port:y.port}));let b,u;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(a){const s=JSON.parse(await this.encryptionMainService.decrypt(a));b=s.username,u=s.password}}catch(a){this.logService.error(a)}if(this.state!==p.StoredCredentialsUsed&&typeof b=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:b,password:u};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const c={authInfo:y,username:this.sessionCredentials?.username??b,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=p.LoginDialogShown;const n=await new Promise(a=>{const s=async(r,l,f)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),f){const m={username:f.username,password:f.password};try{if(f.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(m));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(k){this.logService.error(k)}a({username:m.username,password:m.password})}else a(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=n,n}};t=he([ie(0,g.ILogService),ie(1,S.IWindowsMainService),ie(2,i.INativeHostMainService),ie(3,h.IEncryptionMainService),ie(4,I.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[232],x([0,1,13,26,34,2,10,3,84,146,74,53,24,5,103,6,54,45,21,57,66]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let c=class bt{constructor(a,s,r,l,f,m,k,R,A){this.userEnv=a,this.environmentMainService=s,this.launchMainService=r,this.logService=l,this.diagnosticsService=f,this.dialogMainService=m,this.nativeHostMainService=k,this.protocolMainService=R,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),w.ipcMain.on("vscode:listProcesses",async a=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,g.localize)(0,null),rootProcess:await(0,h.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,i.isRemoteDiagnosticError)(f)?s.push({name:f.hostName,rootProcess:f}):f.processes&&s.push({name:f.hostName,rootProcess:f.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(a,"vscode:listProcessesResponse",s)}),w.ipcMain.on("vscode:issueReporterClipboard",async a=>{const s={title:this.productService.nameLong,message:(0,g.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",r.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const s=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",s)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,g.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(a,s)=>{const{id:r,from:l,args:f}=s;let m;switch(l){case"issueReporter":m=this.issueReporterParentWindow;break;case"processExplorer":m=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}m&&m.webContents.send("vscode:runAction",{id:r,from:l,args:f})}),w.ipcMain.on("vscode:openExternal",(a,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),w.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async a=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",s.windows)})}safeSend(a,s,...r){a.sender.isDestroyed()||a.sender.send(s,...r)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,g.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,g.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,s,r){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:r.title,backgroundColor:r.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,s)}getWindowPosition(a,s,r){let l;const f=w.screen.getAllDisplays();if(f.length===1)l=f[0];else{if(E.isMacintosh){const R=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(R)}!l&&a&&(l=w.screen.getDisplayMatching(a.getBounds())),l||(l=w.screen.getPrimaryDisplay()||f[0])}const m={width:s,height:r},k=l.bounds;return m.x=k.x+k.width/2-m.width/2,m.y=k.y+k.height/2-m.height/2,k.width>0&&k.height>0&&(m.x<k.x&&(m.x=k.x),m.y<k.y&&(m.y=k.y),m.x>k.x+k.width&&(m.x=k.x),m.y>k.y+k.height&&(m.y=k.y),m.width>k.width&&(m.width=k.width),m.height>k.height&&(m.height=k.height)),m}async getPerformanceInfo(){try{const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,s)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=he([ie(1,S.IEnvironmentMainService),ie(2,t.ILaunchMainService),ie(3,d.ILogService),ie(4,i.IDiagnosticsService),ie(5,I.IDialogMainService),ie(6,y.INativeHostMainService),ie(7,u.IProtocolMainService),ie(8,b.IProductService)],c),e.IssueMainService=c}),define(Z[233],x([0,1,23,19,24,22,6,54,21,51,30,41,78]),function(j,e,w,L,D,M,P,E,h,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends S.AbstractUpdateService{constructor(d,y,v,b,u,o,c,n){super(d,y,b,u,o,n);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,S.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(I.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},w.CancellationToken.None).then(g.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?y.message||y:void 0;this.setState(I.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(I.State.Idle(1))}};p=he([ie(0,M.ILifecycleMainService),ie(1,L.IConfigurationService),ie(2,i.ITelemetryService),ie(3,D.IEnvironmentMainService),ie(4,g.IRequestService),ie(5,P.ILogService),ie(6,E.INativeHostMainService),ie(7,h.IProductService)],p),e.LinuxUpdateService=p}),define(Z[234],x([0,1,44,29,26,9,23,47,8,7,112,20,19,24,18,22,6,54,21,51,30,41,78]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(f,m=1e3){for(;!f();)await(0,M.timeout)(m)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),s}let l=class extends n.AbstractUpdateService{constructor(m,k,R,A,F,H,te,se,G){super(m,k,A,F,H,G);this.telemetryService=R,this.fileService=te,this.nativeHostMainService=se}get cachePath(){const m=h.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(m,{recursive:!0}).then(()=>m)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(m){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,n.createUpdateURL)(k,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(c.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},P.CancellationToken.None).then(u.asJson).then(k=>{const R=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(c.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>I.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const H=k.url,te=k.hash,se=`${A}.tmp`;return this.requestService.request({url:H},P.CancellationToken.None).then(G=>this.fileService.writeFile(g.URI.file(se),G.stream)).then(te?()=>(0,i.checksum)(se,k.hash):()=>{}).then(()=>I.Promises.rename(se,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(k)):this.setState(c.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const R=m?k.message||k:void 0;this.setState(c.State.Idle(r(),R))}))}async doDownloadUpdate(m){m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(m){const k=await this.cachePath;return h.join(k,`CodeSetup-${this.productService.quality}-${m}.exe`)}async cleanup(m=null){const k=m?H=>!new RegExp(`${this.productService.quality}-${m}\\.exe$`).test(H):()=>!0,R=await this.cachePath,F=(await I.Promises.readdir(R)).filter(k).map(async H=>{try{await I.Promises.unlink(h.join(R,H))}catch(te){}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const m=this.state.update;this.setState(c.State.Updating(m));const k=await this.cachePath;this.availableUpdate.updateFilePath=h.join(k,`CodeSetup-${this.productService.quality}-${m.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise((H,te)=>{j(["windows-mutex"],H,te)});a(()=>F.isActive(A)).then(()=>this.setState(c.State.Ready(m)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([E.memoize],l.prototype,"cachePath",null),l=he([ie(0,d.ILifecycleMainService),ie(1,S.IConfigurationService),ie(2,o.ITelemetryService),ie(3,p.IEnvironmentMainService),ie(4,u.IRequestService),ie(5,y.ILogService),ie(6,t.IFileService),ie(7,v.INativeHostMainService),ie(8,b.IProductService)],l),e.Win32UpdateService=l}),define(Z[235],x([0,1,13,9,23,4,34,2,10,8,76,3,7,152,52,19,53,24,56,202,18,22,6,21,57,100,30,205,65,66,36,27,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a,s,r,l,f,m,k,R,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(H||(H={}));let te=class extends E.Disposable{constructor(G,ee,T,V,N,B,U,_,X,W,z,K,O,q){super();this.logService=ee,this.environmentMainService=T,this.fileService=V,this.configurationService=B,this.themeMainService=U,this.workspacesManagementMainService=_,this.backupMainService=X,this.telemetryService=W,this.dialogMainService=z,this.lifecycleMainService=K,this.productService=O,this.protocolMainService=q,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[C,$]=this.restoreWindowState(G.state);this.windowState=C,this.logService.trace("window#ctor: using window state",C);const J=this.windowState.mode===0||this.windowState.mode===3,Q=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!J,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(Q?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?ne.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),I.isMacintosh&&(ne.acceptFirstMouse=!0,Q?.clickThroughInactive===!1&&(ne.acceptFirstMouse=!1));const le=I.isMacintosh&&Q?.nativeTabs===!0;le&&(ne.tabbingIdentifier=this.productService.nameShort);const oe=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(oe&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(ne.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(ne),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&oe&&this._win.setSheetOffset(22),I.isMacintosh&&$&&(!le||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(re=>typeof re=="number")){const re=this.windowState;this._win.setBounds({width:re.width,height:re.height,x:re.x,y:re.y})}J&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:C=>N.globalStorage.get(C),store:(C,$)=>N.globalStorage.set(C,$)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){I.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){I.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){I.isMacintosh&&G?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function ee(){T.dispose(),V.dispose(),G()}const T=this.onDidClose(()=>ee()),V=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(N,B,U)=>this.onWindowError(3,{reason:U,exitCode:B})),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),ee=N=>{for(let B=N;B;B=B.parent)if(B.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},T=N=>N.resourceType==="xhr"||ee(N.frame);this._win.webContents.session.webRequest.onBeforeRequest((N,B)=>{const U=S.URI.parse(N.url);return U.path.endsWith(".svg")&&!G.has(U.scheme)?B({cancel:!T(N)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((N,B)=>{const U=N.responseHeaders,_=U["content-type"]||U["Content-Type"];if(_&&Array.isArray(_)){const X=S.URI.parse(N.url);if(X.path.endsWith(".svg")&&G.has(X.scheme))return U["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:U});if(!X.path.includes(h.Schemas.vscodeRemoteResource)&&_.some(W=>W.toLowerCase().includes("image/svg")))return B({cancel:!T(N)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(N,B)=>{const U=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,U)})})}async onWindowError(G,ee){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:ee?.reason,code:ee?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const T=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;T.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):T.response===2&&this.destroyWindow()}else if(G===2){let T;ee?T=(0,p.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):T=(0,p.localize)(5,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(7,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(8,null))],message:T,detail:(0,p.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;V.response===0?this.reload():V.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||T!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=T;const V=ee||"",N=T?`${T},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${N}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:N,pacScript:""})}}addTabbedWindow(G){I.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,ee),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(h.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const T=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:ee.isReload?3:T?2:1})}updateConfiguration(G,ee){const T=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(T){const V=(0,b.isLaunchedFromCli)(T)&&!(0,b.isLaunchedFromCli)(G.userEnv),N=this.isExtensionDevelopmentHost;(V||N)&&(G.userEnv={...T,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(G["disable-extensions"]=ee.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),G.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&G&&(ee.verbose=G.verbose,ee.debugId=G.debugId,ee.extensionEnvironment=G.extensionEnvironment,ee["inspect-extensions"]=G["inspect-extensions"],ee["inspect-brk-extensions"]=G["inspect-brk-extensions"],ee["extensions-dir"]=G["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,A.isWorkspaceIdentifier)(G.workspace)){const ee=G.workspace.configPath;if(ee.scheme===h.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(G.workspace)){const ee=G.workspace.uri;if(ee.scheme===h.Schemas.file&&!await this.fileService.exists(ee))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let T;try{T=w.screen.getDisplayMatching(this.getBounds())}catch(B){}const V=(0,R.defaultWindowState)();return{mode:3,display:T?T.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let ee;if(!I.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?G.mode=0:G.mode=1,ee===1||ee===0){let T;ee===1?T=this.getBounds():T=this._win.getNormalBounds(),G.x=T.x,G.y=T.y,G.width=T.width,G.height=T.height}return G}restoreWindowState(G){(0,i.mark)("code/willRestoreCodeWindowState");let ee=!1;if(G)try{const T=w.screen.getAllDisplays();ee=T.length>1,G=this.validateWindowState(G,T)}catch(T){this.logService.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),ee]}validateWindowState(G,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const N=this.getWorkingArea(ee[0]);if(N){let B=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!N||(G.x<N.x&&(G.x=N.x),G.y<N.y&&(G.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),B(),G.width>N.width&&(G.width=N.width),G.height>N.height&&(G.height=N.height),G.x>N.x+N.width-128&&(G.x=N.x+N.width-G.width),G.y>N.y+N.height-128&&(G.y=N.y+N.height-G.height),B()}return G}if(G.display&&G.mode===3){const N=ee.find(B=>B.id===G.display);if(N&&typeof N.bounds?.x=="number"&&typeof N.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=N.bounds.x,B.y=N.bounds.y,B}}let T,V;try{T=w.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(T)}catch(N){}if(T&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,ee]=this._win.getPosition(),[T,V]=this._win.getSize();return{x:G,y:ee,width:T,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,ee=!0){I.isMacintosh||(G==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,p.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const ee=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,ee,...T){this.isReady?this.send(G,...T):this.ready().then(()=>{ee.isCancellationRequested||this.send(G,...T)})}send(G,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}this._win.webContents.send(G,...ee)}}updateTouchBar(G){!I.isMacintosh||this.touchBarGroups.forEach((ee,T)=>{const V=G[T];ee.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!I.isMacintosh){for(let G=0;G<10;G++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const ee=this.createTouchBarGroupSegments(G),T=new w.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:T.segments[V].id,from:"touchbar"})}});return T}createTouchBarGroupSegments(G=[]){return G.map(T=>{let V;T.icon&&!f.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===h.Schemas.file&&(V=w.nativeImage.createFromPath(S.URI.revive(T.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let N;return typeof T.title=="string"?N=T.title:N=T.title.value,{id:T.id,label:V?void 0:N,icon:V}})}dispose(){super.dispose(),this._win=null}};te=he([ie(1,n.ILogService),ie(2,v.IEnvironmentMainService),ie(3,o.IFileService),ie(4,r.IStorageMainService),ie(5,d.IConfigurationService),ie(6,m.IThemeMainService),ie(7,F.IWorkspacesManagementMainService),ie(8,t.IBackupMainService),ie(9,l.ITelemetryService),ie(10,y.IDialogMainService),ie(11,c.ILifecycleMainService),ie(12,a.IProductService),ie(13,s.IProtocolMainService)],te),e.CodeWindow=te}),define(Z[67],x([0,1,13,31,9,4,34,2,10,3,15,7,20,155,5,22,6,38,27,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let o=class $e extends E.Disposable{constructor(f,m,k,R){super();this.stateMainService=f,this.logService=m,this.workspacesManagementMainService=k,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!g.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const m=[],k=[];for(let R of f)if((0,b.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&a(m,R.workspace)===-1&&m.push(R);else if((0,b.isRecentFolder)(R))s(m,R.folderUri)===-1&&m.push(R);else{const A=r(k,R.fileUri)>=0,F=R.fileUri.scheme===h.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!A&&!F&&(k.push(R),g.isWindows&&R.fileUri.scheme===h.Schemas.file&&w.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(m,k),m.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(m.length=$e.MAX_TOTAL_RECENT_ENTRIES),k.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(k.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:m,files:k}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const m=F=>{const H=n(F);for(const te of f)if(i.extUriBiasedIgnorePathCase.isEqual(te,H))return!1;return!0},k=this.getRecentlyOpened(),R=k.workspaces.filter(m),A=k.files.filter(m);(R.length!==k.workspaces.length||A.length!==k.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;w.app.clearRecentDocuments();const f=this.getRecentlyOpened(),m=[];let k=0;for(let A=0;A<f.workspaces.length&&k<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const F=n(f.workspaces[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);await S.Promises.exists(H)&&(m.push(H),k++)}}const R=[];for(let A=0;A<f.files.length&&k<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const F=n(f.files[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);if($e.COMMON_FILES_FILTER.includes((0,i.basename)(F))||m.includes(H))continue;await S.Promises.exists(H)&&(R.push(H),k++)}}R.reverse().forEach(A=>w.app.addRecentDocument(A)),m.reverse().forEach(A=>w.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){const m=[],k=[],R=f?.config?.workspace;(0,b.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?m.push({workspace:R}):(0,b.isSingleFolderWorkspaceIdentifier)(R)&&m.push({folderUri:R.uri});const A=f?.config?.filesToOpenOrCreate;if(A)for(let F of A){const H=F.fileUri;H&&r(k,H)===-1&&k.push({fileUri:H})}return this.addEntriesFromStorage(m,k),{workspaces:m,files:k}}addEntriesFromStorage(f,m){let k=this.getRecentlyOpenedFromStorage();for(let R of k.workspaces){let A=(0,b.isRecentFolder)(R)?s(f,R.folderUri):a(f,R.workspace);A>=0?f[A].label=f[A].label||R.label:f.push(R)}for(let R of k.files){let A=r(m,R.fileUri);A>=0?m[A].label=m[A].label||R.label:m.push(R)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,b.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const m=(0,b.toStoreData)(f);this.stateMainService.setItem($e.recentlyOpenedStorageKey,m)}updateWindowsJumpList(){if(!g.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let m=[];for(let A of w.app.getJumpListSettings().removedItems){const F=A.args;if(F){const H=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(F);H&&m.push(I.URI.parse(H[2]))}}this.removeRecentlyOpened(m);let k=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const F=(0,b.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:H,description:te}=this.getWindowsJumpListLabel(F,A.label);let se;return I.URI.isUri(F)?se=`--folder-uri "${F.toString()}"`:(k=!0,se=`--file-uri "${F.configPath.toString()}"`),{type:"task",title:H.substr(0,255),description:te.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&f.push({type:"custom",name:k?(0,p.localize)(2,null):(0,p.localize)(3,null),items:R})}f.push({type:"recent"});try{w.app.setJumpList(f)}catch(m){this.logService.warn("updateWindowsJumpList#setJumpList",m)}}getWindowsJumpListLabel(f,m){if(m)return{title:(0,P.splitName)(m).name,description:m};if(I.URI.isUri(f))return{title:(0,i.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,p.localize)(4,null),description:""};let k=(0,i.basename)(f.configPath);return k.endsWith(b.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-b.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,k),description:c(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ie(0,v.IStateMainService),ie(1,y.ILogService),ie(2,u.IWorkspacesManagementMainService),ie(3,d.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(l){return l.scheme==="file"?(0,P.normalizeDriveLetter)(l.fsPath):l.toString()}function n(l){return(0,b.isRecentFolder)(l)?l.folderUri:(0,b.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,f){return l.findIndex(m=>(0,b.isRecentWorkspace)(m)&&m.workspace.id===f.id)}function s(l,f){return l.findIndex(m=>(0,b.isRecentFolder)(m)&&i.extUriBiasedIgnorePathCase.isEqual(m.folderUri,f))}function r(l,f){return l.findIndex(m=>i.extUriBiasedIgnorePathCase.isEqual(m.fileUri,f))}}),define(Z[236],x([0,1,13,9,23,34,3,7,147,19,24,22,6,183,54,21,38,30,41,66,36,67]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let a=class pt{constructor(l,f,m,k,R,A,F,H,te,se,G){this.updateService=l,this.configurationService=f,this.windowsMainService=m,this.environmentMainService=k,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateMainService=F,this.lifecycleMainService=H,this.logService=te,this.nativeHostMainService=se,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,F,H)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,F,H)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const m=this.productService.reportIssueUrl;m&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(m,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const A=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${A}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,f){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!P.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=w.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(P.isMacintosh?new w.Menu:null);return}const f=new w.Menu;let m;if(P.isMacintosh){const R=new w.Menu;m=new w.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),f.append(m)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new w.Menu;R.append(new w.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:R});this.setMenuById(R,"File"),f.append(A)}if(this.shouldDrawMenu("Edit")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),f.append(A)}if(this.shouldDrawMenu("Selection")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),f.append(A)}if(this.shouldDrawMenu("View")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:R});this.setMenuById(R,"View"),f.append(A)}if(this.shouldDrawMenu("Go")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),f.append(A)}if(this.shouldDrawMenu("Run")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),f.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),f.append(A)}let k;if(this.shouldDrawMenu("Window")){const R=new w.Menu;k=new w.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(k&&f.append(k),this.shouldDrawMenu("Help")){const R=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),f.append(A)}f.items&&f.items.length>0?w.Menu.setApplicationMenu(f):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const f=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),m=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const ee=new w.Menu;this.setMenuById(ee,"Preferences"),k=new w.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ee})}const R=new w.Menu,A=new w.MenuItem({label:h.localize(12,null),role:"services",submenu:R}),F=new w.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),H=new w.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new w.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new w.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[f];G.push(...m),k&&G.push(s(),k),G.push(s(),A,s(),F,H,te,s(),se),G.forEach(ee=>l.append(ee))}shouldDrawMenu(l){if(!P.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,f){f.forEach(m=>{if((0,p.isMenubarMenuItemSeparator)(m))l.append(s());else if((0,p.isMenubarMenuItemSubmenu)(m)){const k=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.label),submenu:k});this.setMenu(k,m.submenu.items),l.append(R)}else(0,p.isMenubarMenuItemRecentAction)(m)?l.append(this.createOpenRecentMenuItem(m)):(0,p.isMenubarMenuItemAction)(m)&&(m.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[m.id]?l.append(new w.MenuItem(this.likeAction(m.id,{label:this.mnemonicLabel(m.label),click:this.fallbackMenuHandlers[m.id]}))):l.append(this.createMenuItem(m.label,m.id,!1,m.checked)):l.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)):l.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)))})}setMenuById(l,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(l,this.menubarMenus[f].items)}insertCheckForUpdatesItems(l){const f=this.getUpdateMenuItems();f.length&&(f.forEach(m=>l.append(m)),l.append(s()))}createOpenRecentMenuItem(l){const f=E.URI.revive(l.uri),m=l.id,k=m==="openRecentFile"?{fileUri:f}:m==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new w.MenuItem(this.likeAction(m,{label:l.label,click:(R,A,F)=>{const H=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(l){return!!(l&&(!P.isMacintosh&&(l.ctrlKey||l.shiftKey)||P.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,f,m){const k={label:this.mnemonicLabel(l),role:m,enabled:!0};return new w.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(l){const f=new w.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),m=new w.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new w.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,m,s(),R,...A,s(),k].forEach(F=>l.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,f,m,k){const R=this.mnemonicLabel(l),A=typeof f=="function"?f:(G,ee,T)=>{const V=G?G.userSettingsLabel:null;let N=f;Array.isArray(f)&&(N=this.isOptionClick(T)?f[1]:f[0]),V&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:N})},F=typeof m=="boolean"?m:this.windowsMainService.getWindowCount()>0,H=typeof k=="boolean"?k:!1,te={label:R,click:A,enabled:F};H&&(te.type="checkbox",te.checked=H);let se;return typeof f=="string"?se=f:Array.isArray(f)&&(se=f[0]),P.isMacintosh&&(se==="editor.action.clipboardCutAction"?te.role="cut":se==="editor.action.clipboardCopyAction"?te.role="copy":se==="editor.action.clipboardPasteAction"&&(te.role="paste"),se==="undo"?te.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?te.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(se,te))}makeContextAwareClickHandler(l,f){return(m,k,R)=>{const A=w.BrowserWindow.getFocusedWindow();if(!A)return f.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return f.inDevTools(A.webContents.devToolsWebContents);l(m,k||A,R)}}runActionInRenderer(l){let f=w.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(f=k.win)}const m=f?this.windowsMainService.getWindowById(f.id):void 0;if(m){if(this.logService.trace("menubar#runActionInRenderer",l),P.isMacintosh&&!this.environmentMainService.isBuilt&&!m.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const k={id:l.commandId,from:"menu"};m.sendWhenReady("vscode:runAction",D.CancellationToken.None,k)}else{const k={userSettingsLabel:l.userSettingsLabel};m.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,f){const m=typeof l=="string"?this.keybindings[l]:void 0;if(m?.label){if(m.isNative!==!1)f.accelerator=m.label,f.userSettingsLabel=m.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${m.label}]`:f.label=`${f.label} [${m.label}]`}}else f.accelerator=void 0;return f}likeAction(l,f,m=!f.accelerator){m&&(f=this.withKeybinding(l,f));const k=f.click;return f.click=(R,A,F)=>{this.reportMenuActionTelemetry(l),k&&k(R,A,F)},f}openUrl(l,f){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:n})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([ie(0,b.IUpdateService),ie(1,g.IConfigurationService),ie(2,o.IWindowsMainService),ie(3,i.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,c.IWorkspacesHistoryMainService),ie(6,y.IStateMainService),ie(7,I.ILifecycleMainService),ie(8,S.ILogService),ie(9,t.INativeHostMainService),ie(10,d.IProductService)],a),e.Menubar=a;function s(){return new w.MenuItem({type:"separator"})}}),define(Z[237],x([0,1,5,22,6,236]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let P=class{constructor(h,g,i){this.instantiationService=h,this.lifecycleMainService=g,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(h,g){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(g,h)}};P=he([ie(0,w.IInstantiationService),ie(1,L.ILifecycleMainService),ie(2,D.ILogService)],P),e.MenubarMainService=P}),define(Z[238],x([0,1,13,29,26,31,23,4,33,42,34,2,10,8,76,3,32,15,25,14,7,153,52,19,53,24,18,5,22,6,45,21,57,63,38,66,235,101,218,27,102,67,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a,s,r,l,f,m,k,R,A,F,H,te,se,G,ee,T,V,N,B,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function _(K){return(0,V.isWorkspaceIdentifier)(K?.workspace)}function X(K){return(0,V.isSingleFolderWorkspaceIdentifier)(K?.workspace)}let W=class xe extends I.Disposable{constructor(O,q,C,$,J,Q,ne,le,oe,re,ce,ge,de,Ee,Pe){super();this.machineId=O,this.initialUserEnv=q,this.logService=C,this.stateMainService=$,this.environmentMainService=J,this.lifecycleMainService=Q,this.backupMainService=ne,this.configurationService=le,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=re,this.instantiationService=ce,this.dialogMainService=ge,this.fileService=de,this.productService=Ee,this.protocolMainService=Pe,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new T.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const q=new I.DisposableStore;if(q.add(E.Event.any(O.onDidClose,O.onDidDestroy)(()=>q.dispose())),O.config.extensionDevelopmentPath)for(const C of O.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(o.URI.file(C)));O.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(o.URI.file(O.config.extensionTestsPath)))}}))}openEmptyWindow(O,q){let C=this.environmentMainService.args;const $=q?.remoteAuthority||void 0,J=!0,Q=q?.forceReuseWindow,ne=!Q;return this.open({...O,cli:C,forceEmpty:J,forceNewWindow:ne,forceReuseWindow:Q,remoteAuthority:$})}openExistingWindow(O,q){O.focus(),this.handleWaitMarkerFile(q,[O])}open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const q=[],C=[],$=[],J=[],Q=[];let ne,le=0;const oe=this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const de of oe)X(de)?O.addMode?q.push(de):C.push(de):_(de)?$.push(de):de.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:de.remoteAuthority}),ne.filesToOpenOrCreate.push(de)):de.backupPath?Q.push({backupFolder:(0,p.basename)(de.backupPath),remoteAuthority:de.remoteAuthority}):le++;O.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),ne&&O.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(J.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),$.push(...J),Q.push(...this.backupMainService.getEmptyWindowBackupPaths())):Q.length=0;const{windows:re,filesOpenedInWindow:ce}=this.doOpen(O,$,C,Q,le,ne,q);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${C.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${le})`),re.length>1)if(ce)ce.focus();else{const de=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Ee=!0,Pe=!0;if(de){const Ie=re.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Ee=!1,Pe=!1)}if(Ee)for(let Ie=re.length-1;Ie>=0;Ie--){const ve=re[Ie];if(!(ve.openedWorkspace&&J.some(ye=>ve.openedWorkspace&&ye.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Q.some(ye=>ve.backupPath&&ye.backupFolder===(0,p.basename)(ve.backupPath)))){ve.focus(),Pe=!1;break}}Pe&&re[re.length-1].focus()}const ge=ne&&ne.filesToDiff.length>0;if(!re.some(de=>de.isExtensionDevelopmentHost)&&!ge&&!O.noRecentEntry){const de=[];for(const Ee of oe)_(Ee)&&!Ee.transient?de.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):X(Ee)?de.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&de.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(de)}return this.handleWaitMarkerFile(O,re),re}handleWaitMarkerFile(O,q){const C=O.waitMarkerFileURI;O.context===0&&C&&q.length===1&&q[0]&&(async()=>{await q[0].whenClosedOrLoaded;try{await this.fileService.del(C)}catch($){}})()}doOpen(O,q,C,$,J,Q,ne){const le=[];let oe;function re(ve,ye){le.push(ve),ye&&(oe=ve,Q=void 0)}let{openFolderInNewWindow:ce,openFilesInNewWindow:ge}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&ne.length>0){const ve=ne[0].remoteAuthority,ye=this.getLastActiveWindowForAuthority(ve);ye&&re(this.doAddFoldersToExistingWindow(ye,ne.map(ke=>ke.workspace.uri)))}const de=C.length+q.length+$.length;if(Q&&de===0){const ve=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0],ye=this.getWindows().filter(Fe=>Q&&z(Fe.remoteAuthority,Q.remoteAuthority));let ke;ve?.fileUri&&!ge&&((O.context===4||O.context===0||O.context===1)&&(ke=(0,ee.findWindowOnFile)(ye,ve.fileUri,Fe=>Fe.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Fe.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(ye))),ke?(0,V.isWorkspaceIdentifier)(ke.openedWorkspace)?q.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,V.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?C.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):re(this.doOpenFilesInExistingWindow(O,ke,Q),!0):re(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow}),!0)}const Ee=(0,M.distinct)(q,ve=>ve.workspace.id);if(Ee.length>0){const ve=(0,M.coalesce)(Ee.map(ye=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;re(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Ee.forEach(ye=>{if(ve.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ye.workspace.id))return;const ke=ye.remoteAuthority,Fe=z(Q?.remoteAuthority,ke)?Q:void 0;re(this.doOpenFolderOrWorkspace(O,ye,ce,Fe),!!Fe),ce=!0})}const Pe=(0,M.distinct)(C,ve=>v.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Pe.length>0){const ve=(0,M.coalesce)(Pe.map(ye=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;re(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Pe.forEach(ye=>{if(ve.some(Re=>(0,V.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,ye.workspace.uri)))return;const ke=ye.remoteAuthority,Fe=z(Q?.remoteAuthority,ke)?Q:void 0;re(this.doOpenFolderOrWorkspace(O,ye,ce,Fe),!!Fe),ce=!0})}const Ie=(0,M.distinct)($,ve=>ve.backupFolder);if(Ie.length>0&&Ie.forEach(ve=>{const ye=ve.remoteAuthority,ke=z(Q?.remoteAuthority,ye)?Q:void 0;re(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:ke,remoteAuthority:ye,forceNewWindow:!0,forceNewTabbedWindow:O.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!ke),ce=!0}),le.length===0||Q){Q&&!J&&J++;const ve=Q?Q.remoteAuthority:O.remoteAuthority;for(let ye=0;ye<J;ye++)re(this.doOpenEmpty(O,ce,ve,Q),!!Q),ce=!0}return{windows:(0,M.distinct)(le),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(O,q,C){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),q.focus();const $={filesToOpenOrCreate:C?.filesToOpenOrCreate,filesToDiff:C?.filesToDiff,filesToWait:C?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return q.sendWhenReady("vscode:openFiles",P.CancellationToken.None,$),q}doAddFoldersToExistingWindow(O,q){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),O.focus();const C={foldersToAdd:q};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,C),O}doOpenEmpty(O,q,C,$,J){return!q&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:C,forceNewWindow:q,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}doOpenFolderOrWorkspace(O,q,C,$,J){return!C&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:q.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:q.remoteAuthority,forceNewWindow:C,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}getPathsToOpen(O){let q,C=!1,$=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(q=this.doExtractPathsFromAPI(O),C=!0):O.forceEmpty?q=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(q=this.doExtractPathsFromCLI(O.cli),q.length===0&&q.push(Object.create(null)),C=!0):(q=this.doGetPathsFromLastSession(),q.length===0&&q.push(Object.create(null)),$=!0),!O.addMode&&C){const J=q.filter(Q=>X(Q));if(J.length>1){const Q=J[0].remoteAuthority;if(J.every(ne=>z(ne.remoteAuthority,Q))){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(J.map(le=>({uri:le.workspace.uri})));q.push({workspace:ne,remoteAuthority:Q}),q=q.filter(le=>!X(le))}}}return O.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&q.unshift(...this.doGetPathsFromLastSession().filter(J=>_(J)||X(J)||J.backupPath)),q}doExtractPathsFromAPI(O){const q=[],C={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority};for(const $ of(0,M.coalesce)(O.urisToOpen||[])){const J=this.resolveOpenable($,C);if(J)J.label=$.label,q.push(J);else{const Q=this.resourceFromOpenable($),ne={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,c.localize)(0,null))],defaultId:0,message:Q.scheme===S.Schemas.file?(0,c.localize)(1,null):(0,c.localize)(2,null),detail:Q.scheme===S.Schemas.file?(0,c.localize)(3,null,(0,i.getPathLabel)(Q.fsPath,this.environmentMainService)):(0,c.localize)(4,null,Q.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,(0,u.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return q}doExtractPathsFromCLI(O){const q=[],C={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:!1},$=O["folder-uri"];if($)for(const ne of $){const le=this.cliArgToUri(ne);if(le){const oe=this.resolveOpenable({folderUri:le},C);oe&&q.push(oe)}}const J=O["file-uri"];if(J)for(const ne of J){const le=this.cliArgToUri(ne);if(le){const oe=this.resolveOpenable((0,V.hasWorkspaceFileExtension)(ne)?{workspaceUri:le}:{fileUri:le},C);oe&&q.push(oe)}}const Q=O._;for(const ne of Q){const le=C.remoteAuthority?this.doResolvePathRemote(ne,C):this.doResolveFilePath(ne,C);le&&q.push(le)}return q}cliArgToUri(O){try{const q=o.URI.parse(O);if(!q.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return q}catch(q){this.logService.error(`Invalid URI input string: ${O}, ${q.message}`)}}doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":const q=[];O!=="one"&&q.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&q.push(this.windowsStateHandler.state.lastActiveWindow);const C=[];for(const $ of q)if($.workspace){const J=this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});_(J)&&C.push(J)}else if($.folderUri){const J=this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});X(J)&&C.push(J)}else O!=="folders"&&$.backupPath&&C.push({backupPath:$.backupPath,remoteAuthority:$.remoteAuthority});return C}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}resolveOpenable(O,q=Object.create(null)){let C=this.resourceFromOpenable(O);return C.scheme===S.Schemas.file?((0,se.isFileToOpen)(O)&&(q={...q,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(C.fsPath,q)):this.doResolveRemoteOpenable(O,q)}doResolveRemoteOpenable(O,q){let C=this.resourceFromOpenable(O);const $=(0,H.getRemoteAuthority)(C)||q.remoteAuthority;if(C=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(C)),(0,se.isFileToOpen)(O)){if(q.gotoLineMode){const{path:J,line:Q,column:ne}=(0,h.parseLineAndColumnAware)(C.path);return{fileUri:C.with({path:J}),selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0,remoteAuthority:$}}return{fileUri:C,remoteAuthority:$}}else if((0,se.isWorkspaceToOpen)(O))return{workspace:(0,N.getWorkspaceIdentifier)(C),remoteAuthority:$};return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(C),remoteAuthority:$}}resourceFromOpenable(O){return(0,se.isWorkspaceToOpen)(O)?O.workspaceUri:(0,se.isFolderToOpen)(O)?O.folderUri:O.fileUri}doResolveFilePath(O,q){let C,$;q.gotoLineMode&&({path:O,line:C,column:$}=(0,h.parseLineAndColumnAware)(O)),O=(0,h.sanitizeFilePath)((0,p.normalize)(O),(0,y.cwd)());try{const J=(0,L.statSync)(O);if(J.isFile()){if(!q.forceOpenWorkspaceAsFile){const Q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(o.URI.file(O));if(Q)return Q.transient&&q.rejectTransientWorkspaces?void 0:{workspace:{id:Q.id,configPath:Q.configPath},remoteAuthority:Q.remoteAuthority,exists:!0,transient:Q.transient}}return{fileUri:o.URI.file(O),selection:C?{startLineNumber:C,startColumn:$||1}:void 0,exists:!0}}else if(J.isDirectory())return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(o.URI.file(O),J),exists:!0}}catch(J){const Q=o.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([Q]),q.ignoreFileNotFound)return{fileUri:Q,exists:!1}}}doResolvePathRemote(O,q){const C=O.charCodeAt(0),$=q.remoteAuthority;let J,Q;q.gotoLineMode&&({path:O,line:J,column:Q}=(0,h.parseLineAndColumnAware)(O)),C!==47&&((0,h.isWindowsDriveLetter)(C)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,h.toSlashes)(O)),O=`/${O}`);const ne=o.URI.from({scheme:S.Schemas.vscodeRemote,authority:$,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,V.hasWorkspaceFileExtension)(O))return q.forceOpenWorkspaceAsFile?{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:q.remoteAuthority}:{workspace:(0,N.getWorkspaceIdentifier)(ne),remoteAuthority:$};if(q.gotoLineMode||p.posix.basename(O).indexOf(".")!==-1)return{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:$}}return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(ne),remoteAuthority:$}}shouldOpenNewWindow(O){const q=this.configurationService.getValue("window"),C=q?.openFoldersInNewWindow||"default",$=q?.openFilesInNewWindow||"off";let J=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(C==="on"||C==="off")&&(J=C==="on");let Q=!1;return O.forceNewWindow||O.forceReuseWindow?Q=!!O.forceNewWindow&&!O.forceReuseWindow:(d.isMacintosh?O.context===1&&(Q=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!O.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(Q=$==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:Q}}openExtensionDevelopmentHostWindow(O,q){const C=(0,ee.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(C)return this.lifecycleMainService.reload(C,q.cli),C.focus(),[C];let $=q.cli["folder-uri"]||[],J=q.cli["file-uri"]||[],Q=q.cli._;if(!Q.length&&!$.length&&!J.length&&!q.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=re&&(re.workspace||re.folderUri);ce&&(o.URI.isUri(ce)?ce.scheme===S.Schemas.file?Q=[ce.fsPath]:$=[ce.toString()]:ce.configPath.scheme===S.Schemas.file?Q=[(0,v.originalFSPath)(ce.configPath)]:J=[ce.configPath.toString()])}let ne=q.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=o.URI.parse(re),ge=(0,H.getRemoteAuthority)(ce);ge&&(ne?ge!==ne&&this.logService.error("more than one extension development path authority"):ne=ge)}Q=Q.filter(re=>{const ce=o.URI.file(re);return(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,H.getRemoteAuthority)(ce)===ne}),$=$.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),J=J.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),q.cli._=Q,q.cli["folder-uri"]=$,q.cli["file-uri"]=J;const le=!Q.length&&!$.length&&!J.length,oe={context:q.context,cli:q.cli,forceNewWindow:!0,forceEmpty:le,userEnv:q.userEnv,noRecentEntry:!0,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:ne};return this.open(oe)}openInBrowserWindow(O){const q=this.configurationService.getValue("window"),C={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:O.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof q?.zoomLevel=="number"?q.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:q?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let $;if(!O.forceNewWindow&&!O.forceNewTabbedWindow&&($=O.windowToUse||this.getLastActiveWindow(),$&&$.focus()),$){const J=$.config;!C.extensionDevelopmentPath&&J&&!!J.extensionDevelopmentPath&&(C.extensionDevelopmentPath=J.extensionDevelopmentPath,C.verbose=J.verbose,C["inspect-brk-extensions"]=J["inspect-brk-extensions"],C.debugId=J.debugId,C.extensionEnvironment=J.extensionEnvironment,C["inspect-extensions"]=J["inspect-extensions"],C["extensions-dir"]=J["extensions-dir"])}else{const J=this.windowsStateHandler.getNewWindowState(C);(0,t.mark)("code/willCreateCodeWindow");const Q=$=this.instantiationService.createInstance(G.CodeWindow,{state:J,extensionDevelopmentPath:C.extensionDevelopmentPath,isExtensionTestHost:!!C.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow){const le=this.getLastActiveWindow();le&&le.addTabbedWindow(Q)}xe.WINDOWS.push(Q),this._onDidOpenWindow.fire(Q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(Q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(Q)),(0,g.once)(Q.onDidClose)(()=>this.onWindowClosed(Q)),(0,g.once)(Q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(Q));const ne=(0,u.assertIsDefined)(Q.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(Q)),this.lifecycleMainService.registerWindow(Q)}return C.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,4).then(J=>{J||this.doOpenInBrowserWindow($,C,O)}):this.doOpenInBrowserWindow($,C,O),$}doOpenInBrowserWindow(O,q,C){if(!q.extensionDevelopmentPath)if((0,V.isWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:q.workspace,remoteAuthority:q.remoteAuthority});else if((0,V.isSingleFolderWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerFolderBackupSync(q.workspace.uri);else{const $=C.emptyWindowBackupInfo&&C.emptyWindowBackupInfo.backupFolder;q.backupPath=this.backupMainService.registerEmptyWindowBackupSync($,q.remoteAuthority)}O.load(q)}onWindowClosed(O){const q=xe.WINDOWS.indexOf(O);xe.WINDOWS.splice(q,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=w.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(q=>z(q.remoteAuthority,O)))}doGetLastActiveWindow(O){const q=Math.max.apply(Math,O.map(C=>C.lastFocusTime));return O.find(C=>C.lastFocusTime===q)}sendToFocused(O,...q){const C=this.getFocusedWindow()||this.getLastActiveWindow();C&&C.sendWhenReady(O,P.CancellationToken.None,...q)}sendToAll(O,q,C){for(const $ of this.getWindows())C&&C.indexOf($.id)>=0||$.sendWhenReady(O,P.CancellationToken.None,q)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(O){const q=this.getWindows().filter(C=>C.id===O);return(0,M.firstOrDefault)(q)}getWindowByWebContents(O){const q=w.BrowserWindow.fromWebContents(O);if(!!q)return this.getWindowById(q.id)}};W.WINDOWS=[],W=he([ie(2,k.ILogService),ie(3,te.IStateMainService),ie(4,r.IEnvironmentMainService),ie(5,m.ILifecycleMainService),ie(6,n.IBackupMainService),ie(7,a.IConfigurationService),ie(8,B.IWorkspacesHistoryMainService),ie(9,U.IWorkspacesManagementMainService),ie(10,f.IInstantiationService),ie(11,s.IDialogMainService),ie(12,l.IFileService),ie(13,A.IProductService),ie(14,F.IProtocolMainService)],W),e.WindowsMainService=W;function z(K,O){return K===O||K!==void 0&&O!==void 0&&(0,b.equalsIgnoreCase)(K,O)}}),define(Z[239],x([0,1,52,36,67,46]),function(j,e,w,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(h,g,i,I){this.workspacesManagementMainService=h,this.windowsMainService=g,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,g){const i=this.windowsMainService.getWindowById(h);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(h,g,i){return this.workspacesManagementMainService.createUntitledWorkspace(g,i)}deleteUntitledWorkspace(h,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(h,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}async removeRecentlyOpened(h,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([ie(0,M.IWorkspacesManagementMainService),ie(1,L.IWindowsMainService),ie(2,D.IWorkspacesHistoryMainService),ie(3,w.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[240],x([0,1,13,29,26,17,55,16,33,42,39,34,2,10,8,3,15,14,7,28,70,120,35,123,86,231,132,52,222,19,177,160,74,53,221,89,24,56,91,167,185,90,168,18,179,96,73,5,75,232,198,103,22,6,181,237,54,21,63,227,77,38,216,100,199,30,201,203,64,41,207,229,233,230,234,99,208,209,210,211,213,36,238,214,27,67,239,46]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a,s,r,l,f,m,k,R,A,F,H,te,se,G,ee,T,V,N,B,U,_,X,W,z,K,O,q,C,$,J,Q,ne,le,oe,re,ce,ge,de,Ee,Pe,Ie,ve,ye,ke,Fe,Re,Ve,et,ot,Ge,ht,tt,Y,ae,ue,me,be,Ae,Oe,Ue,Be,_e,ze,It,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends S.Disposable{constructor(fe,pe,Se,we,Me,Le,De,Te,We,je){super();this.mainProcessNodeIpcServer=fe,this.userEnv=pe,this.mainInstantiationService=Se,this.logService=we,this.environmentMainService=Me,this.lifecycleMainService=Le,this.configurationService=De,this.stateMainService=Te,this.fileService=We,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const fe=we=>we?.startsWith(`${p.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((we,Me,Le,De)=>fe(De.requestingUrl)?Le(pe.has(Me)):Le(!1)),w.session.defaultSession.setPermissionCheckHandler((we,Me,Le,De)=>fe(De.requestingUrl)?pe.has(Me):!1);const Se=w.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,E.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,E.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Se,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),w.app.on("activate",(Se,we)=>{this.logService.trace("app#activate"),we||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Se,we)=>{we.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),we.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let fe=[],pe;w.app.on("open-file",(Se,we)=>{this.logService.trace("app#open-file: ",we),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(we)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],pe=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",Se=>{const we=this.windowsMainService?.getWindowByWebContents(Se.sender);let Me,Le;return we?.config?(Me=we.config,Le={...process.env,...we.config.userEnv}):(Me=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(Me,Le)}),w.ipcMain.handle("vscode:writeNlsFile",(Se,we,Me)=>{const Le=this.validateNlsPath([we]);if(!Le||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Me))}),w.ipcMain.handle("vscode:readNlsFile",async(Se,...we)=>{const Me=this.validateNlsPath(we);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let pe;for(const Se of fe)typeof Se=="string"&&(typeof pe!="string"?pe=Se:pe=(0,t.join)(pe,Se));if(!(typeof pe!="string"||!(0,t.isAbsolute)(pe)||!(0,h.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return b.URI.file(pe)}onUnexpectedError(fe){if(fe){const pe={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;d.isWindows&&fe&&w.app.setAppUserModelId(fe);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.logService.error(We)}const pe=new a.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:we,sharedProcessReady:Me,sharedProcessClient:Le}=this.setupSharedProcess(Se),De=await this.initServices(Se,we,Me);if(this.environmentMainService.driverHandle){const We=await(0,te.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(We)}this._register(De.createInstance(r.ProxyAuthHandler)),De.invokeFunction(We=>this.initChannels(We,pe,Le));const Te=De.invokeFunction(We=>this.openFirstWindow(We,pe));De.invokeFunction(We=>this.afterWindowOpen(We,we)),this.environmentMainService.args.trace&&De.invokeFunction(We=>this.stopTracingEventually(We,Te))}async resolveMachineId(){let fe=this.stateMainService.getItem(ye.machineIdKey);return(!fe||d.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,o.getMachineId)(),this.stateMainService.setItem(ye.machineIdKey,fe)),fe}setupSharedProcess(fe){const pe=this._register(this.mainInstantiationService.createInstance(ge.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Me,"main")})(),we=(async()=>(await pe.whenReady(),Se))();return{sharedProcess:pe,sharedProcessReady:we,sharedProcessClient:Se}}async initServices(fe,pe,Se){const we=new O.ServiceCollection;switch(process.platform){case"win32":we.set(Ve.IUpdateService,new z.SyncDescriptor(tt.Win32UpdateService));break;case"linux":d.isLinuxSnap?we.set(Ve.IUpdateService,new z.SyncDescriptor(ht.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Ve.IUpdateService,new z.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":we.set(Ve.IUpdateService,new z.SyncDescriptor(ot.DarwinUpdateService));break}we.set(Oe.IWindowsMainService,new z.SyncDescriptor(Ue.WindowsMainService,[fe,this.userEnv])),we.set(H.IDialogMainService,new z.SyncDescriptor(H.DialogMainService)),we.set($.ILaunchMainService,new z.SyncDescriptor($.LaunchMainService)),we.set(F.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Se.then(Le=>Le.getChannel("diagnostics"))))),we.set(q.IIssueMainService,new z.SyncDescriptor(q.IssueMainService,[this.userEnv])),we.set(se.IEncryptionMainService,new z.SyncDescriptor(se.EncryptionMainService,[fe])),we.set(C.IKeyboardLayoutMainService,new z.SyncDescriptor(C.KeyboardLayoutMainService)),we.set(oe.INativeHostMainService,new z.SyncDescriptor(oe.NativeHostMainService,[pe])),we.set(be.IWebviewManagerService,new z.SyncDescriptor(Ae.WebviewMainService)),we.set(_e.IWorkspacesService,new z.SyncDescriptor(It.WorkspacesMainService)),we.set(vt.IWorkspacesManagementMainService,new z.SyncDescriptor(vt.WorkspacesManagementMainService)),we.set(ze.IWorkspacesHistoryMainService,new z.SyncDescriptor(ze.WorkspacesHistoryMainService)),we.set(le.IMenubarMainService,new z.SyncDescriptor(le.MenubarMainService)),we.set(V.IExtensionUrlTrustService,new z.SyncDescriptor(N.ExtensionUrlTrustService)),we.set(Ie.IStorageMainService,new z.SyncDescriptor(Ie.StorageMainService)),d.isWindows?we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(U.WindowsExternalTerminalService)):d.isMacintosh?we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(U.MacExternalTerminalService)):d.isLinux&&we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(U.LinuxExternalTerminalService));const Me=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(we.set(f.IBackupMainService,Me),we.set(Y.IURLService,new z.SyncDescriptor(ue.NativeURLService)),(0,Re.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,n.getDelayedChannel)(Se.then(Ye=>Ye.getChannel("telemetryAppender"))),De=new ke.TelemetryAppenderClient(Le),Te=(0,ve.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),We=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],je={appenders:[De],commonProperties:Te,piiPaths:We,sendErrorTelemetry:!0};we.set(ye.ITelemetryService,new z.SyncDescriptor(Fe.TelemetryService,[je]))}else we.set(ye.ITelemetryService,Re.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(we)}initChannels(fe,pe,Se){const we=n.ProxyChannel.fromService(fe.get($.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",we);const Me=this.fileService.getProvider(p.Schemas.file);(0,v.assertType)(Me instanceof W.DiskFileSystemProvider);const Le=new X.DiskFileSystemProviderChannel(Me,this.logService);pe.registerChannel("localFilesystem",Le),pe.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const De=new et.UpdateChannel(fe.get(Ve.IUpdateService));pe.registerChannel("update",De);const Te=n.ProxyChannel.fromService(fe.get(q.IIssueMainService));pe.registerChannel("issue",Te);const We=n.ProxyChannel.fromService(fe.get(se.IEncryptionMainService));pe.registerChannel("encryption",We);const je=n.ProxyChannel.fromService(fe.get(de.ISignService));pe.registerChannel("sign",je);const Ye=n.ProxyChannel.fromService(fe.get(C.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Ye),this.nativeHostMainService=fe.get(oe.INativeHostMainService);const Xe=n.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Xe),Se.then(He=>He.registerChannel("nativeHost",Xe));const it=n.ProxyChannel.fromService(fe.get(_e.IWorkspacesService));pe.registerChannel("workspaces",it);const ft=n.ProxyChannel.fromService(fe.get(le.IMenubarMainService));pe.registerChannel("menubar",ft);const Ne=n.ProxyChannel.fromService(fe.get(Y.IURLService));pe.registerChannel("url",Ne);const at=n.ProxyChannel.fromService(fe.get(V.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",at);const nt=n.ProxyChannel.fromService(fe.get(be.IWebviewManagerService));pe.registerChannel("webview",nt);const Qe=this._register(new Pe.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));pe.registerChannel("storage",Qe),Se.then(He=>He.registerChannel("storage",Qe));const lt=n.ProxyChannel.fromService(fe.get(B.IExternalTerminalMainService));pe.registerChannel("externalTerminal",lt);const rt=new ne.LogLevelChannel(fe.get(Q.ILogService));pe.registerChannel("logLevel",rt),Se.then(He=>He.registerChannel("logLevel",rt));const Je=new ne.LoggerChannel(fe.get(Q.ILoggerService));pe.registerChannel("logger",Je),Se.then(He=>He.registerChannel("logger",Je));const st=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(Oe.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",st)}openFirstWindow(fe,pe){const Se=this.windowsMainService=fe.get(Oe.IWindowsMainService),we=fe.get(Y.IURLService),Me=fe.get(oe.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:b.URI.parse(Ce),url:Ce}}catch{return}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(Ce.uri);return Ze?(Le.push(Ze),!1):!0}),Te=this,We=this.environmentMainService,je=this.productService;we.registerHandler({async handleURL(Ce,Ze){if(Ce.scheme===je.urlProtocol&&Ce.path==="workspace"&&(Ce=Ce.with({authority:"file",path:b.URI.parse(Ce.query).path,query:""})),Te.shouldBlockURI(Ce))return!0;const yt=Te.getWindowOpenableFromProtocolLink(Ce);if(yt){const[gt]=Se.open({context:5,cli:{...We.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(d.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...We.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ce.getRemoteAuthority)(Ce)});return await gt.ready(),we.open(Ce,Ze)}return!1}});const Ye=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new n.StaticRouter(Ce=>Ye.getActiveClientId().then(Ze=>Ce===Ze)),it=new ae.URLHandlerRouter(Xe),ft=pe.getChannel("urlHandler",it);we.registerHandler(new ae.URLHandlerChannelClient(ft)),this._register(new me.ElectronURLListener(De,we,Se,this.environmentMainService,this.productService));const Ne=this.environmentMainService.args,at=global.macOpenFiles,nt=(0,ee.isLaunchedFromCli)(process.env)?0:4,Qe=Ne._.length,lt=!!Ne["folder-uri"],rt=!!Ne["file-uri"],Je=Ne["skip-add-to-recently-opened"]===!0,st=Ne.wait&&Ne.waitMarkerFilePath?b.URI.file(Ne.waitMarkerFilePath):void 0,He=Ne.remote||void 0;return Le.length>0?Se.open({context:nt,cli:Ne,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Ne["new-window"]&&!Qe&&!lt&&!rt?Se.open({context:nt,cli:Ne,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Je,waitMarkerFileURI:st,initialStartup:!0,remoteAuthority:He}):at.length&&!Qe&&!lt&&!rt?Se.open({context:1,cli:Ne,urisToOpen:at.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:Je,waitMarkerFileURI:st,initialStartup:!0}):Se.open({context:nt,cli:Ne,forceNewWindow:Ne["new-window"]||!Qe&&Ne["unity-launch"],diffMode:Ne.diff,noRecentEntry:Je,waitMarkerFileURI:st,gotoLineMode:Ne.goto,initialStartup:!0,remoteAuthority:He})}shouldBlockURI(fe){return!!(fe.authority===p.Schemas.file&&d.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,l.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,l.localize)(1,null))],defaultId:0,cancelId:1,message:(0,l.localize)(2,null,(0,I.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,l.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===p.Schemas.file){const pe=b.URI.file(fe.fsPath);return(0,_e.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(fe.authority===p.Schemas.vscodeRemote){const pe=fe.path.indexOf(t.posix.sep,1);if(pe!==-1){const Se=fe.path.substring(1,pe),we=fe.path.substring(pe),Me=b.URI.from({scheme:p.Schemas.vscodeRemote,authority:Se,path:we,query:fe.query,fragment:fe.fragment});return(0,_e.hasWorkspaceFileExtension)(we)?{workspaceUri:Me}:/:[\d]+$/.test(we)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:b.URI.file(fe)};if((0,_e.hasWorkspaceFileExtension)(fe))return{workspaceUri:b.URI.file(fe)}}catch(pe){}return{fileUri:b.URI.file(fe)}}async afterWindowOpen(fe,pe){this.lifecycleMainService.phase=3;let Se=!1;(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const we=fe.get(ye.ITelemetryService);this._register(pe.onDidError(({type:De,details:Te})=>{let We;switch(De){case 1:We="SharedProcess: detected unresponsive window";break;case 2:We=`SharedProcess: crashed (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break;case 3:We=`SharedProcess: failed to load (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(We)),we.publicLog2("sharedprocesserror",{type:De,reason:Te?.reason,code:Te?.exitCode,visible:pe.isVisible(),shuttingdown:Se})}));const Me=this.productService.win32MutexName;if(d.isWindows&&Me)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Te=new De(Me);(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Te.release())}catch(De){this.logService.error(De)}w.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(De,Te)=>{Te({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Le=fe.get(Ve.IUpdateService);(Le instanceof tt.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof ot.DarwinUpdateService)&&Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Te=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Te))["enable-crash-reporter"]===void 0){const Ye=(0,Re.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ye},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],it=Te.substring(0,Te.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(it))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(fe,pe){try{return await(0,T.resolveShellEnv)(this.logService,fe,pe)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,P.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,pe){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(H.IDialogMainService);let we=!1;const Me=async De=>{if(we)return;we=!0;const Te=await w.contentTracing.stopRecording((0,y.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Te}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,l.localize)(4,null),detail:(0,l.localize)(5,null,Te),buttons:[(0,I.mnemonicButtonLabel)((0,l.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Me(!0),3e4);Promise.all(pe.map(De=>De.ready())).then(()=>{clearTimeout(Le),Me(!1)})}};dt=he([ie(2,K.IInstantiationService),ie(3,Q.ILogService),ie(4,G.IEnvironmentMainService),ie(5,J.ILifecycleMainService),ie(6,k.IConfigurationService),ie(7,Ee.IStateMainService),ie(8,_.IFileService),ie(9,re.IProductService)],dt),e.CodeApplication=dt}),define(Z[246],x([0,1,13,29,31,9,55,16,33,42,34,10,8,76,3,32,25,20,35,58,240,11,19,189,200,24,56,163,18,184,96,73,172,75,22,93,6,182,94,45,21,57,186,97,224,51,226,77,197,38,228,64,65,206]),function(j,e,w,L,D,M,P,E,h,g,i,I,S,p,t,d,y,v,b,u,o,c,n,a,s,r,l,f,m,k,R,A,F,H,te,se,G,ee,T,V,N,B,U,_,X,W,z,K,O,q,C,$,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Q{main(){try{this.startup()}catch(oe){console.error(oe.message),w.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[oe,re,ce,ge,de,Ee,Pe]=this.createServices();try{try{await this.initServices(ce,ge,de)}catch(Ie){throw this.handleStartupDataDirError(ce,Pe.nameLong,Ie),Ie}await oe.invokeFunction(async Ie=>{const ve=Ie.get(G.ILogService),ye=Ie.get(te.ILifecycleMainService),ke=Ie.get(m.IFileService),Fe=await this.claimInstance(ve,ce,ye,oe,Pe,!0);return v.Promises.writeFile(ce.mainLockfile,String(process.pid)).catch(Re=>{ve.warn(`Error writing main lockfile: ${Re.stack}`)}),Ee.logger=new T.SpdLogLogger("main",(0,S.join)(ce.logsPath,"main.log"),!0,Ee.getLevel()),(0,g.once)(ye.onWillShutdown)(Re=>{ke.dispose(),ge.dispose(),Re.join(v.Promises.unlink(ce.mainLockfile).catch(()=>{}))}),oe.createInstance(o.CodeApplication,Fe,re).startup()})}catch(Ie){oe.invokeFunction(this.quit,Ie)}}createServices(){const oe=new H.ServiceCollection,re={_serviceBrand:void 0,...V.default};oe.set(N.IProductService,re);const ce=new r.EnvironmentMainService(this.resolveArgs(),re),ge=this.patchEnvironment(ce);oe.set(r.IEnvironmentMainService,ce);const de=new se.BufferLogService,Ee=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(ce)),de]);process.once("exit",()=>Ee.dispose()),oe.set(G.ILogService,Ee);const Pe=new k.FileService(Ee);oe.set(m.IFileService,Pe);const Ie=new R.DiskFileSystemProvider(Ee);Pe.registerProvider(I.Schemas.file,Ie),oe.set(G.ILoggerService,new ee.LoggerService(Ee,Pe));const ve=new a.ConfigurationService(ce.settingsResource,Pe);oe.set(n.IConfigurationService,ve),oe.set(te.ILifecycleMainService,new A.SyncDescriptor(te.LifecycleMainService));const ye=new C.StateMainService(ce,Ee,Pe);return oe.set(q.IStateMainService,ye),oe.set(W.IRequestService,new A.SyncDescriptor(z.RequestMainService)),oe.set(J.IThemeMainService,new A.SyncDescriptor(J.ThemeMainService)),oe.set(K.ISignService,new A.SyncDescriptor(O.SignService)),oe.set(_.ITunnelService,new A.SyncDescriptor(X.TunnelService)),oe.set(B.IProtocolMainService,new A.SyncDescriptor(U.ProtocolMainService)),[new F.InstantiationService(oe,!0),ge,ce,ve,ye,de,re]}patchEnvironment(oe){const re={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ce=>{const ge=process.env[ce];typeof ge=="string"&&(re[ce]=ge)}),Object.assign(process.env,re),re}initServices(oe,re,ce){return M.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(ge=>ge?v.Promises.mkdir(ge,{recursive:!0}):void 0)),re.initialize(),ce.init()])}async claimInstance(oe,re,ce,ge,de,Ee){let Pe;try{(0,p.mark)("code/willStartMainServer"),Pe=await(0,u.serve)(re.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,g.once)(ce.onWillShutdown)(()=>Pe.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(re,de.nameLong,Ie),Ie;let ve;try{ve=await(0,u.connect)(re.mainIPCHandle,"main")}catch(Fe){if(!Ee||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,de.nameShort),(0,c.localize)(1,null),de.nameLong),Fe;try{(0,L.unlinkSync)(re.mainIPCHandle)}catch(Re){throw oe.warn("Could not delete obsolete instance handle",Re),Re}return this.claimInstance(oe,re,ce,ge,de,!1)}if(re.extensionTestsLocationURI&&!re.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Fe),ve.dispose(),new Error(Fe)}let ye;!re.args.wait&&!re.args.status&&(ye=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,de.nameShort),(0,c.localize)(3,null),de.nameLong)},1e4));const ke=b.ProxyChannel.toService(ve.getChannel("launch"),{disableMarshalling:!0});if(re.args.status)return ge.invokeFunction(async()=>{const Fe=new s.DiagnosticsService($.NullTelemetryService,de),Re=await ke.getMainProcessInfo(),Ve=await ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),et=await Fe.getDiagnostics(Re,Ve);throw console.log(et),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(ke,oe),oe.trace("Sending env to running instance..."),await ke.start(re.args,process.env),ve.dispose(),ye&&clearTimeout(ye),new E.ExpectedError("Sent env to running instance. Terminating...")}if(re.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}handleStartupDataDirError(oe,re,ce){if(ce.code==="EACCES"||ce.code==="EPERM"){const ge=(0,D.coalesce)([oe.userDataPath,oe.extensionsPath,u.XDG_RUNTIME_DIR]).map(de=>(0,i.getPathLabel)(de,oe));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,P.toErrorMessage)(ce),ge.join(`
`)),re)}}showStartupWarningDialog(oe,re,ce){w.dialog.showMessageBoxSync({title:ce,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,c.localize)(6,null))],message:oe,detail:re,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,re){if(t.isWindows){const ce=await oe.getMainProcessId();re.trace("Sending some foreground love to the running instance:",ce);try{(await new Promise((ge,de)=>{j(["windows-foreground-love"],ge,de)})).allowSetForegroundWindow(ce)}catch(ge){re.error(ge)}}}quit(oe,re){const ce=oe.get(G.ILogService),ge=oe.get(te.ILifecycleMainService);let de=0;re&&(re.isExpected?re.message&&ce.trace(re.message):(de=1,re.stack?ce.error(re.stack):ce.error(`Startup error: ${re.toString()}`))),ge.kill(de)}resolveArgs(){const oe=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const re=(0,f.createWaitMarkerFile)(oe.verbose);re&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",re),oe.waitMarkerFilePath=re)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const re=this.doValidatePaths(oe._,oe.goto);oe._=re}return oe}doValidatePaths(oe,re){const ce=(0,d.cwd)(),ge=oe.map(Pe=>{let Ie=String(Pe),ve;re&&(ve=(0,h.parseLineAndColumnAware)(Ie),Ie=ve.path),Ie&&(Ie=this.preparePath(ce,Ie));const ye=(0,h.sanitizeFilePath)(Ie,ce),ke=(0,S.basename)(ye);return ke&&!(0,h.isValidBasename)(ke)?null:re&&ve?(ve.path=ye,this.toPath(ve)):ye}),de=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(ge,Pe=>Pe&&de?Pe.toLowerCase():Pe||"");return(0,D.coalesce)(Ee)}preparePath(oe,re){return t.isWindows&&(re=(0,y.rtrim)(re,'"')),re=(0,y.trim)((0,y.trim)(re," "),"	"),t.isWindows&&(re=(0,S.resolve)(oe,re),re=(0,y.rtrim)(re,".")),re}toPath(oe){const re=[oe.path];return typeof oe.line=="number"&&re.push(String(oe.line)),typeof oe.column=="number"&&re.push(String(oe.column)),re.join(":")}}new Q().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bcb9df5afa52c5b713f62e86dcac2c5050504b5f/core/vs/code/electron-main/main.js.map
